The notes in this file concern the floating-point precision
that users should adopt when using the plplot module.

Support for kind=plflt for those who just want to adopt in their own
code the same Fortran floating-point precision as in our C libraries
is supplied by the plplot module, but use of plflt is not necessary.
Instead, users are encouraged to use either kind(1.0) or kind(1.0d0)
for the floating-point arguments in calls to PLplot routines, and our
new Fortran binding automatically does the appropriate conversions to
the floating-point precision of our C libraries using modern Fortran's
overloading mechanism.

N.B. In general, the Fortran examples in this subdirectory are the
best source of documentation for users, but a strong exception to this
rule is our wide-spread use of pl_test_flt in these examples.  That
parameter is made available by the plplot module as a convenience to
our Fortran developers to test that either kind(1.0) or kind(1.0d0)
works well for our examples regardless of the floating-point precision
used by our C libraries.  But users are strongly discouraged from
using this test parameter for their own code because we make no
guarantees concerning its value, and instead they should make their
own decision about whether to adopt kind(1.0) or kind(1.0d0) for the
floating-point arguments for a given call to a PLplot routine.

Therefore, users should adapt these examples for their own use by
replacing pl_test_flt wherever it occurs with, e.g., my_float where
that parameter is defined by their code either as

integer, parameter :: my_float  = kind(1.0)

or

integer, parameter :: my_float  = kind(1.0d0)

depending on which of these two floating-point precisions is most
convenient for their own needs.

PLplot floating-point precision caveats

For those rare cases where the actual floating-point precision cannot
be automatically specified by the user via the precision of the
floating-point arguments which are used for a call to a subroutine or
function, then the only choice we supply is the double precision
(kind(1.0d0)) one regardless of the underlying precision of the C
plplot library.

The instances of this issue are the floating-point return value of the
function plrandd, floating-point elements of the defined type
PLGraphicsIn, floating-point arguments of Fortran callback functions
that are used as arguments for plstransform and pllabelfunc, and the
pre-defined floating-point parameters PL_NOTSET, PL_PI, and PL_TWOPI.
See the examples in this directory for how these
cases are handled when pl_test_flt (to be replaced by my_float,
see above) is not the same as kind(1.0d0).

!    Generates polar plot with, 1-1 scaling
!
!    Copyright (C) 2004-2016 Alan W. Irwin
!
!    This file is part of PLplot.
!
!    PLplot is free software; you can redistribute it and/or modify
!    it under the terms of the GNU Library General Public License as
!    published by the Free Software Foundation; either version 2 of the
!    License, or (at your option) any later version.
!
!    PLplot is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Library General Public License for more details.
!
!    You should have received a copy of the GNU Library General Public
!    License along with PLplot; if not, write to the Free Software
!    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x03f
    use plplot, double_PI => PL_PI
    use plfortrandemolib
    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    character (len=3) :: text
    real(kind=pl_test_flt), dimension(0:360) :: x0, y0, x, y
    real(kind=pl_test_flt) :: dtr, theta, dx, dy, offset
    integer :: i
    integer :: plparseopts_rc
    !    Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !   Set orientation to portrait - note not all device drivers
    !   support this, in particular most interactive drivers do not.
    call plsori(1)

    dtr = PI/180.0_pl_test_flt
    x0 = cos(dtr * arange(361))
    y0 = sin(dtr * arange(361))

    !    Initialize PLplot

    call plinit()

    !    Set up viewport and window, but do not draw box

    call plenv(-1.3_pl_test_flt, 1.3_pl_test_flt, -1.3_pl_test_flt, 1.3_pl_test_flt, 1, -2)
    !   Draw circles for polar grid
    do i = 1,10
        call plarc(0.0_pl_test_flt, 0.0_pl_test_flt, 0.1_pl_test_flt*i, 0.1_pl_test_flt*i, &
               0.0_pl_test_flt, 360.0_pl_test_flt, 0.0_pl_test_flt, .false.)
    enddo
    call plcol0(2)
    do i = 0,11
        theta = 30.0_pl_test_flt*i
        dx = cos(dtr*theta)
        dy = sin(dtr*theta)

        !      Draw radial spokes for polar grid

        call pljoin(0.0_pl_test_flt, 0.0_pl_test_flt, dx, dy)
        write (text,'(i3)') nint(theta)

        !      Write labels for angle

        text = adjustl(text)

        if (theta .lt. 9.99) then
            offset = 0.45
        elseif (theta .lt. 99.9) then
            offset = 0.30
        else
            offset = 0.15
        endif
        !      Slightly off zero to avoid floating point logic flips at
        !      90 and 270 deg.
        if (dx >= -0.00001_pl_test_flt) then
            call plptex(dx, dy, dx, dy, -offset, text)
        else
            call plptex(dx, dy, -dx, -dy, 1._pl_test_flt+offset, text)
        end if
    enddo
    !    Draw the graph

    x = x0 * sin(5.0_pl_test_flt * dtr * arange(361))
    y = y0 * sin(5.0_pl_test_flt * dtr * arange(361))

    call plcol0(3)
    call plline(x,y)

    call plcol0(4)
    call plmtex('t', 2.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
           '#frPLplot Example 3 - r(#gh)=sin 5#gh')

    !    Close the plot at end

    call plend
end program x03f

!   Displays the plotter symbols for PLPOIN
!
!   Copyright (C) 2004-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x06f
    use plplot
    implicit none
    integer :: i, j, k, font, kind_font, maxfont
    integer :: plparseopts_rc
    real(kind=pl_test_flt), dimension(1:1) :: x, y

    character (len=3) :: text

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !   Full sized page for display
    call plinit()

    do kind_font = 1,2
        call plfontld(kind_font-1)
        maxfont = merge( 1, 4, kind_font==1 )

        do font=1,maxfont
            call plfont(font)

            call pladv(0)

            call plcol0(2)

            !           Set up viewport and window

            call plvpor(0.1_pl_test_flt, 1.0_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
            call plwind(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.3_pl_test_flt)

            !           Draw the grid using plbox

            call plbox('bcg', 0.1_pl_test_flt, 0, 'bcg', 0.1_pl_test_flt, 0)
            call plcol0(15)

            !           Write the digits below the frame

            do i=0,9
                write (text,'(i1)') i
                call plmtex('b', 1.5_pl_test_flt, (0.1_pl_test_flt*i+0.05_pl_test_flt), 0.5_pl_test_flt, text)
            enddo

            k=0
            do i=0,12

                !               Write the digits to the left of the frame

                write (text,'(i0)') 10*i

                call plmtex('lv', 1.0_pl_test_flt, (1.0_pl_test_flt-(2*i+1)/26.0_pl_test_flt), &
                       1.0_pl_test_flt, text)

                do j=0,9
                    x=0.1_pl_test_flt*j+0.05_pl_test_flt
                    y=1.25_pl_test_flt-0.1_pl_test_flt*i

                    !                   Display the symbols
                    if (k < 128) call plpoin(x,y,k)

                    k=k+1

                enddo
            enddo

            if (kind_font==1) then
                call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                       'PLplot Example 6 - plpoin symbols (compact)')
            else
                call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                       'PLplot Example 6 - plpoin symbols (extended)')
            endif
        enddo
    enddo

    call plend
end program x06f

!      Demonstration of plshade plotting
!      Reduce colors in cmap 0 so that cmap 1 is useful on a 16-color display
!
!      Copyright (C) 2004-2016  Alan W. Irwin
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x16af
    use plplot
    implicit none
    integer :: plparseopts_rc

    !      Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plscmap0n(3)

    !      Initialize plplot

    call plinit()

    !      Rectangular coordinate plot

    call rect()

    !      Polar coordinate plot

    call polar()

    call plend

contains

    !      Plot function using the identity transform

    subroutine rect()

        use plplot
        implicit none
        integer   xdim, ydim, NX, NY, NCONTR
        !      xdim and ydim are the static dimensions of the 2D arrays while
        !      NX and NY are the defined area.
        parameter (xdim = 99, NX = 35, ydim = 100, NY = 46, NCONTR = 14)

        real(kind=pl_test_flt)    z(xdim, ydim)
        real(kind=pl_test_flt)    zmin, zmax, x, y
        real(kind=pl_test_flt)    shade_min, shade_max, sh_color
        integer   i, j, sh_cmap
        integer   min_color, max_color
        real(kind=pl_test_flt)    sh_width, min_width, max_width

        !      Set up for plshade call

        sh_cmap   = 1
        min_color = 1
        min_width = 0
        max_color = 0
        max_width = 0

        !      Set up data arrays

        do i = 1, NX
            x = (i - 1 - (NX/2)) / real(NX/2,kind=pl_test_flt)
            do j = 1, NY
                y = (j - 1 - (NY/2)) / real(NY/2,kind=pl_test_flt) - 1.0_pl_test_flt
                z(i,j) = x*x - y*y + (x - y) / (x*x + y*y + 0.1_pl_test_flt)
            enddo
        enddo

        call a2mnmx(z, NX, NY, zmin, zmax, xdim)

        !      Plot using identity transform

        call pladv(0)
        call plvpor(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
        call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt)

        do i = 1, NCONTR
            shade_min = zmin + (zmax - zmin) * real(i - 1,kind=pl_test_flt) / &
                   real(NCONTR,kind=pl_test_flt)
            shade_max = zmin + (zmax - zmin) * real(i,kind=pl_test_flt)     / &
                   real(NCONTR,kind=pl_test_flt)
            sh_color = real(i - 1,kind=pl_test_flt) / real(NCONTR - 1,kind=pl_test_flt)
            sh_width = 2
            call plpsty(0)
            call plshade(z(:NX,:NY), &
                   -1._pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, &
                   shade_min, shade_max, &
                   sh_cmap, sh_color, sh_width, &
                   min_color, min_width, max_color, max_width, .true. )
        enddo

        call plcol0(1)
        call plbox('bcnst', 0.0_pl_test_flt, 0, 'bcnstv', 0.0_pl_test_flt, 0)
        call plcol0(2)
        call pllab('distance', 'altitude', 'Bogon flux')

    end subroutine rect

    !      Routine for demonstrating use_ of transformation arrays in contour plots.

    subroutine polar()

        use plplot, double_TWOPI => PL_TWOPI
        implicit none
        real(kind=pl_test_flt), parameter :: TWOPI = double_TWOPI
        integer   xdim, ydim, NX, NY, NCONTR, NBDRY
        !      xdim and ydim are the static dimensions of the 2D arrays while
        !      NX and NY are the defined area.
        parameter (xdim = 99, NX = 40, ydim = 100, NY = 64)
        parameter (NCONTR = 14, NBDRY=200)

        real(kind=pl_test_flt)    z(xdim, ydim)
        real(kind=pl_test_flt)    xg(xdim, ydim+1), yg(xdim, ydim+1), &
               xtm(NBDRY), ytm(NBDRY)
        real(kind=pl_test_flt)    xmin, xmax, ymin, ymax, zmin, zmax
        real(kind=pl_test_flt)    xpmin, xpmax, ypmin, ypmax
        real(kind=pl_test_flt)    r, theta, rmax, x0, y0
        real(kind=pl_test_flt)    eps, q1, d1, q1i, d1i, q2, d2, q2i, d2i
        real(kind=pl_test_flt)    div1, div1i, div2, div2i

        real(kind=pl_test_flt)    shade_min, shade_max, sh_color
        real(kind=pl_test_flt)    xtick, ytick
        integer   nxsub, nysub
        integer   ncolbox, ncollab
        integer   i, j
        integer   sh_cmap
        integer   min_color, max_color
        real(kind=pl_test_flt) sh_width, min_width, max_width
        character(len=8) xopt, yopt

        !      Set up for plshade call

        sh_cmap = 1
        min_color = 1
        min_width = 0
        max_color = 0
        max_width = 0

        !      Set up r-theta grids
        !      Tack on extra cell in theta to handle periodicity.

        do i = 1, NX
            r = i - 0.5_pl_test_flt
            do j = 1, NY
                theta = TWOPI/real(NY,kind=pl_test_flt) * (j-0.5_pl_test_flt)
                xg(i,j) = r * cos(theta)
                yg(i,j) = r * sin(theta)
            enddo
            xg(i, NY+1) = xg(i, 1)
            yg(i, NY+1) = yg(i, 1)
        enddo
        call a2mnmx(xg, NX, NY, xmin, xmax, xdim)
        call a2mnmx(yg, NX, NY, ymin, ymax, xdim)

        rmax = r
        x0 = (xmin + xmax)/2._pl_test_flt
        y0 = (ymin + ymax)/2._pl_test_flt

        !      Potential inside a conducting cylinder (or sphere) by method of images.
        !      Charge 1 is placed at (d1, d1), with image charge at (d2, d2).
        !      Charge 2 is placed at (d1, -d1), with image charge at (d2, -d2).
        !      Also put in smoothing term at small distances.

        eps = 2._pl_test_flt

        q1 = 1._pl_test_flt
        d1 = r/4._pl_test_flt

        q1i = - q1*r/d1
        d1i = r**2/d1

        q2 = -1._pl_test_flt
        d2 = r/4._pl_test_flt

        q2i = - q2*r/d2
        d2i = r**2/d2

        do i = 1, NX
            do j = 1, NY
                div1 = sqrt((xg(i,j)-d1)**2 + (yg(i,j)-d1)**2 + eps**2)
                div1i = sqrt((xg(i,j)-d1i)**2 + (yg(i,j)-d1i)**2 + eps**2)

                div2 = sqrt((xg(i,j)-d2)**2 + (yg(i,j)+d2)**2 + eps**2)
                div2i = sqrt((xg(i,j)-d2i)**2 + (yg(i,j)+d2i)**2 + eps**2)

                z(i,j) = q1/div1 + q1i/div1i + q2/div2 + q2i/div2i
            enddo
        enddo

        call a2mnmx(z, NX, NY, zmin, zmax, xdim)

        !      Advance graphics frame and get ready to plot.

        ncolbox = 1
        ncollab = 2

        call pladv(0)
        call plcol0(ncolbox)

        !      Scale window to user coordinates.
        !      Make a bit larger so the boundary does not get clipped.

        eps = 0.05_pl_test_flt
        xpmin = xmin - abs(xmin)*eps
        xpmax = xmax + abs(xmax)*eps
        ypmin = ymin - abs(ymin)*eps
        ypmax = ymax + abs(ymax)*eps

        call plvpas(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt, 1.0_pl_test_flt)
        call plwind(xpmin, xpmax, ypmin, ypmax)

        xopt = ' '
        yopt = ' '
        xtick = 0._pl_test_flt
        nxsub = 0
        ytick = 0._pl_test_flt
        nysub = 0

        call plbox(xopt, xtick, nxsub, yopt, ytick, nysub)

        !      Call plotter once for z < 0 (dashed), once for z > 0 (solid lines).

        do i = 1, NCONTR
            shade_min = zmin + (zmax - zmin) * real(i - 1,kind=pl_test_flt) / &
                   real(NCONTR,kind=pl_test_flt)
            shade_max = zmin + (zmax - zmin) * real(i,kind=pl_test_flt)     / &
                   real(NCONTR,kind=pl_test_flt)
            sh_color = real(i - 1,kind=pl_test_flt) / real(NCONTR - 1,kind=pl_test_flt)
            sh_width = 2
            call plpsty(0)

            call plshade(z(:NX,:NY), &
                   -1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, &
                   shade_min, shade_max, &
                   sh_cmap, sh_color, sh_width, &
                   min_color, min_width, max_color, max_width, &
                   .false., xg(:NX,:NY), yg(:NX,:NY) )
        enddo

        !      Draw boundary.

        do i = 1, NBDRY
            theta = (TWOPI)/(NBDRY-1) * real(i-1,kind=pl_test_flt)
            xtm(i) = x0 + rmax * cos(theta)
            ytm(i) = y0 + rmax * sin(theta)
        enddo
        call plcol0(ncolbox)
        call plline(xtm, ytm)

        call plcol0(ncollab)
        call pllab(' ', ' ', &
               'Shielded potential of charges in a conducting sphere')

    end subroutine polar

    !----------------------------------------------------------------------------
    !      Subroutine a2mnmx
    !      Minimum and the maximum elements of a 2-d array.

    subroutine a2mnmx(f, nx, ny, fmin, fmax, xdim)
        use plplot
        implicit none

        integer   i, j, nx, ny, xdim
        real(kind=pl_test_flt)    f(xdim, ny), fmin, fmax

        fmax = f(1, 1)
        fmin = fmax
        do j = 1, ny
            do  i = 1, nx
                fmax = max(fmax, f(i, j))
                fmin = min(fmin, f(i, j))
            enddo
        enddo
    end subroutine a2mnmx
end program x16af

!      Copyright (C) 2004-2016  Alan W. Irwin
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!--------------------------------------------------------------------------
! main
!
! Shows two views of the world map.
!--------------------------------------------------------------------------

program x19f
    use plplot, double_PI => PL_PI
    use iso_c_binding, only: c_ptr, c_loc, c_f_pointer
    implicit none
    real(kind=pl_test_flt), parameter :: PI = double_PI

    integer, parameter :: double = kind(1.0d0)

    real(kind=pl_test_flt)    minx, maxx, miny, maxy
    real(kind=pl_test_flt), dimension(1:1) :: x, y

    !     Variables for the shapelib example
    integer, parameter                 :: nbeachareas    = 2
    integer, dimension(nbeachareas)    :: beachareas     = (/ 23, 24 /)
    integer, parameter                 :: nwoodlandareas = 94
    integer, dimension(nwoodlandareas) :: woodlandareas
    integer, parameter                 :: nshingleareas  = 22
    integer, dimension(nshingleareas)  :: shingleareas = (/ 0, 1, 24, 25, 26, 27, 28, 29, 30, 31, 32, &
           33, 34, 35, 217, 2424, 2425, 2426, 2427,  &
           2428, 2491, 2577 /)
    integer, parameter                 :: ncragareas     = 2024
    integer, dimension(ncragareas)     :: cragareas
    integer, dimension(9)              :: majorroads     = (/ 33, 48, 71, 83, 89, 90, 101, 102, 111 /)
    integer                            :: i
    integer :: plparseopts_rc
    type label_data_type
        character(len=2), dimension(-1:1,2) :: label_data
    end type label_data_type

    ! Whether to use no_label_data type of callback.
    logical, parameter :: ifno_label_data = .false.

    type(label_data_type), target :: label_data

    !      Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    ! Longitude (x) and latitude (y)

    miny = -70._pl_test_flt
    maxy = 80._pl_test_flt

    call plinit()

    ! Cartesian plots
    ! Most of world

    minx = -170._pl_test_flt
    maxx = minx+360._pl_test_flt

    ! Setup a custom latitude and longitude-based scaling function.
    if(ifno_label_data) then
        call plslabelfunc(geolocation_labeler)
    else
        label_data%label_data(-1,1) = " W"
        label_data%label_data(0,1) = ""
        label_data%label_data(1,1) = " E"
        label_data%label_data(-1,2) = " S"
        label_data%label_data(0,2) = "Eq"
        label_data%label_data(1,2) = " N"
        call plslabelfunc(geolocation_labeler_data, c_loc(label_data))
    endif

    call plcol0(1)
    call plenv(minx, maxx, miny, maxy, 1, 70)

    call plmap('usaglobe', minx, maxx, miny, maxy)

    ! The Americas

    minx = 190._pl_test_flt
    maxx = 340._pl_test_flt

    call plcol0(1)
    call plenv(minx, maxx, miny, maxy, 1, 70)
    call plmap('usaglobe', minx, maxx, miny, maxy)

    ! Clear the labeling function
    call plslabelfunc

    ! Polar, Northern hemisphere

    minx = 0._pl_test_flt
    maxx = 360._pl_test_flt

    call plenv(-75._pl_test_flt, 75._pl_test_flt, -75._pl_test_flt, &
           75._pl_test_flt, 1, -1)
    call plmap(mapform19, 'globe', minx, maxx, miny, maxy)

    call pllsty(2)
    call plmeridians(mapform19,10.0_pl_test_flt, 10.0_pl_test_flt, &
           0.0_pl_test_flt, 360.0_pl_test_flt, -10.0_pl_test_flt, &
           80.0_pl_test_flt)

    ! Polar, Northern hemisphere, this time with a PLplot-wide transform

    minx = 0._pl_test_flt
    maxx = 360._pl_test_flt

    call plstransform( map_transform )

    call pllsty( 1 )
    call plenv( -75._pl_test_flt, 75._pl_test_flt, -75._pl_test_flt, &
           75._pl_test_flt, 1, -1 )
    ! No need to set the map transform here as the global
    ! transform will be used.
    call plmap('globe', minx, maxx, miny, maxy )

    call pllsty( 2 )
    call plmeridians(10.0_pl_test_flt, 10.0_pl_test_flt, &
           0.0_pl_test_flt, 360.0_pl_test_flt, -10.0_pl_test_flt, &
           80.0_pl_test_flt )

    ! Show Baltimore, MD on the map
    call plcol0( 2 )
    call plssym( 0.0_pl_test_flt, 2.0_pl_test_flt )
    x=-76.6125_pl_test_flt
    y=39.2902778_pl_test_flt
    call plpoin( x, y, 18 )
    call plssym( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plptex( -76.6125_pl_test_flt, 43.0_pl_test_flt, 0.0_pl_test_flt, &
           0.0_pl_test_flt, 0.0_pl_test_flt, 'Baltimore, MD' )

    ! For Fortran, this is how the global transform is cleared.
    call plstransform

    ! An example using shapefiles. The shapefiles used are from Ordnance Survey, UK.
    ! These were chosen because they provide shapefiles for small grid boxes which
    ! are easilly manageable for this demo.

    call pllsty( 1 )

    minx = 240570._pl_test_flt
    maxx = 621109._pl_test_flt
    miny = 87822._pl_test_flt
    maxy = 722770._pl_test_flt
    call plscol0( 0, 255, 255, 255 )
    call plscol0( 1, 0, 0, 0 )
    call plscol0( 2, 150, 150, 150 )
    call plscol0( 3, 0, 50, 200 )
    call plscol0( 4, 50, 50, 50 )
    call plscol0( 5, 150, 0, 0 )
    call plscol0( 6, 100, 100, 255 )

    minx = 265000._pl_test_flt
    maxx = 270000._pl_test_flt
    miny = 145000._pl_test_flt
    maxy = 150000._pl_test_flt
    call plscol0( 0, 255, 255, 255 )  !white
    call plscol0( 1, 0, 0, 0 )        !black
    call plscol0( 2, 255, 200, 0 )    !yelow for sand
    call plscol0( 3, 60, 230, 60 )    !green for woodland
    call plscol0( 4, 210, 120, 60 )   !brown for contours
    call plscol0( 5, 150, 0, 0 )      !red for major roads
    call plscol0( 6, 180, 180, 255 )  !pale blue for water
    call plscol0( 7, 100, 100, 100 )  !pale grey for shingle or boulders
    call plscol0( 8, 100, 100, 100 )  !dark grey for custom polygons - generally crags


    call plcol0( 1 )
    call plenv( minx, maxx, miny, maxy, 1, -1 )
    call pllab( "", "", "Martinhoe CP, Exmoor National Park, UK (shapelib only)" )


    ! Beach
    call plcol0( 2 )
    call plmapfill( "ss/ss64ne_Landform_Area", minx, maxx, miny, maxy, beachareas )

    ! Woodland
    call plcol0( 3 )
    do i = 1, nwoodlandareas
        woodlandareas(i) = i + 217
    enddo
    call plmapfill( "ss/ss64ne_Landform_Area", minx, maxx, miny, maxy, woodlandareas )

    ! Shingle or boulders
    call plcol0( 7 )
    call plmapfill( "ss/ss64ne_Landform_Area", minx, maxx, miny, maxy, shingleareas )

    ! Crags
    call plcol0( 8 )
    do i = 1, ncragareas
        cragareas(i) = i + 324
    enddo
    call plmapfill( "ss/ss64ne_Landform_Area", minx, maxx, miny, maxy, cragareas )

    ! draw contours, we need to separate contours from high/low coastline
    ! draw_contours(pls, "ss/SS64_line", 433, 20, 4, 3, minx, maxx, miny, maxy );
    call plcol0( 4 )
    call plmapline( "ss/ss64ne_Height_Contours", minx, maxx, miny, maxy )

    ! draw the sea and surface water
    call plwidth( 0.0_pl_test_flt )
    call plcol0( 6 )
    call plmapfill( "ss/ss64ne_Water_Area", minx, maxx, miny, maxy )
    call plwidth( 2.0_pl_test_flt )
    call plmapline( "ss/ss64ne_Water_Line", minx, maxx, miny, maxy )

    ! draw the roads, first with black and then thinner with colour to give an
    ! an outlined appearance
    call plwidth( 5.0_pl_test_flt )
    call plcol0( 1 )
    call plmapline( "ss/ss64ne_Road_Centreline", minx, maxx, miny, maxy )
    call plwidth( 3.0_pl_test_flt )
    call plcol0( 0 )
    call plmapline( "ss/ss64ne_Road_Centreline", minx, maxx, miny, maxy )
    call plcol0( 5 )
    call plmapline( "ss/ss64ne_Road_Centreline", minx, maxx, miny, maxy, majorroads )

    ! draw buildings
    call plwidth( 1.0_pl_test_flt )
    call plcol0( 1 )
    call plmapfill( "ss/ss64ne_Building_Area", minx, maxx, miny, maxy )

    ! labels
    call plsfci( int(z'00000100') )
    call plschr( 0._pl_test_flt, 0.8_pl_test_flt )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "MARTINHOE CP", minx, maxx, miny, maxy, 202 )
    call plschr( 0._pl_test_flt, 0.7_pl_test_flt );
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "Heale"//achar(10)//"Down", minx, maxx, miny, maxy, 13 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "South"//achar(10)//"Down", minx, maxx, miny, maxy, 34 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "Martinhoe"//achar(10)//"Common", minx, maxx, miny, maxy, 42 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "Woody Bay", minx, maxx, miny, maxy, 211 )
    call plschr( 0._pl_test_flt, 0.6_pl_test_flt );
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "Mill Wood", minx, maxx, miny, maxy, 16 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "Heale Wood", minx, maxx, miny, maxy, 17 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt, &
           "Bodley", minx, maxx, miny, maxy, 31 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.0_pl_test_flt, &
           "Martinhoe", minx, maxx, miny, maxy, 37 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "Woolhanger"//achar(10)//"Common", minx, maxx, miny, maxy, 60 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "West Ilkerton"//achar(10)//"Common", minx, maxx, miny, maxy, 61 )
    call plmaptex( "ss/ss64ne_General_Text", 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, &
           "Caffyns"//achar(10)//"Heanton"//achar(10)//"Down", minx, maxx, miny, maxy, 62 )

    call plend()

contains

    subroutine map_transform(x, y, xt, yt)

        ! These callback arguments must have exactly these attributes
        ! because of disambiguation issues.
        real(kind=double), intent(in) :: x, y
        real(kind=double), intent(out) :: xt, yt

        real(kind=pl_test_flt) :: radius

        radius = 90.0_pl_test_flt - y
        xt = radius * cos(x * PI / 180.0_pl_test_flt)
        yt = radius * sin(x * PI / 180.0_pl_test_flt)
    end subroutine map_transform
    !--------------------------------------------------------------------------
    ! mapform19
    !
    ! Defines specific coordinate transformation for example 19.
    ! Not to be confused with mapform in src/plmap.c.
    ! x(), y() are the coordinates to be plotted.
    !--------------------------------------------------------------------------

    subroutine mapform19(x, y)

        real(kind=pl_test_flt), dimension(:), intent(inout) :: x, y

        real(kind=pl_test_flt), dimension(:), allocatable :: radius

        ! evaluate x last so RHS's do not get overwritten too soon
        allocate( radius(size(x)) )

        radius = 90.0_pl_test_flt - y
        y = radius*sin(x*PI/180.0_pl_test_flt)
        x = radius*cos(x*PI/180.0_pl_test_flt)
    end subroutine mapform19

    ! A custom axis labeling callback function for longitudes and latitudes.
    subroutine geolocation_labeler(axis, value, label)
        integer, intent(in) :: axis
        ! These callback arguments must have exactly these attributes
        ! because of disambiguation issues.
        real(kind=double), intent(in) :: value
        character(len=*), intent(out) :: label

        type(label_data_type), target :: data

        data%label_data(-1,1) = " W"
        data%label_data(0,1) = ""
        data%label_data(1,1) = " E"
        data%label_data(-1,2) = " S"
        data%label_data(0,2) = "Eq"
        data%label_data(1,2) = " N"
        call custom_labeler(axis, real(value,kind=pl_test_flt), label, c_loc(data))
    end subroutine geolocation_labeler

    ! Another custom axis labeling callback function for longitudes and latitudes.
    subroutine geolocation_labeler_data(axis, value, label, data)
        integer, intent(in) :: axis
        ! These callback arguments must have exactly these attributes
        ! because of disambiguation issues.
        real(kind=double), intent(in) :: value
        character(len=*), intent(out) :: label

        type(c_ptr), intent(in) :: data

        call custom_labeler(axis, real(value,kind=pl_test_flt), label, data)
    end subroutine geolocation_labeler_data

    ! This routine called by two different callbacks.
    subroutine custom_labeler(axis, value, label, data)
        integer, intent(in) :: axis
        real(kind=pl_test_flt), intent(in) :: value
        character(len=*), intent(out) :: label
        type(c_ptr), intent(in) :: data

        type(label_data_type), pointer :: d
        character(len=5) direction_label
        real(kind=pl_test_flt) :: label_val

        call c_f_pointer(data, d)
        label_val = 0.0_pl_test_flt

        if (axis .eq. 2) then
            label_val = value
            if (label_val .gt. 0.0_pl_test_flt) then
                direction_label = d%label_data(1,axis)
            else if (label_val .lt. 0.0_pl_test_flt) then
                direction_label = d%label_data(-1,axis)
            else
                direction_label = d%label_data(0,axis)
            endif
        else if (axis .eq. 1) then
            label_val = normalize_longitude(value)
            if (label_val .gt. 0.0_pl_test_flt) then
                direction_label = d%label_data(1,axis)
            else if (label_val .lt. 0.0_pl_test_flt) then
                direction_label = d%label_data(-1,axis)
            else
                direction_label = d%label_data(0,axis)
            endif
        endif
        if (axis .eq. 2 .and. value .eq. 0.0_pl_test_flt) then
            !     A special case for the equator
            label = direction_label
        else if (abs(label_val) .lt. 10.0_pl_test_flt) then
            write(label,'(I1.1,A2)') iabs(int(label_val)),direction_label
        else if (abs(label_val) .lt. 100.0_pl_test_flt) then
            write(label,'(I2.1,A2)') iabs(int(label_val)),direction_label
        else
            write(label,'(I3.1,A2)') iabs(int(label_val)),direction_label
        endif
    end subroutine custom_labeler

    !     "Normalize" longitude values so that they always fall between
    !      -180.0 and 180.0
    function normalize_longitude(lon)
        real(kind=pl_test_flt) :: normalize_longitude
        real(kind=pl_test_flt) :: lon, times

        if ((lon .ge. -180.0_pl_test_flt) .and. (lon .le. 180.0_pl_test_flt)) then
            normalize_longitude = lon
        else
            times = floor ((abs(lon) + 180.0_pl_test_flt) / 360.0_pl_test_flt)
            if (lon .lt. 0.0_pl_test_flt) then
                normalize_longitude = lon + 360.0_pl_test_flt * times
            else
                normalize_longitude = lon - 360.0_pl_test_flt * times
            endif
        endif
    end function normalize_longitude
end program x19f

!   Demonstrates multiple windows and color map 0
!
!   Copyright (C) 2004-2016  Alan W. Irwin
!   Copyright (C) 2005  Andrew Ross
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x02f
    use plplot
    implicit none
    integer :: plparseopts_rc

    !    Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"


    !   Initialize plplot
    call plinit()

    !   Run demos
    call demo1
    call demo2

    call plend

contains

    !--------------------------------------------------------------------------
    !     demo1
    !
    !     Demonstrates multiple windows and default color map 0 palette.
    !--------------------------------------------------------------------------
    subroutine demo1

        call plbop

        !   Divide screen into 16 regions
        call plssub(4,4)

        call draw_windows(16, 0)

        call pleop

    end subroutine demo1


    !--------------------------------------------------------------------------
    !     demo2
    !
    !     Demonstrates multiple windows, user-modified color map 0 palette,
    !     and HLS -> RGB translation.
    !--------------------------------------------------------------------------
    subroutine demo2
        integer, parameter :: tablesize = 116
        integer, dimension(tablesize) :: r, g, b
        integer :: i

        real(kind=pl_test_flt), parameter :: lmin = 0.15_pl_test_flt, lmax = 0.85_pl_test_flt
        real(kind=pl_test_flt) h, l, s, r1, g1, b1

        call plbop

        !   Divide screen into 100 regions
        call plssub(10,10)

        do i=0,99
            !   Bounds on HLS, from plhlsrgb() commentary --
            !   hue		[0., 360.]	degrees
            !   lightness	        [0., 1.]	magnitude
            !   saturation	[0., 1.]	magnitude

            !   Vary hue uniformly from left to right
            h = (360._pl_test_flt/10._pl_test_flt)*mod(i,10)
            !   Vary lightness uniformly from top to bottom, between min and max
            l = lmin + (lmax - lmin) * (i / 10) / 9._pl_test_flt
            !   Use_ max saturation
            s = 1._pl_test_flt

            call plhlsrgb(h, l, s, r1, g1, b1)

            r(i+17) = int(r1*255.001)
            g(i+17) = int(g1*255.001)
            b(i+17) = int(b1*255.001)
        enddo

        do i=1,16
            call plgcol0(i-1,r(i),g(i),b(i))
        enddo

        call plscmap0(r, g, b)

        call draw_windows(100, 16)

        call pleop

    end subroutine demo2

    !--------------------------------------------------------------------------
    !     draw_windows
    !
    !     Draws a set of numbered boxes with colors according to cmap0 entry.
    !--------------------------------------------------------------------------
    subroutine draw_windows( nw, cmap0_offset )

        integer :: nw, cmap0_offset
        integer :: i,j
        real(kind=pl_test_flt) :: vmin, vmax, xj
        character (len=3) :: text

        call plschr(0.0_pl_test_flt, 3.5_pl_test_flt)
        call plfont(4)

        do i=0,nw-1
            call plcol0(i+cmap0_offset)
            write (text,'(i0)') i

            call pladv(0)
            vmin = 0.1_pl_test_flt
            vmax = 0.9_pl_test_flt
            do j=1,3
                xj = j
                call plwidth(xj)
                call plvpor(vmin,vmax,vmin,vmax)
                call plwind(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)
                call plbox('bc', 0.0_pl_test_flt, 0, 'bc', 0.0_pl_test_flt, 0)
                vmin = vmin + 0.1_pl_test_flt
                vmax = vmax - 0.1_pl_test_flt
            enddo
            call plwidth(1._pl_test_flt)
            call plptex(0.5_pl_test_flt, 0.5_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, text)
        enddo

    end subroutine draw_windows
end program x02f

!   Copyright (C) 2004-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!

!--------------------------------------------------------------------------
!      main program
!--------------------------------------------------------------------------

program x17f
    use plplot, double_PI => PL_PI
    implicit none
    real(kind=pl_test_flt), parameter :: PI = double_PI

    integer            :: id1, n
    integer, parameter :: nsteps = 1000
    logical            :: autoy, acc
    real(kind=pl_test_flt)   :: y1, y2, y3, y4, ymin, ymax, xlab, ylab
    real(kind=pl_test_flt)   :: t, tmin, tmax, tjump, dt, noise
    integer            :: colbox, collab, colline(4), styline(4)
    integer :: plparseopts_rc
    character(len=20)  :: legline(4)

    logical            :: pl_errcode
    character(len=80)  :: errmsg = 'PLplot error'

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !   plplot initialization

    !   If db is used the plot is much more smooth. However, because of the
    !   async X behaviour, one does not have a real-time scripcharter.
    !
    !   call plsetopt('db', '')
    !   call plsetopt('np', '')

    !   User sets up plot completely except for window and data
    !   Eventually settings in place when strip chart is created will be
    !   remembered so that multiple strip charts can be used simultaneously.


    !   Specify some reasonable defaults for ymin and ymax
    !   The plot will grow automatically if needed (but not shrink)

    ymin = -0.1_pl_test_flt
    ymax = 0.1_pl_test_flt

    !    Specify initial tmin and tmax -- this determines length of window.
    !    Also specify maximum jump in t
    !    This can accomodate adaptive timesteps

    tmin = 0._pl_test_flt
    tmax = 10._pl_test_flt
    !   percentage of plot to jump
    tjump = 0.3_pl_test_flt

    !   Axes options same as plbox.
    !   Only automatic tick generation and label placement allowed
    !   Eventually I'll make this fancier

    colbox = 1
    collab = 3
    !   pens color and line style
    styline = (/ 2, 3, 4, 5 /)
    colline = (/ 2, 3, 4, 5 /)

    !   pens legend
    legline = (/ 'sum    ', 'sin    ', 'sin*noi', 'sin+noi' /)

    !   legend position
    xlab = 0._pl_test_flt
    ylab = 0.25_pl_test_flt

    !   autoscale y
    autoy = .true.
    !   don't scrip, accumulate
    acc = .true.

    !   Initialize plplot

    call plinit()

    call pladv(0)
    call plvsta()

    !   Register our error variables with PLplot
    !   From here on, we're handling all errors here

    !   TODO: call plsError(&pl_errcode, errmsg)

    call plstripc(id1, 'bcnst', 'bcnstv', &
           tmin, tmax, tjump, ymin, ymax, &
           xlab, ylab, &
           autoy, acc, &
           colbox, collab, &
           colline, styline, legline, &
           't', '', 'Strip chart demo')

    pl_errcode = .false.
    if ( pl_errcode ) then
        write(*,*) errmsg
        stop
    endif

    !   Let plplot handle errors from here on

    !   TODO: call plsError(NULL, NULL)

    !   autoscale y
    autoy = .false.
    !   accumulate
    acc = .true.

    !   This is to represent a loop over time
    !   Let's try a random walk process

    y1 = 0.0_pl_test_flt
    y2 = 0.0_pl_test_flt
    y3 = 0.0_pl_test_flt
    y4 = 0.0_pl_test_flt
    dt = 0.1_pl_test_flt

    do n = 0,nsteps-1
        !       wait a little (10 ms) to simulate time elapsing.  gfortran
        !       sleep has resolution of 1 sec so the call below is commented
        !       out because it is like watching paint dry.  In any case, I
        !       like the resulting speedier output when you drop sleep
        !       altogether from this loop.
        !       call sleep(1)

        t = real(n,kind=pl_test_flt) * dt
        noise = plrandd() - 0.5_pl_test_flt
        y1 = y1 + noise
        y2 = sin(t*PI/18._pl_test_flt)
        y3 = y2 * noise
        y4 = y2 + noise/3._pl_test_flt

        !       There is no need for all pens to have the same number of
        !       points or beeing equally time spaced.

        if ( mod(n,2) .ne. 0 ) then
            call plstripa(id1, 0, t, y1)
        endif
        if ( mod(n,3) .ne. 0 ) then
            call plstripa(id1, 1, t, y2)
        endif
        if ( mod(n,4) .ne. 0 ) then
            call plstripa(id1, 2, t, y3)
        endif
        if ( mod(n,5) .ne. 0 ) then
            call plstripa(id1, 3, t, y4)
        endif
        !       use_ double buffer (-db on command line)
        !       call pleop()
    enddo

    !   Destroy strip chart and it's memory

    call plstripd(id1)
    call plend()
end program x17f

!   Mesh plot demo
!
!   Copyright (C) 2004-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x11f
    use plplot
    use plfortrandemolib
    implicit none

    integer, parameter :: xpts=35, ypts=46
    integer            :: i, j, k, ifshade

    real(kind=pl_test_flt)   :: x(xpts), y(ypts), z(xpts,ypts), xx, yy

    character(len=80)  :: title(2) = &
           (/ '#frPLplot Example 11 - Alt=33, Az=24, Opt=3 ', &
           '#frPLplot Example 11 - Alt=17, Az=115, Opt=3'  /)
    real(kind=pl_test_flt)   :: alt(2) = (/ 33.0_pl_test_flt,  17.0_pl_test_flt/)
    real(kind=pl_test_flt)   :: az(2)  = (/ 24.0_pl_test_flt, 115.0_pl_test_flt/)

    integer            :: opt(2) = (/ 3, 3 /)
    integer, parameter :: nlevel = 10
    integer :: plparseopts_rc
    real(kind=pl_test_flt)   :: zmin, zmax, step, clevel(nlevel)

    !    Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    x = 3._pl_test_flt * (arange(xpts) - (xpts/2)) / real(xpts/2,kind=pl_test_flt)
    y = 3._pl_test_flt * (arange(ypts) - (ypts/2)) / real(ypts/2,kind=pl_test_flt)

    do i=1,xpts
        xx = x(i)
        do j=1,ypts
            yy = y(j)
            z(i,j) = 3._pl_test_flt * (1._pl_test_flt-xx)*(1._pl_test_flt-xx) * &
                   exp(-(xx**2) - (yy+1._pl_test_flt)*(yy+1._pl_test_flt)) - &
                   10._pl_test_flt * (xx/5._pl_test_flt - xx**3 - yy**5) * exp(-xx**2-yy**2) - &
                   1._pl_test_flt/3._pl_test_flt * exp(-(xx+1._pl_test_flt)*(xx+1._pl_test_flt) - (yy**2))

        enddo
    enddo
    if (.false.) then
        !       Jungfraujoch/Interlaken
        z = max(z, -1._pl_test_flt)
    endif

    zmin = minval(z)
    zmax = maxval(z)

    step = (zmax-zmin)/(nlevel+1)
    clevel = zmin + step * arange(1,nlevel+1)

    call plinit()
    call cmap1_init(0)

    do k=1,2
        do ifshade = 0, 3
            call pladv(0)
            call plcol0(1)
            call plvpor(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 0.9_pl_test_flt )
            call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.5_pl_test_flt )
            call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.2_pl_test_flt, -3.0_pl_test_flt, &
                   3.0_pl_test_flt, -3.0_pl_test_flt, 3.0_pl_test_flt, zmin, zmax, alt(k),az(k))
            call plbox3('bnstu', 'x axis', 0.0_pl_test_flt, 0, &
                   'bnstu', 'y axis', 0.0_pl_test_flt, 0, &
                   'bcdmnstuv', 'z axis', 0.0_pl_test_flt, 0)
            call plcol0(2)

            select case (ifshade)
            case (0) ! wireframe plot
                call plmesh(x(:xpts), y(:ypts), z(:xpts,:ypts), opt(k))

            case (1) ! magnitude colored wireframe plot
                call plmesh(x(:xpts), y(:ypts), z(:xpts,:ypts), ior(opt(k), MAG_COLOR))

            case (2) ! magnitude colored wireframe plot with sides
                call plot3d(x(:xpts), y(:ypts), z(:xpts,:ypts), &
                       ior(opt(k), MAG_COLOR), .true.)

            case (3) ! magnitude colored wireframe plot with base contour
                call plmeshc(x(:xpts), y(:ypts), z(:xpts,:ypts), &
                       ior(opt(k), ior(MAG_COLOR, BASE_CONT)), clevel)

            case default
                stop 'x11f: bad logic'
            end select
            call plcol0(3)
            call plmtex('t', 1.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, title(k))
        enddo
    enddo
    call plend
contains

    !----------------------------------------------------------------------------
    subroutine cmap1_init(gray)
        !    For gray.eq.1, basic grayscale variation from half-dark
        !    to light.  Otherwise, hue variations around the front of the
        !    colour wheel from blue to green to red with constant lightness
        !    and saturation.

        integer gray
        real(kind=pl_test_flt) i(0:1), h(0:1), l(0:1), s(0:1)

        !   left boundary
        i(0) = 0._pl_test_flt
        !   right boundary
        i(1) = 1._pl_test_flt
        if (gray == 1) then
            !       hue -- low: red (arbitrary if s=0)
            h(0) = 0.0_pl_test_flt
            !       hue -- high: red (arbitrary if s=0)
            h(1) = 0.0_pl_test_flt
            !       lightness -- low: half-dark
            l(0) = 0.5_pl_test_flt
            !       lightness -- high: light
            l(1) = 1.0_pl_test_flt
            !       minimum saturation
            s(0) = 0.0_pl_test_flt
            !       minimum saturation
            s(1) = 0.0_pl_test_flt
        else
            !       This combination of hues ranges from blue to cyan to green to yellow
            !       to red (front of colour wheel) with constant lightness = 0.6
            !       and saturation = 0.8.

            !       hue -- low: blue
            h(0) = 240._pl_test_flt
            !       hue -- high: red
            h(1) = 0.0_pl_test_flt
            !       lightness -- low:
            l(0) = 0.6_pl_test_flt
            !       lightness -- high:
            l(1) = 0.6_pl_test_flt
            !       saturation
            s(0) = 0.8_pl_test_flt
            !       minimum saturation
            s(1) = 0.8_pl_test_flt
        endif
        call plscmap1n(256)
        call plscmap1l(.false., i, h, l, s)
    end subroutine cmap1_init

end program x11f

!   Simple demo of a 2D line plot.
!
!   Copyright (C) 2011-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as published
!   by the Free Software Foundation; either version 2 of the License, or
!   (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public License
!   along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x00f
    use plfortrandemolib

    integer, parameter :: NSIZE = 101

    real(kind=pl_test_flt), dimension(NSIZE) :: x, y

    real(kind=pl_test_flt) :: xmin = 0._pl_test_flt, xmax = 1._pl_test_flt, ymin = 0._pl_test_flt, ymax = 100._pl_test_flt
    ! integer          :: i
    integer :: plparseopts_rc

    ! Prepare data to be plotted.
    x = arange(NSIZE) / real(NSIZE-1,pl_test_flt)
    y = ymax * x**2

    ! Or alternatively, using a DO-loop
    !do i = 1,NSIZE
    !    x(i) = real( i - 1, pl_test_flt ) / real( NSIZE - 1, pl_test_flt )
    !    y(i) = ymax * x(i)**2
    !enddo

    ! Parse and process command line arguments
    plparseopts_rc = plparseopts( PL_PARSE_FULL )
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    ! Initialize plplot
    call plinit

    ! Create a labelled box to hold the plot.
    call plenv( xmin, xmax, ymin, ymax, 0, 0 )
    call pllab( "x", "y=100 x#u2#d", "Simple PLplot demo of a 2D line plot" )

    ! Plot the data that was prepared above.
    call plline( x, y )

    ! Close PLplot library
    call plend

end program x00f

!  Drawing "spirograph" curves - epitrochoids, cycolids, roulettes
!
!  Copyright (C) 2007  Arjen Markus
!  Copyright (C) 2008  Andrew Ross
!  Copyright (C) 2008-2016 Alan W. Irwin
!
! This file is part of PLplot.
!
! PLplot is free software; you can redistribute it and/or modify
! it under the terms of the GNU Library General Public License as published
! by the Free Software Foundation; either version 2 of the License, or
! (at your option) any later version.
!
! PLplot is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Library General Public License for more details.
!
! You should have received a copy of the GNU Library General Public License
! along with PLplot; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!

! --------------------------------------------------------------------------
! main
!
! Generates two kinds of plots:
!   - construction of a cycloid (animated)
!   - series of epitrochoids and hypotrochoids
! --------------------------------------------------------------------------

program x27f

    use plplot
    implicit none

    integer i, j, fill

    real(kind=pl_test_flt) params(4,9)

    ! R, r, p, N
    ! R and r should be integers to give correct termination of the
    integer :: plparseopts_rc
    ! angle loop using gcd.
    ! N.B. N is just a place holder since it is no longer used
    ! (because we now have proper termination of the angle loop).
    data ( ( params(i,j) ,i=1,4) ,j=1,9 ) / &
           21.0_pl_test_flt,  7.0_pl_test_flt,  7.0_pl_test_flt,  3.0_pl_test_flt, &
           21.0_pl_test_flt,  7.0_pl_test_flt, 10.0_pl_test_flt,  3.0_pl_test_flt, &
           21.0_pl_test_flt, -7.0_pl_test_flt, 10.0_pl_test_flt,  3.0_pl_test_flt, &
           20.0_pl_test_flt,  3.0_pl_test_flt,  7.0_pl_test_flt, 20.0_pl_test_flt, &
           20.0_pl_test_flt,  3.0_pl_test_flt, 10.0_pl_test_flt, 20.0_pl_test_flt, &
           20.0_pl_test_flt, -3.0_pl_test_flt, 10.0_pl_test_flt, 20.0_pl_test_flt, &
           20.0_pl_test_flt, 13.0_pl_test_flt,  7.0_pl_test_flt, 20.0_pl_test_flt, &
           20.0_pl_test_flt, 13.0_pl_test_flt, 20.0_pl_test_flt, 20.0_pl_test_flt, &
           20.0_pl_test_flt,-13.0_pl_test_flt, 20.0_pl_test_flt, 20.0_pl_test_flt/

    !  plplot initialization

    !  Parse and process command line arguments

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !  Initialize plplot

    call plinit()

    !  Illustrate the construction of a cycloid

    call cycloid()

    !  Loop over the various curves
    !  First an overview, then all curves one by one

    call plssub(3, 3)

    fill = 0
    do i = 1,9
        call pladv(0)
        call plvpor( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
        call spiro( params(1,i), fill )
    end do
    call pladv(0)
    call plssub(1, 1)

    do i = 1,9
        call pladv(0)
        call plvpor( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
        call spiro( params(1,i), fill )
    end do

    ! fill the curves.
    fill = 1
    call pladv(0)
    call plssub(1, 1)

    do i = 1,9
        call pladv(0)
        call plvpor( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
        call spiro( params(1,i), fill )
    end do

    ! Finally, an example to test out plarc capabilities
    call arcs()

    call plend()

contains

    ! --------------------------------------------------------------------------
    ! Calculate greatest common divisor following pseudo-code for the
    ! Euclidian algorithm at http://en.wikipedia.org/wiki/Euclidean_algorithm

    integer function gcd (a,  b)
        use plplot
        implicit none
        integer a, b, t
        a = abs(a)
        b = abs(b)
        do while ( b .ne. 0 )
            t = b
            b = mod (a, b)
            a = t
        enddo
        gcd = a
    end function gcd

    !  ===============================================================

    subroutine cycloid

        !     TODO

    end subroutine cycloid

    !  ===============================================================

    subroutine spiro( params, fill )

        use plplot, double_PI => PL_PI
        implicit none

        real(kind=pl_test_flt), parameter :: PI = double_PI
        real(kind=pl_test_flt)      params(*)
        integer     NPNT
        parameter ( NPNT = 2000 )
        integer     n
        real(kind=pl_test_flt)      xcoord(NPNT+1)
        real(kind=pl_test_flt)      ycoord(NPNT+1)

        integer     windings
        integer     steps
        integer     i
        integer     fill
        real(kind=pl_test_flt)      phi
        real(kind=pl_test_flt)      phiw
        real(kind=pl_test_flt)      dphi
        real(kind=pl_test_flt)      xmin
        real(kind=pl_test_flt)      xmax
        real(kind=pl_test_flt)      xrange_adjust
        real(kind=pl_test_flt)      ymin
        real(kind=pl_test_flt)      ymax
        real(kind=pl_test_flt)      yrange_adjust

        ! Fill the coordinates

        ! Proper termination of the angle loop very near the beginning
        ! point, see
        ! http://mathforum.org/mathimages/index.php/Hypotrochoid.
        windings = int(abs(params(2))/gcd(int(params(1)), int(params(2))))
        steps    = NPNT/windings
        dphi     = 2.0_pl_test_flt*PI/real(steps,kind=pl_test_flt)

        n = windings*steps+1

        ! Initialize variables to prevent compiler warnings
        xmin = 0.0
        xmax = 0.0
        ymin = 0.0
        ymax = 0.0

        do i = 1,n
            phi       = real(i-1,kind=pl_test_flt) * dphi
            phiw      = (params(1)-params(2))/params(2)*phi
            xcoord(i) = (params(1)-params(2))*cos(phi)+params(3)*cos(phiw)
            ycoord(i) = (params(1)-params(2))*sin(phi)-params(3)*sin(phiw)

            if (i.eq.1) then
                xmin = xcoord(1)
                xmax = xcoord(1)
                ymin = ycoord(1)
                ymax = ycoord(1)
            endif
            if ( xmin > xcoord(i) ) xmin = xcoord(i)
            if ( xmax < xcoord(i) ) xmax = xcoord(i)
            if ( ymin > ycoord(i) ) ymin = ycoord(i)
            if ( ymax < ycoord(i) ) ymax = ycoord(i)
        end do

        xrange_adjust = 0.15_pl_test_flt * (xmax - xmin)
        xmin = xmin - xrange_adjust
        xmax = xmax + xrange_adjust
        yrange_adjust = 0.15_pl_test_flt * (ymax - ymin)
        ymin = ymin - yrange_adjust
        ymax = ymax + yrange_adjust

        call plwind( xmin, xmax, ymin, ymax )

        call plcol0(1)
        if ( fill.eq.1) then
            call plfill(xcoord(1:n), ycoord(1:n) )
        else
            call plline(xcoord(1:n), ycoord(1:n) )
        endif

    end subroutine spiro

    !  ===============================================================

    subroutine arcs( )

        use plplot, double_PI => PL_PI
        implicit none

        real(kind=pl_test_flt), parameter :: PI = double_PI
        integer NSEG
        parameter ( NSEG = 8 )
        integer i;
        real (kind=pl_test_flt) theta, dtheta
        real (kind=pl_test_flt) a, b

        theta = 0.0_pl_test_flt
        dtheta = 360.0_pl_test_flt / real(NSEG,kind=pl_test_flt)
        call plenv( -10.0_pl_test_flt, 10.0_pl_test_flt, -10.0_pl_test_flt, 10.0_pl_test_flt, 1, 0 )

        ! Plot segments of circle in different colors
        do i = 0, NSEG-1
            call plcol0( mod(i,2) + 1 )
            call plarc(0.0_pl_test_flt, 0.0_pl_test_flt, 8.0_pl_test_flt, 8.0_pl_test_flt, theta, &
                   theta + dtheta, 0.0_pl_test_flt, .false.)
            theta = theta + dtheta
        enddo

        ! Draw several filled ellipses inside the circle at different
        ! angles.
        a = 3.0_pl_test_flt
        b = a * tan( (dtheta/180.0_pl_test_flt*PI)/2.0_pl_test_flt )
        theta = dtheta/2.0_pl_test_flt
        do i = 0, NSEG-1
            call plcol0( 2 - mod(i,2) )
            call plarc( a*cos(theta/180.0_pl_test_flt*PI), &
                   a*sin(theta/180.0_pl_test_flt*PI), &
                   a, b, 0.0_pl_test_flt, 360.0_pl_test_flt, theta, .true.)
            theta = theta + dtheta;
        enddo

    end subroutine arcs
end program x27f

!   Alpha color values demonstration
!
!   Copyright (C) 2008 Hazen Babcock
!   Copyright (C) 2008 Andrew Ross
!   Copyright (C) 2008-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!

program x30f
    use plplot

    implicit none

    integer, dimension(4) ::  red, green, blue
    real(kind=pl_test_flt), dimension (4) :: alpha, px, py
    real(kind=pl_test_flt), dimension (2) :: pos, rcoord, gcoord, bcoord, acoord
    logical, dimension(1) :: rev

    data red   / 0, 255, 0, 0 /
    data green / 0, 0, 255, 0 /
    data blue  / 0, 0, 0, 255 /
    data alpha / 1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt /
    data px / 0.1_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, 0.1_pl_test_flt /
    data py / 0.1_pl_test_flt, 0.1_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt /
    data pos / 0.0_pl_test_flt, 1.0_pl_test_flt /
    data rcoord / 1.0_pl_test_flt, 1.0_pl_test_flt /
    data gcoord / 0.0_pl_test_flt, 0.0_pl_test_flt /
    data bcoord / 0.0_pl_test_flt, 0.0_pl_test_flt /
    data acoord / 0.0_pl_test_flt, 1.0_pl_test_flt /
    data rev / .false. /

    integer i, j
    integer icol, r, g, b
    integer :: plparseopts_rc
    real(kind=pl_test_flt) :: a

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plinit()

    call plscmap0n(4)

    call plscmap0a (red, green, blue, alpha)

    !
    ! Page 1:
    !
    ! This is a series of red, green and blue rectangles overlaid
    ! on each other with gradually increasing transparency.
    !

    ! Set up the window
    call pladv (0)
    call plvpor (0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)
    call plwind (0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)
    call plcol0 (0)
    call plbox ("", 1.0_pl_test_flt, 0, "", 1.0_pl_test_flt, 0)

    ! Draw the boxes
    do i = 1,9
        icol = mod(i-1,3) + 1

        ! Get a color, change its transparency and
        ! set it as the current color.
        call plgcol0a (icol, r, g, b, a)
        call plscol0a (icol, r, g, b, 1.0_pl_test_flt - real(i-1,kind=pl_test_flt)/9.0_pl_test_flt)
        call plcol0 (icol)

        ! Draw the rectangle
        call plfill (px, py)

        ! Shift the rectangles coordinates
        do j = 1,4
            px(j) = px(j) + 0.5_pl_test_flt/9.0_pl_test_flt
            py(j) = py(j) + 0.5_pl_test_flt/9.0_pl_test_flt
        enddo
    enddo
    !
    ! Page 2:
    !
    ! This is a bunch of boxes colored red, green or blue with a single
    ! large (red) box of linearly varying transparency overlaid. The
    ! overlaid box is completely transparent at the bottom and completely
    ! opaque at the top.
    !

    ! Set up the window
    call pladv(0)
    call plvpor(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
    call plwind(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)

    ! Draw the boxes. There are 25 of them drawn on a 5 x 5 grid.
    do i = 1,5
        ! Set box X position
        px(1) = 0.05_pl_test_flt + 0.2_pl_test_flt * real(i-1,kind=pl_test_flt)
        px(2) = px(1) + 0.1_pl_test_flt
        px(3) = px(2)
        px(4) = px(1)

        ! We don't want the boxes to be transparent, so since we changed
        ! the colors transparencies in the first example we have to change
        ! the transparencies back to completely opaque.
        icol = mod(i-1,3) + 1
        call plgcol0a (icol, r, g, b, a)
        call plscol0a (icol, r, g, b, 1.0_pl_test_flt)
        call plcol0 (icol)
        do j = 1, 5
            ! Set box y position and draw the box.
            py(1) = 0.05_pl_test_flt + 0.2_pl_test_flt * real(j-1,kind=pl_test_flt)
            py(2) = py(1)
            py(3) = py(1) + 0.1_pl_test_flt
            py(4) = py(3)
            call plfill(px, py)
        enddo
    enddo

    ! Create the color map with 128 colors and call plscmap1la to initialize
    ! the color values with a linearly varying red transparency (or alpha)
    call plscmap1n(128)
    call plscmap1la(.true., pos, rcoord, gcoord, bcoord, acoord, rev)

    ! Use that cmap1 to create a transparent red gradient for the whole
    ! window.
    px(1) = 0._pl_test_flt
    px(2) = 1._pl_test_flt
    px(3) = 1._pl_test_flt
    px(4) = 0._pl_test_flt

    py(1) = 0._pl_test_flt
    py(2) = 0._pl_test_flt
    py(3) = 1._pl_test_flt
    py(4) = 1._pl_test_flt

    call plgradient( px, py, 90._pl_test_flt )
    call plend()

end program x30f

!      Grid data demo.
!
!      Copyright (C) 2004  Joao Cardoso
!      Copyright (C) 2008  Andrew Ross
!      Copyright (C) 2008-2016 Alan W. Irwin
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x21f
    use plplot, double_PI => PL_PI
    implicit none
    real(kind=pl_test_flt), parameter :: PI = double_PI

    integer pts, xp, yp, nl, knn_order, randn, rosen
    real(kind=pl_test_flt) threshold, wmin
    parameter (pts = 500)
    parameter (xp = 25)
    parameter (yp = 20)
    parameter (nl = 16)
    parameter (knn_order = 20)
    parameter (threshold = 1.001_pl_test_flt)
    parameter (wmin = -1e3_pl_test_flt)
    parameter (randn = 0)
    parameter (rosen = 0)

    real(kind=pl_test_flt) xmin, xmax, ymin, ymax

    real(kind=pl_test_flt) x(pts), y(pts), z(pts), clev(nl)
    real(kind=pl_test_flt) xg(xp), yg(yp), zg(xp,yp)
    real(kind=pl_test_flt) zmin, zmax, lzmin, lzmax
    integer i, j, k
    integer alg
    character(len=80) title(6)
    data title /'Cubic Spline Approximation', &
           'Delaunay Linear Interpolation', &
           'Natural Neighbors Interpolation', &
           'KNN Inv. Distance Weighted', &
           '3NN Linear Interpolation', &
           '4NN Around Inv. Dist. Weighted'/

    real(kind=pl_test_flt) opt(6)
    data opt /0._pl_test_flt, 0._pl_test_flt, 0._pl_test_flt, 0._pl_test_flt, 0._pl_test_flt, 0._pl_test_flt/

    real(kind=pl_test_flt) xt, yt

    real(kind=pl_test_flt) r
    integer ii, jj
    integer :: plparseopts_rc
    real(kind=pl_test_flt) dist, d

    xmin = -0.2_pl_test_flt
    ymin = -0.2_pl_test_flt
    xmax = 0.6_pl_test_flt
    ymax = 0.6_pl_test_flt

    !      call plMergeOpts(options, "x21c options", NULL);
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    opt(3) = wmin
    opt(4) = real(knn_order,kind=pl_test_flt)
    opt(5) = threshold

    ! Initialize plplot

    call plinit

    call cmap1_init

    call plseed(5489)

    do i=1,pts
        xt = (xmax-xmin)*plrandd()
        yt = (ymax-ymin)*plrandd()
        if (randn.eq.0) then
            x(i) = xt + xmin
            y(i) = yt + ymin
        else
            x(i) = sqrt(-2._pl_test_flt*log(xt)) * cos(2._pl_test_flt*PI*yt) + xmin
            y(i) = sqrt(-2._pl_test_flt*log(xt)) * sin(2._pl_test_flt*PI*yt) + ymin
        endif
        if (rosen.eq.0) then
            r = sqrt(x(i)*x(i) + y(i)*y(i))
            z(i) = exp(-r*r)*cos(2._pl_test_flt*PI*r)
        else
            z(i) = log((1._pl_test_flt-x(i))**2 + 100._pl_test_flt*(y(i)-x(i)**2)**2)
        endif
    enddo

    zmin = z(1)
    zmax = z(1)
    do i=2,pts
        zmax = max(zmax,z(i))
        zmin = min(zmin,z(i))
    enddo

    do i=1,xp
        xg(i) = xmin + (xmax-xmin)*(i-1._pl_test_flt)/(xp-1._pl_test_flt)
    enddo
    do i=1,yp
        yg(i) = ymin + (ymax-ymin)*(i-1._pl_test_flt)/(yp-1._pl_test_flt)
    enddo

    call plcol0(1)
    call plenv(xmin, xmax, ymin, ymax, 2, 0)
    call plcol0(15)
    call pllab("X", "Y", "The original data sampling")
    do i=1,pts
        call plcol1( ( z(i) - zmin ) / ( zmax - zmin ) )
        !     The following plstring call should be the the equivalent of
        !     plpoin( 1, &x[i], &y[i], 5 ); Use plstring because it is
        !     not deprecated like plpoin and has much more powerful
        !     capabilities.  N.B. symbol 141 works for Hershey devices
        !     (e.g., -dev xwin) only if plfontld( 0 ) has been called
        !     while symbol 727 works only if plfontld( 1 ) has been
        !     called.  The latter is the default which is why we use 727
        !     here to represent a centred X (multiplication) symbol.
        !     This dependence on plfontld is one of the limitations of
        !     the Hershey escapes for PLplot, but the upside is you get
        !     reasonable results for both Hershey and Unicode devices.
        call plstring( x(i:i), y(i:i), '#(727)' );
    enddo
    call pladv(0)

    call plssub(3,2)

    do k=1,2
        call pladv(0)
        do alg=1,6

            call plgriddata(x, y, z, xg, yg, zg, alg, opt(alg))

            !     - CSA can generate NaNs (only interpolates? !).
            !     - DTLI and NNI can generate NaNs for points outside the convex hull
            !     of the data points.
            !     - NNLI can generate NaNs if a sufficiently thick triangle is not found
            !
            !     PLplot should be NaN/Inf aware, but changing it now is quite a job...
            !     so, instead of not plotting the NaN regions, a weighted average over
            !     the neighbors is done.
            !

            if ((alg.eq.GRID_CSA).or.(alg.eq.GRID_DTLI).or. &
                   (alg.eq.GRID_NNLI).or.(alg.eq.GRID_NNI)) then

                do i=1,xp
                    do j=1,yp
                        if (myisnan(zg(i,j))) then
                            !     average (IDW) over the 8 neighbors

                            zg(i,j) = 0._pl_test_flt
                            dist = 0._pl_test_flt

                            ii=i-1
                            do while ((ii.le.i+1).and.(ii.le.xp))
                                jj = j-1
                                do while ((jj.le.j+1).and.(jj.le.yp))
                                    if ((ii.ge.1) .and. (jj.ge.1) .and. &
                                           (.not.myisnan(zg(ii,jj))) ) then
                                        if (abs(ii-i) + abs(jj-j) .eq. 1) then
                                            d = 1._pl_test_flt
                                        else
                                            d = 1.4142_pl_test_flt
                                        endif
                                        zg(i,j) = zg(i,j) + zg(ii,jj)/(d*d)
                                        dist = dist + d
                                    endif
                                    jj = jj+1
                                enddo
                                ii = ii+1
                            enddo
                            if (dist.ne.0._pl_test_flt) then
                                zg(i,j) = zg(i,j) / dist
                            else
                                zg(i,j) = zmin
                            endif
                        endif
                    enddo
                enddo
            endif

            call a2mnmx(zg, xp, yp, lzmin, lzmax, xp)

            lzmin = min(lzmin, zmin)
            lzmax = max(lzmax, zmax)

            lzmin = lzmin - 0.01_pl_test_flt
            lzmax = lzmax + 0.01_pl_test_flt

            call plcol0(1)
            call pladv(alg)

            if (k.eq.1) then

                do i=1,nl
                    clev(i) = lzmin + (lzmax-lzmin)/(nl-1._pl_test_flt)*(i-1._pl_test_flt)
                enddo
                call plenv0(xmin, xmax, ymin, ymax, 2, 0)
                call plcol0(15)
                call pllab("X", "Y", title(alg))
                call plshades(zg, xmin, xmax, ymin, &
                       ymax, clev, 1._pl_test_flt, 0, 1._pl_test_flt, .true. )
                call plcol0(2)
            else

                do i = 1,nl
                    clev(i) = lzmin + (lzmax-lzmin)/(nl-1._pl_test_flt)*(i-1._pl_test_flt)
                enddo
                call plvpor(0._pl_test_flt, 1._pl_test_flt, 0._pl_test_flt, 0.9_pl_test_flt)
                call plwind(-1.1_pl_test_flt, 0.75_pl_test_flt, -0.65_pl_test_flt, 1.20_pl_test_flt)
                !
                !     For the comparison to be fair, all plots should have the
                !     same z values, but to get the max/min of the data generated
                !     by all algorithms would imply two passes. Keep it simple.
                !
                !     plw3d(1., 1., 1., xmin, xmax, ymin, ymax, zmin, zmax, 30, -60);
                !

                call plw3d(1._pl_test_flt, 1._pl_test_flt, 1._pl_test_flt, xmin, xmax, ymin, ymax,  &
                       lzmin, lzmax, 30._pl_test_flt, -40._pl_test_flt)
                call plbox3("bntu", "X", 0._pl_test_flt, 0, &
                       "bntu", "Y", 0._pl_test_flt, 0, &
                       "bcdfntu", "Z", 0.5_pl_test_flt, 0)
                call plcol0(15)
                call pllab("", "", title(alg))
                call plot3dc(xg, yg, zg, ior(ior(DRAW_LINEXY, &
                       MAG_COLOR), BASE_CONT), clev)
            endif
        enddo
    enddo

    call plend

contains

    subroutine cmap1_init
        use plplot
        implicit none
        real(kind=pl_test_flt) i(2), h(2), l(2), s(2)

        i(1) = 0._pl_test_flt
        i(2) = 1._pl_test_flt

        h(1) = 240._pl_test_flt
        h(2) = 0._pl_test_flt

        l(1) = 0.6_pl_test_flt
        l(2) = 0.6_pl_test_flt

        s(1) = 0.8_pl_test_flt
        s(2) = 0.8_pl_test_flt

        call plscmap1n(256)
        call plscmap1l(.false., i, h, l, s)
    end subroutine cmap1_init


    !----------------------------------------------------------------------------
    !      Subroutine a2mnmx
    !      Minimum and the maximum elements of a 2-d array.

    subroutine a2mnmx(f, nx, ny, fmin, fmax, xdim)
        use plplot
        implicit none

        integer   i, j, nx, ny, xdim
        real(kind=pl_test_flt) f(xdim, ny), fmin, fmax

        fmax = f(1, 1)
        fmin = fmax
        do j = 1, ny
            do  i = 1, nx
                fmax = max(fmax, f(i, j))
                fmin = min(fmin, f(i, j))
            enddo
        enddo
    end subroutine a2mnmx

    include 'plfortrandemos.inc'

end program x21f

!   Displays Greek letters and mathematically interesting Unicode ranges
!
!   Copyright (C) 2005-2016 Alan W. Irwin
!   Copyright (C) 2005 Andrew Ross
!
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as published
!   by the Free Software Foundation; either version 2 of the License, or
!   (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public License
!   along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!

program x23f
    use plplot
    implicit none

    real(kind=pl_test_flt) xmin, xmax, ymin, ymax, ycharacter_scale, yoffset
    real(kind=pl_test_flt) chardef, charht, deltax, deltay, x, y
    integer i, j, page, length, slice
    character(len=20) cmdString
    integer fci_old
    integer ifamily, istyle, iweight
    real(kind=pl_test_flt) dy
    integer family_index, style_index, weight_index
    ! Must be big enough to contain the prefix strings, the font-changing
    ! commands, and the "The quick brown..." string.
    character(len=200) string



    !
    !  Displays Greek letters and mathematically interesting Unicode ranges
    !
    integer      fci_combinations
    parameter(fci_combinations = 30)

    character(len=5)  greek(48)
    integer      type1(166)
    character(len=80) title(11)
    integer      lo(11)
    integer      hi(11)
    integer      nxcells(11)
    integer      nycells(11)
    integer      offset(11)
    integer :: fci(fci_combinations)
    character(len=11) family(5)
    character(len=8)  style(3)
    character(len=7)  weight(2)

    data (greek(i) ,i=1,48) / &
           '#gA','#gB','#gG','#gD','#gE','#gZ', &
           '#gY','#gH','#gI','#gK','#gL','#gM', &
           '#gN','#gC','#gO','#gP','#gR','#gS', &
           '#gT','#gU','#gF','#gX','#gQ','#gW', &
           '#ga','#gb','#gg','#gd','#ge','#gz', &
           '#gy','#gh','#gi','#gk','#gl','#gm', &
           '#gn','#gc','#go','#gp','#gr','#gs', &
           '#gt','#gu','#gf','#gx','#gq','#gw'  /

    data (type1(i) ,i=1,75) / &
           z'0020',z'0021',z'0023',z'0025',z'0026', &
           z'0028',z'0029',z'002b',z'002c',z'002e', &
           z'002f',z'0030',z'0031',z'0032',z'0033', &
           z'0034',z'0035',z'0036',z'0037',z'0038', &
           z'0039',z'003a',z'003b',z'003c',z'003d', &
           z'003e',z'003f',z'005b',z'005d',z'005f', &
           z'007b',z'007c',z'007d',z'00a9',z'00ac', &
           z'00ae',z'00b0',z'00b1',z'00d7',z'00f7', &
           z'0192',z'0391',z'0392',z'0393',z'0394', &
           z'0395',z'0396',z'0397',z'0398',z'0399', &
           z'039a',z'039b',z'039c',z'039d',z'039e', &
           z'039f',z'03a0',z'03a1',z'03a3',z'03a4', &
           z'03a5',z'03a6',z'03a7',z'03a8',z'03a9', &
           z'03b1',z'03b2',z'03b3',z'03b4',z'03b5', &
           z'03b6',z'03b7',z'03b8',z'03b9',z'03ba' /
    data (type1(i) ,i=76,166) / &
           z'03bb',z'03bc',z'03bd',z'03be',z'03bf', &
           z'03c0',z'03c1',z'03c2',z'03c3',z'03c4', &
           z'03c5',z'03c6',z'03c7',z'03c8',z'03c9', &
           z'03d1',z'03d2',z'03d5',z'03d6',z'2022', &
           z'2026',z'2032',z'2033',z'203e',z'2044', &
           z'2111',z'2118',z'211c',z'2122',z'2126', &
           z'2135',z'2190',z'2191',z'2192',z'2193', &
           z'2194',z'21b5',z'21d0',z'21d1',z'21d2', &
           z'21d3',z'21d4',z'2200',z'2202',z'2203', &
           z'2205',z'2206',z'2207',z'2208',z'2209', &
           z'220b',z'220f',z'2211',z'2212',z'2215', &
           z'2217',z'221a',z'221d',z'221e',z'2220', &
           z'2227',z'2228',z'2229',z'222a',z'222b', &
           z'2234',z'223c',z'2245',z'2248',z'2260', &
           z'2261',z'2264',z'2265',z'2282',z'2283', &
           z'2284',z'2286',z'2287',z'2295',z'2297', &
           z'22a5',z'22c5',z'2320',z'2321',z'2329', &
           z'232a',z'25ca',z'2660',z'2663',z'2665', &
           z'2666' /

    data (title(i) ,i=1,11 )/ &
           "#<0x10>PLplot Example 23 - Greek Letters", &
           "#<0x10>PLplot Example 23 - Type 1 Symbol Font Glyphs by Unicode (a)", &
           "#<0x10>PLplot Example 23 - Type 1 Symbol Font Glyphs by Unicode (b)", &
           "#<0x10>PLplot Example 23 - Type 1 Symbol Font Glyphs by Unicode (c)", &
           "#<0x10>PLplot Example 23 - Number Forms Unicode Block", &
           "#<0x10>PLplot Example 23 - Arrows Unicode Block (a)", &
           "#<0x10>PLplot Example 23 - Arrows Unicode Block (b)", &
           "#<0x10>PLplot Example 23 - Mathematical Operators Unicode Block (a)", &
           "#<0x10>PLplot Example 23 - Mathematical Operators Unicode Block (b)", &
           "#<0x10>PLplot Example 23 - Mathematical Operators Unicode Block (c)", &
           "#<0x10>PLplot Example 23 - Mathematical Operators Unicode Block (d)" /

    data (lo(i) ,i=1,11) / &
           z'0', &
           z'0', &
           z'40', &
           z'80', &
           z'2153', &
           z'2190', &
           z'21d0', &
           z'2200', &
           z'2240', &
           z'2280', &
           z'22c0' /

    data (hi(i) ,i=1,11) / &
           z'30', &
           z'40', &
           z'80', &
           z'A6', &
           z'2184', &
           z'21d0', &
           z'2200', &
           z'2240', &
           z'2280', &
           z'22c0', &
           z'2300' /

    data (nxcells(i) ,i=1,11) / &
           12, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8 /

    data (nycells(i) ,i=1,11) / &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8, &
           8 /

    !  non-zero values Must be consistent with nxcells and nycells. */
    data (offset(i) ,i=1,11) / &
           0, &
           0, &
           64, &
           128, &
           0, &
           0, &
           0, &
           0, &
           0, &
           0, &
           0 /

    !    drop the leading '8' marker for FCI because some compilers (gfortran)
    !    have an implementation error (integer overflow error) for that case, and
    integer :: plparseopts_rc
    !    the marker is not needed, in any case, for calls to plsfci.

    data (fci(i), i=1,fci_combinations) / &
           z'00000000', &
           z'00000001', &
           z'00000002', &
           z'00000003', &
           z'00000004', &
           z'00000010', &
           z'00000011', &
           z'00000012', &
           z'00000013', &
           z'00000014', &
           z'00000020', &
           z'00000021', &
           z'00000022', &
           z'00000023', &
           z'00000024', &
           z'00000100', &
           z'00000101', &
           z'00000102', &
           z'00000103', &
           z'00000104', &
           z'00000110', &
           z'00000111', &
           z'00000112', &
           z'00000113', &
           z'00000114', &
           z'00000120', &
           z'00000121', &
           z'00000122', &
           z'00000123', &
           z'00000124' /

    data (family(i), i=1,5) / &
           "sans-serif", &
           "serif", &
           "monospace", &
           "script", &
           "symbol" /

    data (style(i), i=1,3) / &
           "upright", &
           "italic", &
           "oblique" /

    data (weight(i), i=1,2) / &
           "medium", &
           "bold" /

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plinit()

    do page = 1,11
        call pladv(0)

        !        Set up viewport and window

        call plvpor(0.02_pl_test_flt, 0.98_pl_test_flt, 0.02_pl_test_flt, 0.90_pl_test_flt)
        call plwind(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)
        call plgspa(xmin, xmax, ymin, ymax)
        call plschr(0._pl_test_flt, 0.8_pl_test_flt)
        ycharacter_scale = (1.0_pl_test_flt - 0.0_pl_test_flt)/(ymax-ymin)

        !        Factor should be 0.5, but heuristically it turns out to be larger.

        call plgchr(chardef, charht)
        yoffset = 1.0_pl_test_flt*charht*ycharacter_scale

        !        Draw the grid using plbox

        call plcol0(2)
        deltax = 1.0_pl_test_flt/nxcells(page)
        deltay = 1.0_pl_test_flt/nycells(page)
        call plbox("bcg", deltax, 0, "bcg", deltay, 0)
        call plcol0(15)
        length=hi(page)-lo(page)
        slice = 1
        do j=nycells(page),0,-1
            y = (j-0.5_pl_test_flt)*deltay
            do i=1,nxcells(page)
                x  = (i-0.5_pl_test_flt)*deltax
                if (slice .le. length) then
                    if (page .eq. 1) then
                        write(cmdString, '("#",a)') Greek(slice)
                    elseif (page .ge. 1 .and. page .le. 4) then
                        write(cmdString, '("##[0x",z4.4,"]")') &
                               type1(offset(page)+slice)
                        !                     Not required for command which is case insensitive,
                        !                     but lowercase the command simply to get same
                        !                     lowercase display of command as corresponding C example.
                        call lowercase23(cmdString)
                    elseif (page .ge. 5) then
                        write(cmdString, '("##[0x",z4.4,"]")') &
                               lo(page)+slice-1
                        !                     Not required for command which is case insensitive,
                        !                     but lowercase the command simply to get same
                        !                     lowercase display of command as corresponding C example.
                        call lowercase23(cmdString)
                    endif
                    call plptex(x,y+yoffset,1._pl_test_flt,0._pl_test_flt,0.5_pl_test_flt, &
                           cmdString(2:20))
                    call plptex(x,y-yoffset,1._pl_test_flt,0._pl_test_flt,0.5_pl_test_flt, &
                           cmdString)
                endif
                slice = slice + 1
            enddo
        enddo
        call plschr(0._pl_test_flt, 1.0_pl_test_flt)
        call plmtex("t", 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, title(page))
    enddo

    !     Demonstrate methods of getting the current fonts
    call plgfci(fci_old)
    call plgfont(ifamily, istyle, iweight)
    write (*,'(a,z8)') 'For example 23 prior to page 12 the FCI is 0x',fci_old
    write (*,'(a)') 'For example 23 prior to page 12 the font family, style and weight are '// &
           trim(family(ifamily+1))//' '//trim(style(istyle+1))//' '//trim(weight(iweight+1))

    do page=11,15
        dy = 0.030_pl_test_flt

        call pladv(0)
        call plvpor(0.02_pl_test_flt, 0.98_pl_test_flt, 0.02_pl_test_flt, 0.90_pl_test_flt)
        call plwind(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)
        call plsfci(0)
        if (page == 11) then
            call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                   '#<0x10>PLplot Example 23 - '// &
                   'Set Font with plsfci')
        elseif (page == 12) then
            call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                   '#<0x10>PLplot Example 23 - '// &
                   'Set Font with plsfont')
        elseif(page == 13) then
            call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                   '#<0x10>PLplot Example 23 - '// &
                   'Set Font with ##<0x8nnnnnnn> construct')
        elseif(page == 14) then
            call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                   '#<0x10>PLplot Example 23 - '// &
                   'Set Font with ##<0xmn> constructs')
        elseif(page == 15) then
            call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                   '#<0x10>PLplot Example 23 - '// &
                   'Set Font with ##<FCI COMMAND STRING/> constructs')
        endif
        call plschr(0._pl_test_flt, 0.75_pl_test_flt)
        do i=0,fci_combinations-1
            family_index = mod(i,5)
            style_index = mod(i/5,3)
            weight_index = mod((i/5)/3,2)
            if(page == 11) then
                call plsfci(fci(i+1))
                write(string,'(a)') &
                       'Page 12, '// &
                       trim(family(family_index+1))//', '// &
                       trim(style(style_index+1))//', '// &
                       trim(weight(weight_index+1))//':  '// &
                       'The quick brown fox jumps over the lazy dog'
            elseif(page == 12) then
                call plsfont(family_index, style_index, weight_index)
                write(string,'(a)') &
                       'Page 13, '// &
                       trim(family(family_index+1))//', '// &
                       trim(style(style_index+1))//', '// &
                       trim(weight(weight_index+1))//':  '// &
                       'The quick brown fox jumps over the lazy dog'
            elseif(page == 13) then
                !           Note, must put in missing FCI marker for this particular case.
                write(string,'(a,"#<0x8",z7.7,">",a)') &
                       'Page 14, '//trim(family(family_index+1))//', '// &
                       trim(style(style_index+1))//', '// &
                       trim(weight(weight_index+1))//':  ', &
                       fci(i+1), &
                       'The quick brown fox jumps over the lazy dog'
            elseif(page == 14) then
                write(string,'(a,"#<0x",z1,"0>#<0x",z1,"1>#<0x",z1,"2>",a)') &
                       'Page 15, '// &
                       trim(family(family_index+1))//', '// &
                       trim(style(style_index+1))//', '// &
                       trim(weight(weight_index+1))//':  ', &
                       family_index, &
                       style_index, &
                       weight_index, &
                       'The quick brown fox jumps over the lazy dog'
            elseif(page == 15) then
                write(string,'(a)') &
                       'Page 16, '// &
                       trim(family(family_index+1))//', '// &
                       trim(style(style_index+1))//', '// &
                       trim(weight(weight_index+1))//':  '// &
                       '#<'//trim(family(family_index+1))//'/>#<'// &
                       trim(style(style_index+1))//'/>#<'// &
                       trim(weight(weight_index+1))//'/>'// &
                       'The quick brown fox jumps over the lazy dog'
            endif
            call plptex (0._pl_test_flt, 1._pl_test_flt - (i+0.5_pl_test_flt)*dy, 1._pl_test_flt, &
                   0._pl_test_flt, 0._pl_test_flt, string)
        enddo
        call plschr(0._pl_test_flt, 1.0_pl_test_flt)
    enddo
    !     Restore defaults

    call plcol0(1)

    call plend()

contains

    subroutine lowercase23(string)
        implicit none
        character*(*) string
        integer i, iascii
        do i = 1, len(string)
            iascii = iachar(string(i:i))
            if(65.le.iascii.and.iascii.le.90) then
                !          convert uppercase to lowercase.
                string(i:i) = achar(iascii+32)
            endif
        enddo
    end subroutine lowercase23
end program x23f

!   Demonstration program for PLplot illustrating absolute positioning
!   of graphs on a page
!
!   Copyright (C) 2004-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x10f
    use plplot
    implicit none
    integer :: plparseopts_rc

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plinit()

    call pladv(0)
    call plvpor(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plwind(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plbox('bc', 0.0_pl_test_flt, 0, 'bc', 0.0_pl_test_flt, 0 )

    call plsvpa(50.0_pl_test_flt, 150.0_pl_test_flt, 50.0_pl_test_flt, 100.0_pl_test_flt )
    call plwind(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plbox('bc', 0.0_pl_test_flt, 0, 'bc', 0.0_pl_test_flt, 0 )
    call plptex(0.5_pl_test_flt, 0.5_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, &
           0.5_pl_test_flt, 'BOX at (50,150,50,100)' )

    call plend

end program x10f

!   Draws a histogram from sample data
!
!   Copyright (C) 2004-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x04f
    use plplot, double_PI => PL_PI
    use plfortrandemolib
    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    integer, parameter :: NPTS = 2047
    integer :: plparseopts_rc
    real(kind=pl_test_flt) :: data(NPTS), delta

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !   Initialize plplot
    call plinit()

    !   Fill up data points
    delta = 2.0_pl_test_flt * PI / real(NPTS,kind=pl_test_flt)
    data = sin(delta*arange(NPTS))

    call plcol0(1)
    call plhist(data, -1.1_pl_test_flt, 1.1_pl_test_flt, 44, 0)
    call plcol0(2)
    call pllab('#frValue','#frFrequency', &
           '#frPLplot Example 5 - Probability function of Oscillator')

    call plend
end program x04f

!      Demo of multiple stream/window capability
!
!      Copyright (C) 2004  Arjen Markus
!      Copyright (C) 2004-2016  Alan W. Irwin
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
! Plots several simple functions from other example programs.
!
! This version sends the output of the first 4 plots (one page) to two
! independent streams.

program x14f
    use plplot
    implicit none

    integer digmax

    character(len=80) :: driver
    character(len=15) :: geometry_master
    character(len=15) :: geometry_slave

    integer :: fam, num, bmax

    real(kind=pl_test_flt), dimension(101) ::  x, y
    real(kind=pl_test_flt), dimension(6) ::  xs, ys
    real(kind=pl_test_flt)  :: xscale, yscale, xoff, yoff
    common /plotdat/ x, y, xs, ys, xscale, yscale, xoff, yoff
    real(kind=pl_test_flt) :: xp0, yp0
    integer :: xleng0, yleng0, xoff0, yoff0
    integer :: plparseopts_rc, plsetopt_rc
    logical :: valid_geometry

    geometry_master = '500x410+100+200'
    geometry_slave = '500x410+650+200'

    !      Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !      If valid geometry specified on command line, use it for both streams.
    call plgpage(xp0, yp0, xleng0, yleng0, xoff0, yoff0)
    valid_geometry = (xleng0 .gt. 0 .and. yleng0 .gt. 0)

    !      Set up first stream

    if(valid_geometry) then
        call plspage(xp0, yp0, xleng0, yleng0, xoff0, yoff0)
    else
        plsetopt_rc = plsetopt( 'geometry', geometry_master)
        if(plsetopt_rc .ne. 0) stop "plsetopt error"
    endif

    call plssub(2, 2)
    call plinit()

    call plgdev(driver)
    call plgfam(fam,num,bmax)

    write(6,'(3A)') 'Demo of multiple output streams via the ', &
           trim(driver), ' driver.'
    write(6,'(A)') 'Running with the second stream as slave '// &
           'to the first.'
    write(6,*)
    !      flush unit 6 so this part of stdout is guaranteed to be written prior
    !      to stdout generated by second plinit below.
    flush(6)

    !      Start next stream

    call plsstrm(1)

    if(valid_geometry) then
        call plspage(xp0, yp0, xleng0, yleng0, xoff0, yoff0)
    else
        plsetopt_rc = plsetopt( 'geometry', geometry_slave)
    endif

    !      Turn off pause to make this a slave (must follow master)

    call plspause(.false.)
    call plsdev(driver)
    call plsfam(fam,num,bmax)
    plsetopt_rc = plsetopt('fflen','2')
    call plinit()

    !      Set up the data & plot
    !      Original case

    call plsstrm(0)

    xscale = 6._pl_test_flt
    yscale = 1._pl_test_flt
    xoff = 0._pl_test_flt
    yoff = 0._pl_test_flt
    call plot1()

    !      Set up the data & plot

    xscale = 1._pl_test_flt
    yscale = 1.d+6
    call plot1()

    !      Set up the data & plot

    xscale = 1._pl_test_flt
    yscale = 1.d-6
    digmax = 2
    call plsyax(digmax, 0)
    call plot1()

    !      Set up the data & plot

    xscale = 1._pl_test_flt
    yscale = 0.0014_pl_test_flt
    yoff = 0.0185_pl_test_flt
    digmax = 5
    call plsyax(digmax, 0)
    call plot1()

    !      To slave
    !      The pleop() ensures the eop indicator gets lit.

    call plsstrm(1)
    call plot4()
    call pleop()

    !      Back to master

    call plsstrm(0)
    call plot2()
    call plot3()

    !      To slave

    call plsstrm(1)
    call plot5()
    call pleop()

    !      Back to master to wait for user to advance

    call plsstrm(0)
    call pleop()

    !      Call plend to finish off.

    call plend()

contains

    !======================================================================

    subroutine plot1()
        use plplot
        implicit none

        real(kind=pl_test_flt), dimension(101) :: x, y
        real(kind=pl_test_flt), dimension(6) :: xs, ys
        real(kind=pl_test_flt) :: xscale, yscale, xoff, yoff, xmin, xmax, ymin, ymax
        integer :: i
        common /plotdat/ x, y, xs, ys, xscale, yscale, xoff, yoff

        do i = 1, 60
            x(i) = xoff + xscale * real(i,kind=pl_test_flt)/60.0_pl_test_flt
            y(i) = yoff + yscale * x(i)**2
        enddo

        xmin = x(1)
        xmax = x(60)
        ymin = y(1)
        ymax = y(60)

        do i = 1, 6
            xs(i) = x((i-1)*10+4)
            ys(i) = y((i-1)*10+4)
        enddo

        !      Set up the viewport and window using PLENV. The range in X is
        !      0.0 to 6.0, and the range in Y is 0.0 to 30.0. The axes are
        !      scaled separately (just = 0), and we just draw a labelled
        !      box (axis = 0).

        call plcol0(1)
        call plenv( xmin, xmax, ymin, ymax, 0, 0 )
        call plcol0(6)
        call pllab( '(x)', '(y)', '#frPLplot Example 1 - y=x#u2' )

        !      Plot the data points

        call plcol0(9)
        call plpoin(xs, ys, 9)

        !      Draw the line through the data

        call plcol0(4)
        call plline(x(:60), y(:60))
        call plflush
    end subroutine plot1

    !======================================================================

    subroutine plot2()
        use plplot
        implicit none
        real(kind=pl_test_flt), dimension(101) :: x, y
        real(kind=pl_test_flt), dimension(6) :: xs, ys
        real(kind=pl_test_flt) :: xscale, yscale, xoff, yoff
        integer :: i
        common /plotdat/ x, y, xs, ys, xscale, yscale, xoff, yoff

        !======================================================================
        !
        !      Set up the viewport and window using PLENV. The range in X is
        !      -2.0 to 10.0, and the range in Y is -0.4 to 2.0. The axes are
        !      scaled separately (just = 0), and we draw a box with axes
        !      (axis = 1).

        call plcol0(1)
        call plenv(-2.0_pl_test_flt, 10.0_pl_test_flt, -0.4_pl_test_flt, 1.2_pl_test_flt, 0, 1 )
        call plcol0(2)
        call pllab( '(x)', 'sin(x)/x', &
               '#frPLplot Example 1 - Sinc Function' )

        !      Fill up the arrays

        do i = 1, 100
            x(i) = (i-20.0_pl_test_flt)/6.0_pl_test_flt
            y(i) = 1.0_pl_test_flt
            if (x(i) .ne. 0.0_pl_test_flt) y(i) = sin(x(i)) / x(i)
        enddo
        !      Draw the line

        call plcol0(3)
        call plline(x(:100), y(:100))
        call plflush

    end subroutine plot2
    !======================================================================

    subroutine plot3()
        !
        !      For the final graph we wish to override the default tick intervals,
        !      and so do not use_ PLENV

        use plplot, double_PI => PL_PI
        implicit none
        real(kind=pl_test_flt), parameter :: PI = double_PI
        real(kind=pl_test_flt), dimension(101) ::  x, y
        real(kind=pl_test_flt), dimension(6) :: xs, ys
        real(kind=pl_test_flt) :: xscale, yscale, xoff, yoff
        integer :: i
        common /plotdat/ x, y, xs, ys, xscale, yscale, xoff, yoff
        call pladv(0)

        !      Use_ standard viewport, and define X range from 0 to 360 degrees,
        !      Y range from -1.2 to 1.2.

        call plvsta()
        call plwind( 0.0_pl_test_flt, 360.0_pl_test_flt, -1.2_pl_test_flt, 1.2_pl_test_flt )

        !      Draw a box with ticks spaced 60 degrees apart in X, and 0.2 in Y.

        call plcol0(1)
        call plbox( 'bcnst', 60.0_pl_test_flt, 2, 'bcnstv', 0.2_pl_test_flt, 2 )

        !      Superimpose a dashed line grid, with 1.5 mm marks and spaces. With
        !      only a single mark and space element, we do not need arrays

        call plstyl( (/1500/), (/1500/) )
        call plcol0(2)
        call plbox( 'g', 30.0_pl_test_flt, 0, 'g', 0.2_pl_test_flt, 0 )
        call plstyl( (/integer ::/), (/integer ::/) )

        call plcol0(3)
        call pllab( 'Angle (degrees)', 'sine', &
               '#frPLplot Example 1 - Sine function' )

        do i = 1, 101
            x(i) = 3.6_pl_test_flt * (i-1)
            y(i) = sin( x(i) * PI/180.0_pl_test_flt )
        enddo

        call plcol0(4)
        call plline(x, y)
        call plflush
    end subroutine plot3

    !======================================================================

    subroutine plot4()

        use plplot, double_PI => PL_PI
        implicit none
        real(kind=pl_test_flt), parameter :: PI = double_PI
        character(len=3) :: text
        real(kind=pl_test_flt), dimension(0:360) :: x0, y0, x, y
        real(kind=pl_test_flt) :: dtr, theta, dx, dy, r
        integer :: i, j

        dtr = PI/180.0_pl_test_flt
        do i=0,360
            x0(i) = cos(dtr * real(i,kind=pl_test_flt))
            y0(i) = sin(dtr * real(i,kind=pl_test_flt))
        enddo

        !      Set up viewport and window, but do not draw box

        call plenv(-1.3_pl_test_flt, 1.3_pl_test_flt, -1.3_pl_test_flt, 1.3_pl_test_flt, 1, -2)
        do i = 1,10
            do j = 0,360
                x(j) = 0.1_pl_test_flt*i*x0(j)
                y(j) = 0.1_pl_test_flt*i*y0(j)
            enddo

            !        Draw circles for polar grid

            call plline(x,y)
        enddo
        call plcol0(2)
        do i = 0,11
            theta = 30.0_pl_test_flt*i
            dx = cos(dtr*theta)
            dy = sin(dtr*theta)

            !        Draw radial spokes for polar grid

            call pljoin(0.0_pl_test_flt, 0.0_pl_test_flt, dx, dy)
            write (text,'(i3)') nint(theta)

            !        Write labels for angle

            text = text(nsp(text):)
            !        Slightly off zero to avoid floating point logic flips at
            !        90 and 270 deg.
            if (dx.ge.-0.00001_pl_test_flt) then
                call plptex(dx, dy, dx, dy, -0.15_pl_test_flt, text)
            else
                call plptex(dx, dy, -dx, -dy, 1.15_pl_test_flt, text)
            end if
        enddo
        !      Draw the graph

        do i=0,360
            r = sin(dtr*real(5*i,kind=pl_test_flt))
            x(i) = x0(i) * r
            y(i) = y0(i) * r
        enddo
        call plcol0(3)
        call plline(x,y)

        call plcol0(4)
        call plmtex('t', 2.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
               '#frPLplot Example 3 - r(#gh)=sin 5#gh')

        !      Flush the plot at end

        call plflush
    end subroutine plot4

    !======================================================================

    integer function nsp(text)
        !      ==================

        !      Find first non-space character
        use plplot
        implicit none

        character*(*) text
        integer l

        l = len(text)
        nsp = 1
        do while(text(nsp:nsp).eq.' ' .and. nsp.lt.l)
            nsp = nsp+1
        enddo
    end function nsp

    !======================================================================

    subroutine plot5()

        use plplot
        implicit none
        integer :: i, j, nptsx, nptsy, xdim, ydim
        !      xdim and ydim are the absolute static dimensions.
        !      nptsx, and nptsy are the (potentially dynamic) defined area of the 2D
        !      arrays that is actually used.
        parameter (xdim=99, ydim=100, nptsx=35,nptsy=46)

        real(kind=pl_test_flt), dimension(xdim,ydim) ::  z, w
        real(kind=pl_test_flt), dimension(11) :: clevel
        real(kind=pl_test_flt) :: xx, yy
        real(kind=pl_test_flt), dimension(6) :: tr

        data clevel /-1._pl_test_flt, -0.8_pl_test_flt, -0.6_pl_test_flt, -0.4_pl_test_flt, &
               -0.2_pl_test_flt, &
               0._pl_test_flt, 0.2_pl_test_flt, 0.4_pl_test_flt, 0.6_pl_test_flt ,0.8_pl_test_flt, 1._pl_test_flt/

        tr(1) = 2._pl_test_flt/real(nptsx-1,kind=pl_test_flt)
        tr(2) = 0.0_pl_test_flt
        tr(3) = -1.0_pl_test_flt
        tr(4) = 0.0_pl_test_flt
        tr(5) = 2._pl_test_flt/real(nptsy-1,kind=pl_test_flt)
        tr(6) = -1.0_pl_test_flt

        !      Calculate the data matrices.
        do i=1,nptsx
            xx = real(i-1-(nptsx/2),kind=pl_test_flt)/real(nptsx/2,kind=pl_test_flt)
            do j=1,nptsy
                yy = real(j-1-(nptsy/2),kind=pl_test_flt)/real(nptsy/2,kind=pl_test_flt) - 1.0_pl_test_flt
                z(i,j) = xx*xx - yy*yy
                w(i,j) = 2._pl_test_flt*xx*yy
            enddo
        enddo

        !      Plot using identity transform
        call plenv(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, 0, 0)
        call plcol0(2)
        call plcont(z,1,nptsx,1,nptsy,clevel,tr)
        call plstyl( (/1500/), (/1500/) )
        call plcol0(3)
        call plcont(w,1,nptsx,1,nptsy,clevel,tr)
        call plstyl( (/integer ::/), (/integer ::/) )
        call plcol0(1)
        call pllab('X Coordinate', 'Y Coordinate', &
               'Streamlines of flow')

        call plflush
    end subroutine plot5
end program x14f

!      Copyright (C) 2004-2016  Alan W. Irwin
!      Copyright (C) 2008  Andrew Ross
!
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!
!      plimage demo
!
!

!static PLOptionTable options[] = {
!{
!    "dbg",			/* extra debugging plot */
!    NULL,
!    NULL,
!    &dbg,
!    PL_OPT_BOOL,
!    "-dbg",
!    "Extra debugging plot" },
!{
!    "nosombrero",			/* Turns on test of xor function */
!    NULL,
!    NULL,
!    &nosombrero,
!    PL_OPT_BOOL,
!    "-nosombrero",
!    "No sombrero plot" },
!{
!    "nointeractive",			/* Turns on test of xor function */
!    NULL,
!    NULL,
!    &nointeractive,
!    PL_OPT_BOOL,
!    "-nointeractive",
!    "No interactive selection" },
!{
!    "save",			/* For saving in postscript */
!    NULL,
!    NULL,
!    &f_name,
!    PL_OPT_STRING,
!    "-save filename",
!      "Save sombrero plot in color postscript `filename'" },
!{
!    NULL,			/* option */
!    NULL,			/* handler */
!    NULL,			/* client data */
!    NULL,			/* address of variable to set */
!    0,				/* mode flag */
!    NULL,			/* short syntax */
!    NULL }			/* long syntax */
!};

program x20f
    use plplot, double_PI => PL_PI
    use iso_c_binding, only: c_ptr, c_loc, c_f_pointer

    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    integer, parameter          :: XDIM = 260, YDIM = 220
    real(kind=pl_test_flt), parameter :: XDIMR = XDIM, YDIMR = YDIM

    real(kind=pl_test_flt) ::  x(XDIM), y(YDIM), z(XDIM,YDIM), r(XDIM,YDIM)
    real(kind=pl_test_flt) ::  xi, yi, xe, ye
    integer i, j
    real(kind=pl_test_flt)  width_r, height_r

    !
    !     Dimensions taken from "Chloe.pgm"
    !
    integer width, height, num_col
    integer :: plparseopts_rc
    real(kind=pl_test_flt), dimension(:,:), pointer :: img_f
    real(kind=pl_test_flt), dimension(:,:), pointer :: xg, yg
    real(kind=pl_test_flt), dimension(:), pointer :: xg1, yg1
    real(kind=pl_test_flt) :: img_max, img_min

    real(kind=pl_test_flt) :: x0, y0, dy, stretch

    !
    !     Parameters from command-line
    !
    logical dbg
    logical nosombrero
    logical nointeractive
    character(len=80) f_name
    integer :: plgetcursor_rc
    real(kind=pl_test_flt) tr(6)

    ! Global parameters to be used in mypltr callback
    real(kind=pl_test_flt) :: xmin, xmax, ymin, ymax

    ! Use no callback?
    logical, parameter :: no_callback = .false.

    ! Use tr callback? (Only meaningful if no_callback is false.)
    logical, parameter :: tr_callback = .false.

    ! Use Fortran callback with no data? (Only meaningful
    ! if no_callback and tr_callback are both .false.).
    logical, parameter :: mypltr_callback = .false.

    type mypltr_data_type
        ! Only contains data required by the mypltr_data callback
        integer :: xpts_data, ypts_data
        real(kind=pl_test_flt) :: xmin_data, xmax_data, ymin_data, ymax_data
    end type mypltr_data_type

    ! Global data type to be used in mypltr_data callback
    type(mypltr_data_type), target :: data

    !     Parse and process command line arguments
    !
    !      call plMergeOpts(options, 'x20c options', NULL)

    dbg            = .false.
    nosombrero     = .false.
    nointeractive  = .false.
    f_name         = ' '
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !     Initialize plplot

    call plinit

    !     View image border pixels
    if (dbg) then
        call plenv(1._pl_test_flt, XDIMR, 1._pl_test_flt, YDIMR, 1, 1)

        z = 0.0_pl_test_flt

        !         Build a one pixel square border, for diagnostics
        do i = 1,XDIM
            !             Right
            z(i,YDIM) = 1._pl_test_flt
            !             Left
            z(i,1)    = 1._pl_test_flt
        enddo

        do i = 1,YDIM
            !             Top
            z(1,i)    = 1._pl_test_flt
            !             Bottom
            z(XDIM,i) = 1._pl_test_flt
        enddo

        call pllab('...around a blue square.',' '//PL_END_OF_STRING, &
               'A red border should appear...')

        call plimage(z, 1._pl_test_flt, XDIMR, 1._pl_test_flt, YDIMR, 0._pl_test_flt, 0._pl_test_flt, &
               1._pl_test_flt, XDIMR, 1._pl_test_flt, YDIMR)
    endif

    !     Sombrero-like demo
    if (.not. nosombrero) then
        !         draw a yellow plot box, useful for diagnostics! :(
        call plcol0(2)
        call plenv(0._pl_test_flt, 2._pl_test_flt*PI, 0.0_pl_test_flt, 3._pl_test_flt*PI, 1, -1)

        do i=1,XDIM
            x(i) = real(i-1,kind=pl_test_flt)*2._pl_test_flt*PI/real(XDIM-1,kind=pl_test_flt)
        enddo
        do i=1,YDIM
            y(i) = real(i-1,kind=pl_test_flt)*3._pl_test_flt*PI/real(YDIM-1,kind=pl_test_flt)
        enddo

        do i=1,XDIM
            do j=1,YDIM
                r(i,j) = sqrt(x(i)*x(i)+y(j)*y(j))+0.001_pl_test_flt
                z(i,j) = sin(r(i,j)) / (r(i,j))
            enddo
        enddo

        call pllab('No, an amplitude clipped "sombrero"', '', &
               'Saturn?')
        call plptex(2._pl_test_flt, 2._pl_test_flt, 3._pl_test_flt, 4._pl_test_flt, 0._pl_test_flt, 'Transparent image')
        call plimage(z, 0._pl_test_flt, 2._pl_test_flt*PI, 0.0_pl_test_flt, 3._pl_test_flt*PI, &
               0.05_pl_test_flt, 1._pl_test_flt, 0._pl_test_flt, 2._pl_test_flt*PI, 0._pl_test_flt, 3._pl_test_flt*PI)

        !         Save the plot
        if (f_name .ne. ' ') then
            call save_plot(f_name)
        endif
    endif

    !
    !     Read Chloe image
    !     Note we try two different locations to cover the case where this
    !     example is being run from the test_c.sh script
    !
    if (.not. read_img('Chloe.pgm', img_f, width, height, num_col)) then
        if (.not. read_img('../Chloe.pgm', img_f, width, height, num_col)) then
            !C            call plabort('No such file')
            write(*,*) 'Image could not be read'
            call plend()
            stop
        endif
    endif

    width_r  = real(width,kind=pl_test_flt)
    height_r = real(height,kind=pl_test_flt)

    ! Initialize callback data
    xmin = 0.0_pl_test_flt
    xmax = width_r
    ymin = 0.0_pl_test_flt
    ymax = height_r

    data%xpts_data = width
    data%ypts_data = height
    data%xmin_data = xmin
    data%xmax_data = xmax
    data%ymin_data = ymin
    data%ymax_data = ymax

    tr = (/ (xmax-xmin)/real(width-1,kind=pl_test_flt), 0.0_pl_test_flt, xmin, &
           0.0_pl_test_flt, (ymax-ymin)/real(height-1,kind=pl_test_flt), ymin /)

    !     Set gray colormap
    call gray_cmap(num_col)

    !     Display Chloe
    call plenv(1._pl_test_flt, width_r, 1._pl_test_flt, height_r, 1, -1)

    if (.not. nointeractive) then
        call pllab('Set and drag Button 1 to (re)set selection, Butto'// &
               'n 2 to finish.',' '//PL_END_OF_STRING,'Chloe...')
    else
        call pllab('',' '//PL_END_OF_STRING,'Chloe...')
    endif

    call plimage(img_f, 1._pl_test_flt, width_r, 1._pl_test_flt, &
           height_r, 0._pl_test_flt, 0._pl_test_flt, 1._pl_test_flt, width_r, 1._pl_test_flt, height_r)

    !     Selection/expansion demo
    if (.not. nointeractive) then
        xi = 25.0_pl_test_flt
        xe = 130.0_pl_test_flt
        yi = 235.0_pl_test_flt
        ye = 125.0_pl_test_flt

        if (get_clip(xi, xe, yi, ye)) then
            call plend()
            stop
        endif

        !
        !         I'm unable to continue, clearing the plot and advancing to the next
        !         one, without hiting the enter key, or pressing the button... help!
        !         Forcing the xwin driver to leave locate mode and destroying the
        !         xhairs (in GetCursorCmd()) solves some problems, but I still have
        !         to press the enter key or press Button-2 to go to next plot, even
        !         if a pladv() is not present!  Using plbop() solves the problem, but
        !         it shouldn't be needed!
        !
        !         plspause(0), pladv(0), plspause(1), also works,
        !         but the above question remains.
        !         With this approach, the previous pause state is lost,
        !         as there is no API call to get its current state.
        !

        call plspause(.false.)
        call pladv(0)

        !         Display selection only
        call plimage(img_f, 1._pl_test_flt, width_r, 1._pl_test_flt, &
               height_r, 0._pl_test_flt, 0._pl_test_flt, xi, xe, ye, yi)

        call plspause(.true.)

        !         Zoom in selection
        call plenv(xi, xe, ye, yi, 1, -1)
        call plimage(img_f, 1._pl_test_flt, width_r, 1._pl_test_flt, &
               height_r, 0._pl_test_flt, 0._pl_test_flt, xi, xe, ye, yi)
    endif

    !     Base the dynamic range on the image contents.

    call a2mnmx(img_f,width,height,img_min,img_max,width)

    call plcol0(2)
    call plenv(0._pl_test_flt, width_r, 0._pl_test_flt, height_r, 1, -1)
    call pllab("", "", "Reduced dynamic range image example")
    if(no_callback) then
        call plimagefr(img_f, 0._pl_test_flt, width_r, 0._pl_test_flt, &
               height_r, 0._pl_test_flt, 0._pl_test_flt, img_min + img_max * 0.25_pl_test_flt, &
               img_max - img_max * 0.25_pl_test_flt)
    elseif(tr_callback) then
        call plimagefr(img_f, 0._pl_test_flt, width_r, 0._pl_test_flt, &
               height_r, 0._pl_test_flt, 0._pl_test_flt, img_min + img_max * 0.25_pl_test_flt, &
               img_max - img_max * 0.25_pl_test_flt, tr)
    elseif(mypltr_callback) then
        call plimagefr(img_f, 0._pl_test_flt, width_r, 0._pl_test_flt, &
               height_r, 0._pl_test_flt, 0._pl_test_flt, img_min + img_max * 0.25_pl_test_flt, &
               img_max - img_max * 0.25_pl_test_flt, mypltr)
    else
        call plimagefr(img_f, 0._pl_test_flt, width_r, 0._pl_test_flt, &
               height_r, 0._pl_test_flt, 0._pl_test_flt, img_min + img_max * 0.25_pl_test_flt, &
               img_max - img_max * 0.25_pl_test_flt, mypltr_data, c_loc(data))
    endif

    !     Draw a distorted version of the original image, showing its
    !     full dynamic range.
    call plenv(0._pl_test_flt, width_r, 0._pl_test_flt, height_r, 1, -1)
    call pllab("", "", "Distorted image example")

    !     Populate the 2-d grids used for the distortion
    !     NB grids must be 1 larger in each dimension than the image
    !     since the coordinates are for the corner of each pixel.
    allocate( xg(width+1,height+1) )
    allocate( yg(width+1,height+1) )
    x0 = 0.5_pl_test_flt*width_r
    y0 = 0.5_pl_test_flt*height_r
    dy = 0.5_pl_test_flt*height_r
    stretch = 0.5_pl_test_flt
    do i=1,width+1
        do j=1,height+1
            xg(i,j) = x0 + (x0-real(i-1,kind=pl_test_flt))*(1.0_pl_test_flt - stretch* &
                   cos((real(j-1,kind=pl_test_flt)-y0)/dy*PI*0.5_pl_test_flt))
            yg(i,j) = real(j-1,kind=pl_test_flt)
        enddo
    enddo
    call plimagefr(img_f, 0._pl_test_flt, width_r, 0._pl_test_flt, &
           height_r, 0._pl_test_flt, 0._pl_test_flt, img_min, img_max, xg, yg)

    if(.false.) then
        ! Two test pages to compare undistorted results plotted with
        ! doubly dimensioned xg, yg, versus singly dimensioned xg1, yg1
        call plenv(0._pl_test_flt, width_r, 0._pl_test_flt, height_r, 1, -1)
        call pllab("", "", "Undistorted image example")

        do i=1,width+1
            do j=1,height+1
                xg(i,j) = real(i-1,kind=pl_test_flt)
                yg(i,j) = real(j-1,kind=pl_test_flt)
            enddo
        enddo
        call plimagefr(img_f, 0._pl_test_flt, width_r, 0._pl_test_flt, &
               height_r, 0._pl_test_flt, 0._pl_test_flt, img_min, img_max, xg, yg)

        call plenv(0._pl_test_flt, width_r, 0._pl_test_flt, height_r, 1, -1)
        call pllab("", "", "Undistorted image example")

        allocate( xg1(width+1) )
        allocate( yg1(height+1) )
        do i=1,width+1
            xg1(i) = real(i-1,kind=pl_test_flt)
        enddo
        do j=1,height+1
            yg1(j) = real(j-1,kind=pl_test_flt)
        enddo

        call plimagefr(img_f, 0._pl_test_flt, width_r, 0._pl_test_flt, &
               height_r, 0._pl_test_flt, 0._pl_test_flt, img_min, img_max, xg1, yg1)

        deallocate(xg1, yg1)
    end if

    deallocate( img_f, xg, yg )

    call plend()
    stop

contains

    ! Callback function that relies on global width, height, xmin, xmax, ymin, ymax
    subroutine mypltr( x, y, xt, yt )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt

        xt = xmin + ((xmax-xmin)/real(width-1,kind=pl_test_flt))*x
        yt = ymin + ((ymax-ymin)/real(height-1,kind=pl_test_flt))*y

    end subroutine mypltr

    ! Callback function that uses data argument to pass required data.
    subroutine mypltr_data( x, y, xt, yt, data )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt
        type(c_ptr), intent(in) :: data

        type(mypltr_data_type), pointer :: d
        call c_f_pointer(data, d)

        xt = d%xmin_data + ((d%xmax_data-d%xmin_data)/real(d%xpts_data-1,kind=pl_test_flt))*x
        yt = d%ymin_data + ((d%ymax_data-d%ymin_data)/real(d%ypts_data-1,kind=pl_test_flt))*y

    end subroutine mypltr_data

!     Determine the unit of length (of 8 or less) for direct-access files
    subroutine bytes_in_rec( bytes )
        implicit none
        integer     bytes

        character(len=8) string
        integer     ierr

        open( 10, file = '_x20f_.bin', access = 'direct', recl = 1 )

        string = "12345678"
        bytes = 0
        ierr = 0
        do while(ierr == 0 .and. bytes < 8)
            bytes = bytes + 1
            write( 10, rec = 1, iostat = ierr ) string(1:bytes)
        enddo
        if(ierr /= 0) bytes = bytes -1

        close( 10, status = 'delete' )

    end subroutine bytes_in_rec


    !     Read image from file in binary ppm format
    logical function read_img(fname, img_f, width, height, num_col)

        character(*), intent(in)                  :: fname
        integer, intent(out)                      :: width, height
        real(kind=pl_test_flt), dimension(:,:), pointer :: img_f
        integer      num_col

        character, dimension(8) :: img
        character(len=80), dimension(2) :: ver
        integer ::  i, j, w, h, b

        integer :: ierr
        integer ::  count
        integer ::  record

        integer ::  bytes = 0
        integer ::  lastlf = 0
        integer ::  first
        integer ::  last
        integer ::  pixel

        !     Naive grayscale binary ppm reading. If you know how to, improve it

        open( 10, file = fname, status = 'old', iostat = ierr )

        if (ierr .ne. 0 ) then
            read_img = .false.
            return
        endif

        !
        !     Read the first lines (count them for later re-reading)
        !
        count = 1
        read( 10, '(a)', iostat = ierr ) ver(1)

        !     I only understand "P5"!
        if (ver(1) .ne. 'P5' .or. ierr .ne. 0) then
            read_img = .false.
            return
        endif

        do
            count = count + 1
            read( 10, '(a)', iostat = ierr ) ver(1)

            if (ierr .ne. 0) then
                read_img = .false.
                write(*,*) 'Error!'
                return
            endif

            if (ver(1)(1:1) .ne. '#' ) then
                exit
            endif
        enddo

        !     Found the line with the sizes, copy this one and the next

        count = count + 1
        read( 10, '(a)', iostat = ierr ) ver(2)

        read( ver(1), * ) w, h
        read( ver(2), * ) num_col

        allocate( img_f(w,h) )

        close( 10 )

        !
        !     Read the second part - we need to do it the hard way :(
        !
        !     Note:
        !     The algorithm works if the unit of record length is a byte or
        !     if it is a multiple therefore (up to 8 bytes are allowed).
        !     Background: Some compilers use a word (4 bytes) as the unit of
        !     length instead, but often provide a compile switch to use bytes,
        !     we can not rely on this though.
        !
        call bytes_in_rec( bytes )

        open( 10, file = fname, access = 'direct', recl = 1 )

        record = 0
        do while ( count > 0 )
            !
            !     Look for the end of the line with sizes
            !
            record = record + 1
            read( 10, rec = record, iostat = ierr ) (img(i), i = 1,bytes )
            if ( ierr .ne. 0 ) then
                exit
            endif

            do i = 1,bytes
                if ( img(i) == char(10) ) then
                    count  = count - 1
                    lastlf = i
                endif
            enddo
        enddo

        !
        !     We have found the picture bytes!
        !     The picture needs to be flipped vertically.
        !     So do that rightaway
        !
        first = lastlf + 1
        last  = bytes
        pixel = 0

        do
            do b = first, last
                pixel = pixel + 1
                if ( pixel <= h*w ) then
                    i     = 1 + mod(pixel-1,w)
                    j     = 1 + (pixel-1)/w
                    img_f(i,h-j+1) = real(ichar(img(b),kind=pl_test_flt))
                endif
            enddo
            if ( pixel < h*w ) then
                record = record + 1
                read( 10, rec = record ) (img(b), b = 1,bytes )
                first  = 1
            else
                exit
            endif
        enddo

        width  = w
        height = h
        read_img = .true.

    end function read_img

    !     Save plot
    subroutine save_plot(fname)

        character*(*) fname

        integer cur_strm, new_strm

        !     Get current stream
        call plgstrm(cur_strm)

        !     Create a new one
        call plmkstrm(new_strm)

        !     New device type. Use a known existing driver
        call plsdev('psc')
        call plsfnam(fname)

        !     Copy old stream parameters to new stream
        call plcpstrm(cur_strm, .false.)
        call plreplot()
        call plend1()

        !     Return to previous one
        call plsstrm(cur_strm)

    end subroutine save_plot

    !     Get selection square interactively
    logical function get_clip(xi, xe, yi, ye)

        real(kind=pl_test_flt) xi, xe, yi, ye

        type(PLGraphicsIn) :: gin
        real(kind=pl_test_flt) :: xxi, yyi, xxe, yye, t
        logical st, start
        real(kind=pl_test_flt) sx(5), sy(5)

        integer PLK_Return
        data PLK_Return / Z'0D' /
        integer hex100
        data hex100 / Z'100' /

        xxi = xi
        yyi = yi
        xxe = xe
        yye = ye
        start = .false.

        !     Enter xor mode to draw a selection rectangle
        call plxormod(.true., st)

        !     Driver has xormod capability, continue
        if (st) then
            do while (.true.)

                call plxormod(.false., st)
                plgetcursor_rc = plgetcursor(gin)
                call plxormod(.true., st)

                if (gin%button .eq. 1) then
                    xxi = gin%wX
                    yyi = gin%wY
                    if (start) then
                        !                 Clear previous rectangle
                        call plline(sx, sy)
                    endif

                    start = .false.

                    sx(1) = xxi
                    sy(1) = yyi
                    sx(5) = xxi
                    sy(5) = yyi
                endif

                if (iand(gin%state,hex100).ne.0) then
                    xxe = gin%wX
                    yye = gin%wY
                    if (start) then
                        !                 Clear previous rectangle
                        call plline(sx, sy)
                    endif
                    start = .true.

                    sx(3) = xxe
                    sy(3) = yye
                    sx(2) = xxe
                    sy(2) = yyi
                    sx(4) = xxi
                    sy(4) = yye
                    !              Draw new rectangle
                    call plline(sx, sy)
                endif

                if ((gin%button .eq. 3).or.(gin%keysym .eq. PLK_Return).or.(gin%keysym .eq. ichar('Q'))) then
                    if (start) then
                        !                 Clear previous rectangle
                        call plline(sx, sy)
                        exit
                    endif
                endif
            enddo

            !         Leave xor mode
            call plxormod(.false., st)

            if (xxe .lt. xxi) then
                t   = xxi
                xxi = xxe
                xxe = t
            endif

            if (yyi .lt. yye) then
                t   = yyi
                yyi = yye
                yye = t
            endif

            xe = xxe
            xi = xxi
            ye = yye
            yi = yyi

            get_clip = (gin%keysym .eq. ichar('Q'))
            !          get_clip = .false.
        else
            !         driver has no xormod capability, just do nothing
            get_clip = .false.
            return
        endif

    end function get_clip

    !     Set gray colormap
    subroutine gray_cmap(num_col)

        integer num_col
        real(kind=pl_test_flt) r(2), g(2), b(2), pos(2)
        logical rev(1)

        r(1) = 0.0
        g(1) = 0.0
        b(1) = 0.0
        r(2) = 1.0
        g(2) = 1.0
        b(2) = 1.0

        pos(1) = 0.0
        pos(2) = 1.0
        rev(1) = .false.

        call plscmap1n(num_col)
        call plscmap1l(.true., pos, r, g, b, rev)

    end subroutine gray_cmap


    !----------------------------------------------------------------------------
    !      Subroutine a2mmx
    !      Minimum and the maximum elements of a 2-d array.

    subroutine a2mnmx(f, nx, ny, fmin, fmax, xdim)
        use plplot
        implicit none

        integer   i, j, nx, ny, xdim
        real(kind=pl_test_flt)    f(xdim, ny), fmin, fmax

        fmax = f(1, 1)
        fmin = fmax
        do j = 1, ny
            do  i = 1, nx
                fmax = max(fmax, f(i, j))
                fmin = min(fmin, f(i, j))
            enddo
        enddo
    end subroutine a2mnmx

end program x20f

!   Contour plot demo.
!
!   Copyright (C) 2004-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!   Does several contour plots using different coordinate mappings.

program x09f
    use plplot, double_PI => PL_PI, double_TWOPI => PL_TWOPI
    use plfortrandemolib
    use iso_c_binding, only: c_ptr, c_loc, c_f_pointer
    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    real(kind=pl_test_flt), parameter :: TWOPI = double_TWOPI
    integer i, j

    !   xdim and ydim are the absolute static dimensions.
    !   nptsx, and nptsy are the (potentially dynamic) defined area of the 2D
    !   arrays that is actually used.
    integer, parameter :: xdim=99, ydim=100, nptsx=35, nptsy=46
    integer :: plparseopts_rc

    real(kind=pl_test_flt)   :: z(xdim, ydim), w(xdim, ydim), &
           xg1(xdim), yg1(ydim), &
           xg2(xdim, ydim), yg2(xdim, ydim)
    real(kind=pl_test_flt)   :: xc(nptsx), yc(nptsy)
    real(kind=pl_test_flt)   :: xx, yy, argx, argy, distort
    real(kind=pl_test_flt)   :: tr(6)

    real(kind=pl_test_flt)   :: clevel(11) = &
           (/ -1._pl_test_flt, -0.8_pl_test_flt, -0.6_pl_test_flt, -0.4_pl_test_flt, -0.2_pl_test_flt, &
           0._pl_test_flt,  0.2_pl_test_flt,  0.4_pl_test_flt,  0.6_pl_test_flt,  0.8_pl_test_flt, 1._pl_test_flt /)

    type mypltr_data_type
        ! Only contains data required by the mypltr_data callback
        real(kind=pl_test_flt), dimension(6) :: tr_data
    end type mypltr_data_type

    type(mypltr_data_type), target :: data

    ! Use tr plcont callback?
    logical, parameter :: tr_callback = .false.
    ! Use pltr0 (identity transformation) callback? (only meaningful
    ! if tr_callback is .false.).
    logical, parameter :: identity_callback = .false.

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    tr = (/ 2._pl_test_flt/real(nptsx-1,kind=pl_test_flt), 0.0_pl_test_flt, -1.0_pl_test_flt, &
           0.0_pl_test_flt, 2._pl_test_flt/real(nptsy-1,kind=pl_test_flt), -1.0_pl_test_flt /)

    !   Calculate the data matrices.
    xc = (arange(nptsx) - (nptsx/2)) / real(nptsx/2,kind=pl_test_flt)
    yc = (arange(nptsy) - (nptsy/2)) / real(nptsy/2,kind=pl_test_flt) - 1.0_pl_test_flt

    do i=1,nptsx
        do j=1,nptsy
            z(i,j) = xc(i)**2 - yc(j)**2
            w(i,j) = 2._pl_test_flt*xc(i)*yc(j)
        enddo
    enddo

    !   Build the 1-d coord arrays.
    distort = 0.4_pl_test_flt

    xg1(1:nptsx) = coord_function( arange(nptsx) / real(nptsx-1,kind=pl_test_flt),  distort )
    yg1(1:nptsy) = coord_function( arange(nptsy) / real(nptsy-1,kind=pl_test_flt), -distort )

    !   Build the 2-d coord arrays.
    do i=1,nptsx
        xx = -1._pl_test_flt + real(i-1,kind=pl_test_flt)*2._pl_test_flt/real(nptsx-1,kind=pl_test_flt)
        argx = 0.5_pl_test_flt*PI*xx
        do j=1,nptsy
            yy = -1._pl_test_flt + real(j-1,kind=pl_test_flt)*2._pl_test_flt/real(nptsy-1,kind=pl_test_flt)
            argy = 0.5_pl_test_flt*PI*yy
            xg2(i,j) = xx + distort*cos(argx)*cos(argy)
            yg2(i,j) = yy - distort*cos(argx)*cos(argy)
        enddo
    enddo

    call plinit

    !   Plot using identity transform
    call pl_setcontlabelformat(4, 3)
    call pl_setcontlabelparam(0.006_pl_test_flt, 0.3_pl_test_flt, 0.1_pl_test_flt, 1)
    if(.not. tr_callback .and. identity_callback) then
        call plenv( &
               real(0,kind=pl_test_flt), real(nptsx-1,kind=pl_test_flt), &
               real(0,kind=pl_test_flt), real(nptsy-1,kind=pl_test_flt), 0, 0)
    else
        call plenv(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, 0, 0)
    endif
    call plcol0(2)
    if(tr_callback) then
        call plcont(z(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, tr)
    elseif(identity_callback) then
        call plcont(z(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel)
    else
        data%tr_data = tr
        call plcont(z(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, mypltr_data, c_loc(data))
    endif
    call plstyl( (/1500/), (/1500/) )
    call plcol0(3)
    if(tr_callback) then
        call plcont(w(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, tr)
    elseif(identity_callback) then
        call plcont(w(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel)
    else
        call plcont(w(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, mypltr)
    endif
    call plstyl( (/integer ::/), (/integer ::/) )
    call plcol0(1)
    call pllab('X Coordinate', 'Y Coordinate', 'Streamlines of flow')
    call pl_setcontlabelparam(0.006_pl_test_flt, 0.3_pl_test_flt, 0.1_pl_test_flt, 0)

    !   Plot using 1d coordinate transform
    call plenv(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, 0, 0)
    call plcol0(2)
    call plcont(z(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, xg1(1:nptsx), yg1(1:nptsy))
    call plstyl( (/1500/), (/1500/) )
    call plcol0(3)
    call plcont(w(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, xg1(1:nptsx), yg1(1:nptsy))
    call plstyl( (/integer ::/), (/integer ::/) )
    call plcol0(1)
    call pllab('X Coordinate', 'Y Coordinate', 'Streamlines of flow')

    !   Plot using 2d coordinate transform
    call plenv(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, 0, 0)
    call plcol0(2)
    call plcont(z(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, xg2(1:nptsx,1:nptsy), yg2(1:nptsx,1:nptsy))
    call plstyl( (/1500/), (/1500/) )
    call plcol0(3)
    call plcont(w(1:nptsx,1:nptsy), 1, nptsx, 1, nptsy, clevel, xg2(1:nptsx,1:nptsy), yg2(1:nptsx,1:nptsy))
    call plstyl( (/integer ::/), (/integer ::/) )
    call plcol0(1)
    call pllab('X Coordinate', 'Y Coordinate', 'Streamlines of flow')

    call polar()
    call potential()

    call plend
contains

    !----------------------------------------------------------------------------
    !   Auxiliary function to compute the coordinates

    elemental real(kind=pl_test_flt) function coord_function( coord, factor )
        real(kind=pl_test_flt), intent(in) :: coord
        real(kind=pl_test_flt), intent(in) :: factor

        real(kind=pl_test_flt)             :: tcoord

        tcoord         = -1.0_pl_test_flt + coord * 2.0_pl_test_flt
        coord_function = tcoord + factor*cos(0.5_pl_test_flt*PI*tcoord)
    end function coord_function

    ! Callback function that relies on global tr.
    subroutine mypltr( x, y, xt, yt )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt

        xt = tr(1) * x + tr(2) * y + tr(3)
        yt = tr(4) * x + tr(5) * y + tr(6)

    end subroutine mypltr

    ! Callback function that uses data argument to pass tr information.
    subroutine mypltr_data( x, y, xt, yt, data )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt
        type(c_ptr), intent(in) :: data

        type(mypltr_data_type), pointer :: d
        call c_f_pointer(data, d)

        xt = d%tr_data(1) * x + d%tr_data(2) * y + d%tr_data(3)
        yt = d%tr_data(4) * x + d%tr_data(5) * y + d%tr_data(6)

    end subroutine mypltr_data

    !----------------------------------------------------------------------------
    !   polar contour plot example.
    subroutine polar()
        integer, parameter :: PERIMETERPTS = 100

        !   xdim and ydim are the absolute static size of the 2D arrays.
        !   RPTS and THETAPTS are associated with the part of the
        !   2D arrays that are defined.
        integer, parameter :: xdim=99, RPTS = 40
        integer, parameter :: ydim=100, THETAPTS = 40
        integer, parameter :: NLEVEL=10
        integer            :: i,j
        real(kind=pl_test_flt)   :: xg(xdim, ydim),  yg(xdim, ydim), &
               z(xdim, ydim), px(PERIMETERPTS), py(PERIMETERPTS), &
               lev(NLEVEL), r, theta, delta

        call plenv(-1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, 1._pl_test_flt, 0, -2)
        call plcol0(1)

        !   perimeter.
        delta = 2._pl_test_flt*PI/(PERIMETERPTS-1)
        px = cos(delta*arange(PERIMETERPTS))
        py = sin(delta*arange(PERIMETERPTS))

        call plline(px, py)

        !   create data to be contoured.
        do j = 1, THETAPTS
            theta = (2._pl_test_flt*PI/real(THETAPTS-1,kind=pl_test_flt))*real(j-1,kind=pl_test_flt)
            do i = 1, RPTS
                r = (i-1)/real(RPTS-1,kind=pl_test_flt)
                xg(i,j) = r*cos(theta)
                yg(i,j) = r*sin(theta)
                z(i,j) = r
            enddo
        enddo

        !   create contour values.
        lev = 0.05_pl_test_flt + 0.10_pl_test_flt * arange(nlevel)

        !   plot the (polar) contours.
        call plcol0(2)
        call plcont(z, 1, RPTS, 1, THETAPTS, lev, xg, yg)
        call plcol0(1)
        call pllab('', '', 'Polar Contour Plot')
    end subroutine polar

    !----------------------------------------------------------------------------
    !    shielded potential contour plot example
    subroutine potential()

        integer          :: i, j, nx, ny, kx, lx, ky, ly, &
               nlevel, ilevgt, ilevlt, nlevlt, nlevgt, &
               ncollin, ncolbox, ncollab, &
               nxsub, nysub
        real(kind=pl_test_flt) :: r, theta, rmax, x0, &
               y0, xmin, xmax, eps, q1, d1, &
               ymin, ymax, &
               q1i, d1i, q2, d2, q2i, d2i, div1, div1i, div2, div2i, &
               zmin, zmax, dz, xpmin, xpmax, ypmin, ypmax, &
               xtick, ytick, delta

        !    xdim and ydim are the absolute static size of the 2D arrays.
        !    NCX and NCY are associated with the part of the
        !    2D arrays that are defined.
        integer, parameter :: xdim=99, NCX=40, ydim=100, NCY=64, NPLT=100

        real(kind=pl_test_flt)   :: z(xdim, ydim), ztmp(xdim, ydim+1)
        real(kind=pl_test_flt)   :: xg(xdim, ydim+1), yg(xdim, ydim+1), xtm(NPLT), ytm(NPLT)

        real(kind=pl_test_flt)   :: clevel(20)
        character(len=8)   :: xopt, yopt

        nx = NCX
        ny = NCY

        kx = 1
        lx = nx
        ky = 1
        ly = ny

        !    Set up r-theta grids
        !    Tack on extra cell in theta to handle periodicity.

        do i = 1, nx
            r = i - 0.5_pl_test_flt
            do j = 1, ny
                theta = TWOPI/real(ny-1,kind=pl_test_flt) * (j-0.5_pl_test_flt)
                xg(i,j) = r * cos(theta)
                yg(i,j) = r * sin(theta)
            enddo
            xg(i, ny+1) = xg(i, 1)
            yg(i, ny+1) = yg(i, 1)
        enddo

        xmax = maxval( xg(1:nx,1:ny) )
        xmin = minval( xg(1:nx,1:ny) )
        ymax = maxval( yg(1:nx,1:ny) )
        ymin = minval( yg(1:nx,1:ny) )

        rmax = r
        x0 = (xmin + xmax)/2._pl_test_flt
        y0 = (ymin + ymax)/2._pl_test_flt

        !    Potential inside a conducting cylinder (or sphere) by method of images.
        !    Charge 1 is placed at (d1, d1), with image charge at (d2, d2).
        !    Charge 2 is placed at (d1, -d1), with image charge at (d2, -d2).
        !    Also put in smoothing term at small distances.

        eps = 2._pl_test_flt

        q1 = 1._pl_test_flt
        d1 = r/4._pl_test_flt

        q1i = - q1*r/d1
        d1i = r**2/d1

        q2 = -1._pl_test_flt
        d2 = r/4._pl_test_flt

        q2i = - q2*r/d2
        d2i = r**2/d2

        do i = 1, nx
            do j = 1, ny
                div1  = sqrt((xg(i,j)-d1)**2  + (yg(i,j)-d1)**2  + eps**2)
                div1i = sqrt((xg(i,j)-d1i)**2 + (yg(i,j)-d1i)**2 + eps**2)

                div2  = sqrt((xg(i,j)-d2)**2  + (yg(i,j)+d2)**2  + eps**2)
                div2i = sqrt((xg(i,j)-d2i)**2 + (yg(i,j)+d2i)**2 + eps**2)

                z(i,j) = q1/div1 + q1i/div1i + q2/div2 + q2i/div2i
            enddo
        enddo

        !   Tack on extra cell in theta to handle periodicity.

        ztmp(:,1:ny) = z
        ztmp(:,ny+1:ny+1) = z(:,1:1)

        zmax = maxval( z(1:nx,1:ny) )
        zmin = minval( z(1:nx,1:ny) )

        !   Set up contour levels.

        nlevel = 20
        dz = abs(zmax - zmin)/real(nlevel,kind=pl_test_flt)
        clevel(1:nlevel) = zmin + (arange(1,nlevel+1) - 0.5_pl_test_flt) * dz

        !   Split contours into two parts, z > 0, and z < 0.
        !   Dashed contours will be at levels 'ilevlt' through 'ilevlt+nlevlt'.
        !   Solid  contours will be at levels 'ilevgt' through 'ilevgt+nlevgt'.
        !
        !   Since the array clevel is ordered, we can find the level
        !   where the values become positive by counting the non-positive
        !   elements

        ilevlt = 1
        nlevlt = count( clevel(1:nlevel) <= 0.0_pl_test_flt )
        ilevgt = ilevlt + nlevlt
        nlevgt = nlevel - nlevlt

        !   Advance graphics frame and get ready to plot.

        ncollin = 11
        ncolbox = 1
        ncollab = 2

        call pladv(0)
        call plcol0(ncolbox)

        !   Scale window to user coordinates.
        !   Make a bit larger so the boundary doesn't get clipped.

        eps = 0.05_pl_test_flt
        xpmin = xmin - abs(xmin)*eps
        xpmax = xmax + abs(xmax)*eps
        ypmin = ymin - abs(ymin)*eps
        ypmax = ymax + abs(ymax)*eps

        call plvpas(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt, 1.0_pl_test_flt )
        call plwind(xpmin, xpmax, ypmin, ypmax)

        xopt = ' '
        yopt = ' '
        xtick = 0._pl_test_flt
        nxsub = 0
        ytick = 0._pl_test_flt
        nysub = 0

        call plbox(xopt, xtick, nxsub, yopt, ytick, nysub)

        !   Call plotter once for z < 0 (dashed), once for z > 0 (solid lines).

        call plcol0(ncollin)
        if (nlevlt > 0) then
            call pllsty(2)
            call plcont(ztmp, kx, lx, ky, ly+1, &
                   clevel(ilevlt:nlevlt), xg, yg)
        endif
        if (nlevgt > 0) then
            call pllsty(1)
            call plcont(ztmp, kx, lx, ky, ly+1, &
                   clevel(ilevgt:ilevgt-1+nlevgt), xg, yg)
        endif

        !   Draw boundary.

        delta = TWOPI/(NPLT-1)
        xtm = x0 + rmax * cos(delta*arange(NPLT))
        ytm = y0 + rmax * sin(delta*arange(NPLT))

        call plcol0(ncolbox)
        call plline(xtm, ytm)

        call plcol0(ncollab)
        call pllab('', '', 'Shielded potential of charges in a conducting sphere')
    end subroutine potential
end program x09f

!   Sample plots using date / time formatting for axes
!
!   Copyright (C) 2008  Andrew Ross
!   Copyright (C) 2008-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!

program x29f
    use plplot
    implicit none

    integer, parameter :: double = kind(1.0d0)
    integer :: plparseopts_rc

    real(kind=double), parameter :: PI = PL_PI

    real(kind=pl_test_flt), dimension(365) :: x, y, xerr1, xerr2, yerr1, yerr2

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plinit()

    !  This is the ASCII value for character @
    call plsesc(64)

    call plot1()
    call plot2()
    call plot3()
    call plot4()

    call plend()

contains


    !====================================================================
    !
    !     Plot a model diurnal cycle of temperature

    subroutine plot1()


        integer :: i, npts
        real(kind=pl_test_flt) :: xmin, xmax, ymin, ymax

        parameter(npts = 73)
        parameter(xmin = 0.0_pl_test_flt)
        parameter(xmax = 60.0_pl_test_flt*60.0_pl_test_flt*24.0_pl_test_flt)
        parameter(ymin = 10.0_pl_test_flt)
        parameter(ymax = 20.0_pl_test_flt)

        do i = 1,npts
            x(i) = xmax*(real(i-1,kind=pl_test_flt)/real(npts,kind=pl_test_flt))
            y(i) = 15.0_pl_test_flt - 5.0_pl_test_flt* &
                   cos(2.0_pl_test_flt*PI*real(i-1,kind=pl_test_flt)/ &
                   real(npts,kind=pl_test_flt))
            !     Set x error bars to +/- 5 minute
            xerr1(i) = x(i)-60.0_pl_test_flt*5.0_pl_test_flt
            xerr2(i) = x(i)+60.0_pl_test_flt*5.0_pl_test_flt
            !     Set y error bars to +/- 0.1 deg C
            yerr1(i) = y(i)-0.1_pl_test_flt
            yerr2(i) = y(i)+0.1_pl_test_flt
        enddo

        call pladv(0)

        !     Rescale major ticks marks by 0.5
        call plsmaj(0.0_pl_test_flt,0.5_pl_test_flt)
        !     Rescale minor ticks and error bar marks by 0.5
        call plsmin(0.0_pl_test_flt,0.5_pl_test_flt)

        call plvsta()
        call plwind(xmin, xmax, ymin, ymax)

        !     Draw a box with ticks spaced every 3 hour in X and 1 degree C in Y.
        call plcol0(1)
        !     Set time format to be hours:minutes
        call pltimefmt("%H:%M")
        call plbox("bcnstd", 3.0_pl_test_flt*60.0_pl_test_flt*60.0_pl_test_flt, 3, "bcnstv", &
               1.0_pl_test_flt, 5)

        call plcol0(3)
        call pllab("Time (hours:mins)", "Temperature (degC)", &
               "@frPLplot Example 29 - Daily temperature")

        call plcol0(4)

        call plline(x(1:npts), y(1:npts))
        call plcol0(2)
        call plerrx(xerr1(1:npts), xerr2(1:npts), y(1:npts))
        call plcol0(3)
        call plerry(x(1:npts), yerr1(1:npts), yerr2(1:npts))

        !     Rescale major / minor tick marks back to default
        call plsmin(0.0_pl_test_flt,1.0_pl_test_flt)
        call plsmaj(0.0_pl_test_flt,1.0_pl_test_flt)

    end subroutine plot1

    !
    !     Plot the number of hours of daylight as a function of day for a year
    !
    subroutine plot2()

        integer ::  j, npts
        real(kind=pl_test_flt) :: xmin, xmax, ymin, ymax
        real(kind=pl_test_flt) :: lat, p, d


        ! Latitude for London
        parameter (lat = 51.5_pl_test_flt)

        parameter (npts = 365)

        parameter(xmin = 0.0_pl_test_flt)
        parameter(xmax = npts*60.0_pl_test_flt*60.0_pl_test_flt*24.0_pl_test_flt)
        parameter(ymin = 0)
        parameter(ymax = 24)

        !     Formula for hours of daylight from
        !     "A Model Comparison for Daylength as a Function of Latitude and
        !     Day of the Year", 1995, Ecological Modelling, 80, pp 87-95.
        do j=1,npts
            x(j) = (j-1)*60.0_pl_test_flt*60.0_pl_test_flt*24.0_pl_test_flt
            p = asin(0.39795_pl_test_flt*cos(0.2163108_pl_test_flt + 2.0_pl_test_flt* &
                   atan(0.9671396_pl_test_flt*tan(0.00860_pl_test_flt*(j-187)))))
            d = 24.0_pl_test_flt - (24.0_pl_test_flt/PI)* &
                   acos( (sin(0.8333_pl_test_flt*PI/180.0_pl_test_flt) + &
                   sin(lat*PI/180.0_pl_test_flt)*sin(p)) / (cos(lat*PI/180.0_pl_test_flt)* &
                   cos(p)) )
            y(j) = d
        enddo

        call plcol0(1)
        !     Set time format to be abbreviated month name followed by day of month
        call pltimefmt("%b %d")
        call plprec(1,1)
        call plenv(xmin, xmax, ymin, ymax, 0, 40)

        call plcol0(3)
        call pllab("Date", "Hours of daylight", &
               "@frPLplot Example 29 - Hours of daylight at 51.5N")

        call plcol0(4)

        call plline(x, y)

        call plprec(0,0)

    end subroutine plot2

    !
    !
    !
    subroutine plot3()

        integer :: i, npts
        real(kind=pl_test_flt) :: xmin, xmax, ymin, ymax
        integer :: tstart

        parameter (npts = 62)

        !     number of seconds elapsed since the Unix epoch (1970-01-01, UTC) for
        !     2005-12-01, UTC.  This is the same result as the Python
        !     calendar.timegm((2005,12,1,0,0,0)) result or the Linux C timegm
        !     result corresponding to 2005-12-01.
        tstart = 1133395200

        xmin = real(tstart,kind=pl_test_flt)
        xmax = xmin + npts*60.0_pl_test_flt*60.0_pl_test_flt*24.0_pl_test_flt
        ymin = 0.0_pl_test_flt
        ymax = 5.0_pl_test_flt

        do i=1,npts
            x(i) = xmin + real(i-1,kind=pl_test_flt)*60.0_pl_test_flt*60.0_pl_test_flt*24.0_pl_test_flt
            y(i) = 1.0_pl_test_flt + &
                   sin( 2.0_pl_test_flt*PI*real(i-1,kind=pl_test_flt)/7.0_pl_test_flt) + &
                   exp( real(min(i-1,npts+1-i),kind=pl_test_flt) / 31.0_pl_test_flt)
        enddo
        call pladv(0)

        call plvsta()
        call plwind(xmin, xmax, ymin, ymax)

        call plcol0(1)
        !     Set time format to be ISO 8601 standard YYYY-MM-DD. Note that this is
        !     equivalent to %f for C99 compliant implementations of strftime.
        call pltimefmt("%Y-%m-%d")
        !     Draw a box with ticks spaced every 14 days in X and 1 hour in Y.
        call plbox("bcnstd", 14.0_pl_test_flt*24.0_pl_test_flt*60.0_pl_test_flt*60.0_pl_test_flt,14, &
               "bcnstv", 1.0_pl_test_flt, 4)

        call plcol0(3)
        call pllab("Date", "Hours of television watched", &
               "@frPLplot Example 29 - Hours of television watched in " // &
               "Dec 2005 / Jan 2006")

        call plcol0(4)

        call plssym(0.0_pl_test_flt, 0.5_pl_test_flt)
        call plpoin(x(1:npts), y(1:npts), 2)
        call plline(x(1:npts), y(1:npts))

    end subroutine plot3

    !
    !
    !
    subroutine plot4()
        !     TAI-UTC (seconds) as a function of time.

        real(kind=pl_test_flt) :: scale
        real(kind=pl_test_flt) :: xmin, xmax, ymin, ymax, xlabel_step
        integer :: k, npts = 0, i
        logical :: if_TAI_time_format = .false.
        character(len=10) :: time_format
        character(len=100) :: title_suffix
        character(len=100) :: xtitle
        character(len=100) :: title
        real(kind=pl_test_flt) :: x(1001), y(1001)
        integer :: epoch_year, epoch_month, epoch_day, epoch_hour, epoch_min
        real(kind=pl_test_flt) :: epoch_sec
        integer :: tai_year, tai_month, tai_day, tai_hour, tai_min
        real(kind=pl_test_flt) :: tai_sec, tai
        integer :: utc_year, utc_month, utc_day, utc_hour, utc_min
        real(kind=pl_test_flt) :: utc_sec, utc

        ! Continuous time unit is Besselian years from whatever epoch is
        ! chosen below.  Could change to seconds (or days) from the
        ! epoch, but then would have to adjust xlabel_step below.
        scale = 365.242198781_pl_test_flt
        ! MJD epoch (see <https://en.wikipedia.org/wiki/Julian_day>).
        ! This is only set for illustrative purposes, and is overwritten
        ! below for the time-representation reasons given in the
        ! discussion below.
        epoch_year  = 1858
        epoch_month = 11
        epoch_day   = 17
        epoch_hour  = 0
        epoch_min   = 0
        epoch_sec   = 0._pl_test_flt
        ! To illustrate the time-representation issues of using the
        ! MJD epoch, in 1985, MJD was roughly 46000 days which
        ! corresponds to 4e9 seconds.  Thus, for the case where
        ! pl_test_flt corresponds to double precision which can
        ! represent continuous time to roughly 16 decimal digits of
        ! precision, the time-representation error is roughly ~400
        ! nanoseconds.  Therefore the MJD epoch would be acceptable
        ! for the plots below when pl_test_flt corresponds to double
        ! precision.  However, that epoch is obviously not acceptable
        ! for the case where pl_test_flt corresponds to single
        ! precision which can represent continuous time to only ~7
        ! decimal digits of precision corresponding to a time
        ! representation error of 400 seconds (!)  in 1985.  For this
        ! reason, we do not use the MJD epoch below and instead choose
        ! the best epoch for each case to minimize time-representation
        ! issues.

        do k = 0,6
            if (k .eq. 0) then
                ! Choose midpoint to maximize time-representation precision.
                epoch_year  = 1985
                epoch_month = 0
                epoch_day   = 2
                epoch_hour  = 0
                epoch_min   = 0
                epoch_sec   = 0._pl_test_flt
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 0, .true., &
                       epoch_year, epoch_month, epoch_day, epoch_hour, epoch_min, epoch_sec )
                call plctime(1950,0,2,0,0,0._pl_test_flt,xmin)
                call plctime(2020,0,2,0,0,0._pl_test_flt,xmax)
                npts = 70*12 + 1
                ymin = 0.0_pl_test_flt
                ymax = 36.0_pl_test_flt
                time_format="%Y%"
                if_TAI_time_format = .true.
                title_suffix = "from 1950 to 2020"
                xtitle =  "Year"
                xlabel_step = 10.0_pl_test_flt
            elseif ((k .eq. 1) .or. (k .eq. 2)) then
                ! Choose midpoint to maximize time-representation precision.
                epoch_year  = 1961
                epoch_month = 7
                epoch_day   = 1
                epoch_hour  = 0
                epoch_min   = 0
                epoch_sec   = 1.64757_pl_test_flt
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 0, .true., &
                       epoch_year, epoch_month, epoch_day, epoch_hour, epoch_min, epoch_sec )
                call plctime(1961,7,1,0,0,1.64757_pl_test_flt-.20_pl_test_flt, xmin)
                call plctime(1961,7,1,0,0,1.64757_pl_test_flt+.20_pl_test_flt, xmax)
                npts = 1001
                ymin = 1.625_pl_test_flt
                ymax = 1.725_pl_test_flt
                time_format = "%S%2%"
                title_suffix = "near 1961-08-01 (TAI)"
                xlabel_step = 0.05_pl_test_flt/(scale*86400.0_pl_test_flt)
                if (k .eq. 1) then
                    if_TAI_time_format = .true.
                    xtitle = "Seconds (TAI)"
                else
                    if_TAI_time_format = .false.
                    xtitle = "Seconds (TAI) labelled with corresponding UTC"
                endif
            elseif ((k .eq. 3) .or. (k .eq. 4)) then
                ! Choose midpoint to maximize time-representation precision.
                epoch_year  = 1963
                epoch_month = 10
                epoch_day   = 1
                epoch_hour  = 0
                epoch_min   = 0
                epoch_sec   = 2.6972788_pl_test_flt
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 0, .true., &
                       epoch_year, epoch_month, epoch_day, epoch_hour, epoch_min, epoch_sec )
                call plctime(1963,10,1,0,0,2.6972788_pl_test_flt-.20_pl_test_flt, xmin)
                call plctime(1963,10,1,0,0,2.6972788_pl_test_flt+.20_pl_test_flt, xmax)
                npts = 1001
                ymin = 2.55_pl_test_flt
                ymax = 2.75_pl_test_flt
                time_format = "%S%2%"
                title_suffix = "near 1963-11-01 (TAI)"
                xlabel_step = 0.05_pl_test_flt/(scale*86400.0_pl_test_flt)
                if (k .eq. 3) then
                    if_TAI_time_format = .true.
                    xtitle = "Seconds (TAI)"
                else
                    if_TAI_time_format = .false.
                    xtitle = "Seconds (TAI) labelled with corresponding UTC"
                endif
            elseif ((k .eq. 5) .or. (k .eq. 6)) then
                ! Choose midpoint to maximize time-representation precision.
                epoch_year  = 2009
                epoch_month = 0
                epoch_day   = 1
                epoch_hour  = 0
                epoch_min   = 0
                epoch_sec   = 34._pl_test_flt
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 0, .true., &
                       epoch_year, epoch_month, epoch_day, epoch_hour, epoch_min, epoch_sec )
                call plctime(2009,0,1,0,0,34._pl_test_flt-5._pl_test_flt,xmin)
                call plctime(2009,0,1,0,0,34._pl_test_flt+5._pl_test_flt,xmax)
                npts = 1001
                ymin = 32.5_pl_test_flt
                ymax = 34.5_pl_test_flt
                time_format = "%S%2%"
                title_suffix = "near 2009-01-01 (TAI)"
                xlabel_step = 1._pl_test_flt/(scale*86400._pl_test_flt)
                if (k .eq. 5) then
                    if_TAI_time_format = .true.
                    xtitle = "Seconds (TAI)"
                else
                    if_TAI_time_format = .false.
                    xtitle = "Seconds (TAI) labelled with corresponding UTC"
                endif
            endif

            do i=0,npts-1
                x(i+1) = xmin + i*(xmax-xmin)/(real(npts-1,kind=pl_test_flt))
                tai = x(i+1)
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 0, .true., &
                       epoch_year, epoch_month, epoch_day, epoch_hour, epoch_min, epoch_sec )
                call plbtime(tai_year, tai_month, tai_day, tai_hour, &
                       tai_min, tai_sec, tai)
                ! Calculate residual using tai as the epoch to nearly maximize time-representation precision.
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 0, .true., &
                       tai_year, tai_month, tai_day, tai_hour, tai_min, tai_sec)
                ! Calculate continuous tai with new epoch.
                call plctime( tai_year, tai_month, tai_day, tai_hour, tai_min, tai_sec, tai)
                ! Calculate broken-down utc (with leap seconds inserted) from continuous tai with new epoch.
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 2, .true., &
                       tai_year, tai_month, tai_day, tai_hour, tai_min, tai_sec)
                call plbtime(utc_year, utc_month, utc_day, utc_hour, utc_min, utc_sec, tai)
                ! Calculate continuous utc from broken-down utc using same epoch as for the continuous tai.
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 0, .true., &
                       tai_year, tai_month, tai_day, tai_hour, tai_min, tai_sec)
                call plctime(utc_year, utc_month, utc_day, utc_hour, utc_min, utc_sec, utc)
                ! Convert residuals to seconds.
                y(i+1)=(tai-utc)*scale*86400._pl_test_flt
            enddo

            call pladv(0)
            call plvsta()
            call plwind(xmin, xmax, ymin, ymax)
            call plcol0(1)
            if (if_TAI_time_format) then
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 0, .true., &
                       epoch_year, epoch_month, epoch_day, epoch_hour, epoch_min, epoch_sec )
            else
                call plconfigtime(scale, 0._pl_test_flt, 0._pl_test_flt, 2, .true., &
                       epoch_year, epoch_month, epoch_day, epoch_hour, epoch_min, epoch_sec )
            endif
            call pltimefmt(time_format)
            call plbox("bcnstd", xlabel_step, 0, "bcnstv", 0._pl_test_flt, 0)
            call plcol0(3)
            title = "@frPLplot Example 29 - TAI-UTC "// &
                   trim(title_suffix)
            call pllab(xtitle, "TAI-UTC (sec)", title)

            call plcol0(4)

            call plline(x(1:npts), y(1:npts))
        enddo
    end subroutine plot4
end program x29f

!   Demonstrates plotting text in 3D (plmtex3, plptex3)
!
!   Copyright (C) 2007-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!

program x28f
    use plplot, double_PI => PL_PI

    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    integer, parameter :: XPTS = 2
    integer, parameter :: YPTS = 2
    integer, parameter :: NREVOLUTION = 16
    integer, parameter :: NROTATION = 8
    integer, parameter :: NSHEAR = 8

    real(PLFLT), dimension(:), allocatable   :: x, y
    real(PLFLT), dimension(:,:), allocatable :: z

    real(PLFLT), parameter :: xmin=0., xmax=1.0,                            &
           xmid = 0.5*(xmax + xmin), xrange = xmax - xmin,                    &
           ymin=0., ymax=1.0, ymid = 0.5*(ymax + ymin), yrange = ymax - ymin, &
           zmin=0., zmax=1.0, zmid = 0.5*(zmax + zmin), zrange = zmax - zmin
    real(PLFLT), parameter :: &
           ysmin    = ymin + 0.1 * yrange, &
           ysmax    = ymax - 0.1 * yrange, &
           ysrange  = ysmax - ysmin, &
           dysrot   = ysrange / ( NROTATION - 1 ), &
           dysshear = ysrange / ( NSHEAR - 1 ), &
           zsmin    = zmin + 0.1 * zrange, &
           zsmax    = zmax - 0.1 * zrange, &
           zsrange  = zsmax - zsmin, &
           dzsrot   = zsrange / ( NROTATION - 1 ), &
           dzsshear = zsrange / ( NSHEAR - 1 )
    real(PLFLT) :: ys, zs, &
           x_inclination, y_inclination, z_inclination,       &
           x_shear, y_shear, z_shear,                         &
           omega, sin_omega, cos_omega, domega
    integer     :: i, j
    integer :: plparseopts_rc
    real(PLFLT) :: radius, pitch, xpos, ypos, zpos

    ! N.B. Need to append PL_END_OF_STRING so spaces get
    ! properly plotted.
    character(len=2)  :: p1string = "O"//PL_END_OF_STRING
    character(len=80) :: pstring  = &
           "The future of our civilization depends on software freedom."

    ! Allocate and define the minimal x, y, and z to insure 3D box
    allocate( x(XPTS) )
    allocate( y(YPTS) )
    allocate( z(XPTS,YPTS) )

    do i = 1,XPTS
        x(i) = xmin + (i-1) * (xmax-xmin)/(XPTS-1)
    enddo

    do j = 1,YPTS
        y(j) = ymin + (j-1) * (ymax-ymin)/(YPTS-1)
    enddo

    z = 0.0

    ! Parse and process command line arguments

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plinit

    ! Page 1: Demonstrate inclination and shear capability pattern.

    call pladv(0)
    call plvpor(-0.15_pl_test_flt, 1.15_pl_test_flt, -0.05_pl_test_flt, 1.05_pl_test_flt)
    call plwind(-1.2_pl_test_flt, 1.2_pl_test_flt, -0.8_pl_test_flt, 1.5_pl_test_flt)
    call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, &
           xmin, xmax, ymin, ymax, zmin, zmax, 20._pl_test_flt, 45._pl_test_flt)

    call plcol0(2)
    call plbox3("b",   "", xmax-xmin, 0, &
           "b",   "", ymax-ymin, 0, &
           "bcd", "", zmax-zmin, 0)

    ! z = zmin.
    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    do i = 1,NREVOLUTION
        omega = 2.*PI*((i-1)/real(NREVOLUTION,kind=pl_test_flt))
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        x_inclination = 0.5*xrange*cos_omega
        y_inclination = 0.5*yrange*sin_omega
        z_inclination = 0.
        x_shear = -0.5*xrange*sin_omega
        y_shear = 0.5*yrange*cos_omega
        z_shear = 0.
        call plptex3( &
               xmid, ymid, zmin, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.0_pl_test_flt, "  revolution")
    enddo

    ! x = xmax.
    call plschr(0._pl_test_flt, 1.0_pl_test_flt)
    do i = 1,NREVOLUTION
        omega = 2.*PI*((i-1)/real(NREVOLUTION,kind=pl_test_flt))
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        x_inclination = 0.
        y_inclination = -0.5*yrange*cos_omega
        z_inclination = 0.5*zrange*sin_omega
        x_shear = 0.
        y_shear = 0.5*yrange*sin_omega
        z_shear = 0.5*zrange*cos_omega
        call plptex3( &
               xmax, ymid, zmid, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.0_pl_test_flt, "  revolution")
    enddo

    ! y = ymax.
    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    do i = 1,NREVOLUTION
        omega = 2.*PI*(i-1)/real(NREVOLUTION,kind=pl_test_flt)
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        x_inclination = 0.5*xrange*cos_omega
        y_inclination = 0.
        z_inclination = 0.5*zrange*sin_omega
        x_shear = -0.5*xrange*sin_omega
        y_shear = 0.
        z_shear = 0.5*zrange*cos_omega
        call plptex3( &
               xmid, ymax, zmid, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.0_pl_test_flt, "  revolution")
    enddo

    ! Draw minimal 3D grid to finish defining the 3D box.
    call plmesh(x, y, z, DRAW_LINEXY)

    ! Page 2: Demonstrate rotation of string around its axis.
    call pladv(0)
    call plvpor(-0.15_pl_test_flt, 1.15_pl_test_flt, -0.05_pl_test_flt, 1.05_pl_test_flt)
    call plwind(-1.2_pl_test_flt, 1.2_pl_test_flt, -0.8_pl_test_flt, 1.5_pl_test_flt)
    call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, xmin, xmax, ymin, ymax, &
           zmin, zmax, 20._pl_test_flt, 45._pl_test_flt)

    call plcol0(2)
    call plbox3("b",   "", xmax-xmin, 0, &
           "b",   "", ymax-ymin, 0, &
           "bcd", "", zmax-zmin, 0)

    ! y = ymax.
    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    x_inclination = 1.
    y_inclination = 0.
    z_inclination = 0.
    x_shear = 0.
    do i = 1,NROTATION
        omega = 2.*PI*(i-1)/real(NROTATION,kind=pl_test_flt)
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        y_shear = 0.5*yrange*sin_omega
        z_shear = 0.5*zrange*cos_omega
        zs        = zsmax - dzsrot * real(i-1,kind=pl_test_flt)
        call plptex3( &
               xmid, ymax, zs, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.5_pl_test_flt, "rotation for y = y#dmax#u")
    enddo

    ! x = xmax.
    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    x_inclination = 0.0
    y_inclination = -1.0
    z_inclination = 0.0
    y_shear = 0.0
    do i = 1,NROTATION
        omega = 2.*PI*((i-1)/real(NROTATION,kind=pl_test_flt))
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        x_shear = 0.5*xrange*sin_omega
        z_shear = 0.5*zrange*cos_omega
        zs        = zsmax - dzsrot * real(i-1,kind=pl_test_flt)
        call plptex3( &
               xmax, ymid, zs, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.5_pl_test_flt, "rotation for x = x#dmax#u")
    enddo

    ! z = zmin.
    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    x_inclination = 1.
    y_inclination = 0.
    z_inclination = 0.
    x_shear = 0.
    do i = 1,NROTATION
        omega = 2.*PI*((i-1)/real(NROTATION,kind=pl_test_flt))
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        y_shear = 0.5*yrange*cos_omega
        z_shear = 0.5*zrange*sin_omega
        ys        = ysmax - dysrot * real(i-1,kind=pl_test_flt)
        call plptex3( &
               xmid, ys, zmin, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.5_pl_test_flt, "rotation for z = z#dmin#u")
    enddo
    ! Draw minimal 3D grid to finish defining the 3D box.
    call plmesh(x, y, z, DRAW_LINEXY)

    ! Page 3: Demonstrate shear of string along its axis.
    ! Work around xcairo and pngcairo (but not pscairo) problems for
    ! shear vector too close to axis of string. (N.B. no workaround
    ! would be domega = 0.)
    domega = 0.05
    call pladv(0)
    call plvpor(-0.15_pl_test_flt, 1.15_pl_test_flt, -0.05_pl_test_flt, 1.05_pl_test_flt)
    call plwind(-1.2_pl_test_flt, 1.2_pl_test_flt, -0.8_pl_test_flt, 1.5_pl_test_flt)
    call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, xmin, xmax, ymin, ymax, &
           zmin, zmax, 20._pl_test_flt, 45._pl_test_flt)

    call plcol0(2)
    call plbox3("b",   "", xmax-xmin, 0, &
           "b",   "", ymax-ymin, 0, &
           "bcd", "", zmax-zmin, 0)

    ! y = ymax.
    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    x_inclination = 1.
    y_inclination = 0.
    z_inclination = 0.
    y_shear = 0.
    do i = 1,NSHEAR
        omega = domega + 2.*PI*((i-1)/real(NSHEAR,kind=pl_test_flt))
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        x_shear = 0.5*xrange*sin_omega
        z_shear = 0.5*zrange*cos_omega
        zs        = zsmax - dzsshear * real(i-1,kind=pl_test_flt)
        call plptex3( &
               xmid, ymax, zs, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.5_pl_test_flt, "shear for y = y#dmax#u")
    enddo

    ! x = xmax.
    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    x_inclination = 0.
    y_inclination = -1.
    z_inclination = 0.
    x_shear = 0.
    do i = 1,NSHEAR
        omega = domega + 2.*PI*((i-1)/real(NSHEAR,kind=pl_test_flt))
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        y_shear = -0.5*yrange*sin_omega
        z_shear = 0.5*zrange*cos_omega
        zs        = zsmax - dzsshear * real(i-1,kind=pl_test_flt)
        call plptex3( &
               xmax, ymid, zs, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.5_pl_test_flt, "shear for x = x#dmax#u")
    enddo

    ! z = zmin.
    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    x_inclination = 1.
    y_inclination = 0.
    z_inclination = 0.
    z_shear = 0.
    do i = 1,NSHEAR
        omega = domega + 2.*PI*((i-1)/real(NSHEAR,kind=pl_test_flt))
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        y_shear = 0.5*yrange*cos_omega
        x_shear = 0.5*xrange*sin_omega
        ys        = ysmax - dysshear * real(i-1,kind=pl_test_flt)
        call plptex3( &
               xmid, ys, zmin, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.5_pl_test_flt, "shear for z = z#dmin#u")
    enddo
    ! Draw minimal 3D grid to finish defining the 3D box.
    call plmesh(x, y, z, DRAW_LINEXY)

    ! Page 4: Demonstrate drawing a string on a 3D path.
    call pladv(0)
    call plvpor(-0.15_pl_test_flt, 1.15_pl_test_flt, -0.05_pl_test_flt, 1.05_pl_test_flt)
    call plwind(-1.2_pl_test_flt, 1.2_pl_test_flt, -0.8_pl_test_flt, 1.5_pl_test_flt)
    call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, &
           xmin, xmax, ymin, ymax, zmin, zmax, 40._pl_test_flt, -30._pl_test_flt)

    call plcol0(2)
    call plbox3("b",   "", xmax-xmin, 0, &
           "b",   "", ymax-ymin, 0, &
           "bcd", "", zmax-zmin, 0)

    call plschr(0.0_pl_test_flt, 1.2_pl_test_flt)
    ! domega controls the spacing between the various characters of the
    ! string and also the maximum value of omega for the given number
    ! of characters in pstring.
    domega = 2.*PI/len_trim(pstring)
    omega = 0.
    ! 3D function is a helix of the given radius and pitch
    radius = 0.5
    pitch = 1./(2.*PI)
    do i = 1,len_trim(pstring)
        sin_omega = sin(omega)
        cos_omega = cos(omega)
        xpos = xmid + radius*sin_omega
        ypos = ymid - radius*cos_omega
        zpos = zmin + pitch*omega
        ! In general, the inclination is proportional to the derivative of
        ! the position wrt theta.
        x_inclination = radius*cos_omega
        y_inclination = radius*sin_omega
        z_inclination = pitch
        ! The shear vector should be perpendicular to the 3D line with Z
        ! component maximized, but for low pitch a good approximation is
        ! a constant vector that is parallel to the Z axis.
        x_shear = 0.
        y_shear = 0.
        z_shear = 1.
        p1string(1:1) = pstring(i:i)
        call plptex3( &
               xpos, ypos, zpos, &
               x_inclination, y_inclination, z_inclination, &
               x_shear, y_shear, z_shear, &
               0.5_pl_test_flt, p1string)
        omega = omega + domega
    enddo
    ! Draw minimal 3D grid to finish defining the 3D box.
    call plmesh(x, y, z, DRAW_LINEXY)

    ! Page 5: Demonstrate plmtex3 axis labelling capability
    call pladv(0)
    call plvpor(-0.15_pl_test_flt, 1.15_pl_test_flt, -0.05_pl_test_flt, 1.05_pl_test_flt)
    call plwind(-1.2_pl_test_flt, 1.2_pl_test_flt, -0.8_pl_test_flt, 1.5_pl_test_flt)
    call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, &
           xmin, xmax, ymin, ymax, zmin, zmax, 20._pl_test_flt, 45._pl_test_flt)

    call plcol0(2)
    call plbox3("b",   "", xmax-xmin, 0, &
           "b",   "", ymax-ymin, 0, &
           "bcd", "", zmax-zmin, 0)

    call plschr(0.0_pl_test_flt, 1.0_pl_test_flt)
    call plmtex3("xp", 3.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "Arbitrarily displaced")
    call plmtex3("xp", 4.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "primary X-axis label")
    call plmtex3("xs", -2.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "Arbitrarily displaced")
    call plmtex3("xs", -1.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "secondary X-axis label")
    call plmtex3("yp", 3.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "Arbitrarily displaced")
    call plmtex3("yp", 4.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "primary Y-axis label")
    call plmtex3("ys", -2.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "Arbitrarily displaced")
    call plmtex3("ys", -1.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "secondary Y-axis label")
    call plmtex3("zp", 4.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "Arbitrarily displaced")
    call plmtex3("zp", 3.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "primary Z-axis label")
    call plmtex3("zs", -2.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "Arbitrarily displaced")
    call plmtex3("zs", -1.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, "secondary Z-axis label")
    ! Draw minimal 3D grid to finish defining the 3D box.
    call plmesh(x, y, z, DRAW_LINEXY)

    ! Clean up.
    deallocate( x, y, z )
    call plend
    stop
end program x28f

!      Vector plot demo.
!
!      Copyright (C) 2004-2016  Alan W. Irwin
!      Copyright (C) 2004  Andrew Ross
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!      Does several contour plots using different coordinate mappings.

program x22f
    use plplot, double_PI => PL_PI
    use plfortrandemolib
    use iso_c_binding, only: c_ptr, c_loc, c_f_pointer
    implicit none
    real(kind=pl_test_flt), parameter :: PI = double_PI

    integer, parameter :: double = kind(1.0d0)
    real(kind=double) common_max

    integer narr
    integer :: plparseopts_rc
    logical fill
    parameter (narr=6)
    real(kind=pl_test_flt) arrow_x(narr),arrow_y(narr), &
           arrow2_x(narr),arrow2_y(narr)

    type callback_data_type
        ! Only contains data required by the tranform_data callback
        real(kind=double) max
    end type callback_data_type

    data arrow_x/-0.5_pl_test_flt, 0.5_pl_test_flt, 0.3_pl_test_flt, 0.5_pl_test_flt, 0.3_pl_test_flt, 0.5_pl_test_flt/
    data arrow_y/0._pl_test_flt, 0._pl_test_flt, 0.2_pl_test_flt, 0._pl_test_flt, -0.2_pl_test_flt, 0._pl_test_flt/
    data arrow2_x/-0.5_pl_test_flt, 0.3_pl_test_flt, 0.3_pl_test_flt, 0.5_pl_test_flt, 0.3_pl_test_flt, 0.3_pl_test_flt/
    data arrow2_y/0._pl_test_flt, 0._pl_test_flt, 0.2_pl_test_flt, 0._pl_test_flt, -0.2_pl_test_flt, 0._pl_test_flt/

    real(kind=pl_test_flt) :: tr(6), xmin_global, xmax_global, ymin_global, ymax_global
    integer :: nx_global, ny_global
    type mypltr_data_type
        ! Only contains data required by the mypltr_data callback
        real(kind=pl_test_flt), dimension(6) :: tr_data
    end type mypltr_data_type

    type(mypltr_data_type), target :: data

    ! Use tr plcont callback?
    logical, parameter :: tr_callback = .false.
    ! Use pltr0 (identity transformation) callback? (only meaningful
    ! if tr_callback is .false.).
    logical, parameter :: identity_callback = .false.
    ! Use Fortran callback with no data? (only meaningful
    ! if tr_callback and identity_callback are .false.).
    logical, parameter :: mypltr_callback = .false.

    ! use plstransform callback without data?
    logical, parameter :: ifno_transform_data = .false.

    !      Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    ! I believe tr must be declared and defined globally this way in
    ! order for mypltr in circulation to work properly, and I would otherwise declare
    ! and define tr locally in that routine.

    ! Consistent with nx and ny in circulation.
    nx_global = 20
    ny_global = 20

    ! Must be consistent with actual ranges of xg and yg arrays in circulation
    ! so these values not exactly the same as xmin, xmax, ymin, and ymax there.
    xmin_global = - real(nx_global / 2, kind=pl_test_flt) + 0.5_pl_test_flt
    xmax_global = xmin_global + real(nx_global-1, kind=pl_test_flt)
    ymin_global = - real(ny_global / 2, kind=pl_test_flt) + 0.5_pl_test_flt
    ymax_global = ymin_global + real(ny_global-1, kind=pl_test_flt)
    tr = [(xmax_global-xmin_global)/real(nx_global-1,kind=pl_test_flt), 0.0_pl_test_flt, xmin_global, &
           0.0_pl_test_flt, (ymax_global-ymin_global)/real(ny_global-1,kind=pl_test_flt), ymin_global ]

    call plinit

    call circulation

    fill = .false.

    !     Set arrow style using arrow_x and arrow_y the
    !     plot using these arrows
    call plsvect(arrow_x, arrow_y, fill)
    call constriction( 1 )

    !     Set arrow style using arrow_x and arrow_y the
    !     plot using these arrows
    fill = .true.
    call plsvect(arrow2_x, arrow2_y, fill)
    call constriction( 2 )

    call constriction2

    call plsvect

    call potential

    call plend


contains

    ! Callback function that relies on global tr.
    subroutine mypltr( x, y, xt, yt )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt

        xt = tr(1) * x + tr(2) * y + tr(3)
        yt = tr(4) * x + tr(5) * y + tr(6)

    end subroutine mypltr

    ! Callback function that uses data argument to pass tr information.
    subroutine mypltr_data( x, y, xt, yt, data )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt
        type(c_ptr), intent(in) :: data

        type(mypltr_data_type), pointer :: d
        call c_f_pointer(data, d)

        xt = d%tr_data(1) * x + d%tr_data(2) * y + d%tr_data(3)
        yt = d%tr_data(4) * x + d%tr_data(5) * y + d%tr_data(6)

    end subroutine mypltr_data

    !     vector plot of the circulation around the origin
    subroutine circulation()

        integer, parameter :: nx=20, ny=20

        real(kind=pl_test_flt), allocatable :: u(:,:), v(:,:), xg(:), yg(:)

        real(kind=pl_test_flt) :: dx, dy, xmin, xmax, ymin, ymax
        real(kind=pl_test_flt) :: scaling

        dx = 1.0_pl_test_flt
        dy = 1.0_pl_test_flt

        xmin = -real(nx,kind=pl_test_flt)/2.0_pl_test_flt*dx
        xmax = real(nx,kind=pl_test_flt)/2.0_pl_test_flt*dx
        ymin = -real(ny,kind=pl_test_flt)/2.0_pl_test_flt*dy
        ymax = real(ny,kind=pl_test_flt)/2.0_pl_test_flt*dy

        allocate( xg(nx), yg(ny) )
        xg = (arange(nx) + (-nx/2.0_pl_test_flt+0.5_pl_test_flt))*dx
        yg = (arange(ny) + (-ny/2.0_pl_test_flt+0.5_pl_test_flt))*dy

        allocate( u(nx,ny), v(nx,ny) )
        u = spread(yg,1,nx)
        v = -spread(xg,2,ny)

        if(.not. tr_callback .and. identity_callback) then
            ! This scaling the same as if xmin, xmax, ymin, and ymax
            ! replaced in plenv call below by actual minimum and maximum
            ! xg and yg values.  So along with different tick marks you
            ! will also get slightly different scaling with this alternative
            ! compared to all other results.
            call plenv( &
                   real(0,kind=pl_test_flt), real(nx-1,kind=pl_test_flt), &
                   real(0,kind=pl_test_flt), real(ny-1,kind=pl_test_flt), 0, 0)
        else
            call plenv(xmin, xmax, ymin, ymax, 0, 0)
        endif
        call pllab('(x)', '(y)',  &
               '#frPLplot Example 22 - circulation')
        call plcol0(2)
        scaling = 0.0_pl_test_flt
        if(tr_callback) then
            call plvect(u,v,scaling,tr)
        elseif(identity_callback) then
            call plvect(u,v,scaling)
        elseif(mypltr_callback) then
            call plvect(u,v,scaling, mypltr)
        else
            data%tr_data = tr
            call plvect(u,v,scaling, mypltr_data, c_loc(data))
        endif
        call plcol0(1)

    end subroutine circulation

    !     vector plot of the flow through a constricted pipe
    subroutine constriction( astyle )

        integer i, j, nx, ny, astyle
        parameter (nx=20, ny=20)

        character(len=80) :: title

        real(kind=pl_test_flt) :: u(nx, ny), v(nx, ny)
        real(kind=pl_test_flt), allocatable :: xg(:), yg(:)

        real(kind=pl_test_flt) dx, dy, xmin, xmax, ymin, ymax
        real(kind=pl_test_flt) xx, yy, Q, b, dbdx, scaling

        dx = 1.0_pl_test_flt
        dy = 1.0_pl_test_flt

        xmin = -real(nx,kind=pl_test_flt)/2.0_pl_test_flt*dx
        xmax = real(nx,kind=pl_test_flt)/2.0_pl_test_flt*dx
        ymin = -real(ny,kind=pl_test_flt)/2.0_pl_test_flt*dy
        ymax = real(ny,kind=pl_test_flt)/2.0_pl_test_flt*dy

        Q = 2.0_pl_test_flt

        allocate( xg(nx), yg(ny) )

        xg = (arange(nx) + (-nx/2.0_pl_test_flt+0.5_pl_test_flt))*dx
        yg = (arange(ny) + (-ny/2.0_pl_test_flt+0.5_pl_test_flt))*dy
        do i=1,nx
            xx = xg(i)
            do j=1,ny
                yy = yg(j)
                b = ymax/4.0_pl_test_flt*(3.0_pl_test_flt-cos(PI*xx/xmax))
                if (abs(yy).lt.b) then
                    dbdx = ymax/4.0_pl_test_flt*sin(PI*xx/xmax)*PI/xmax*yy/b
                    u(i,j) = Q*ymax/b
                    v(i,j) = u(i,j)*dbdx
                else
                    u(i,j) = 0.0_pl_test_flt
                    v(i,j) = 0.0_pl_test_flt
                endif
            enddo
        enddo

        call plenv(xmin, xmax, ymin, ymax, 0, 0)
        write(title,'(A,I0,A)') '#frPLplot Example 22 - constriction (arrow style ', astyle,')'
        call pllab('(x)', '(y)', title)
        call plcol0(2)
        scaling = -1.0_pl_test_flt
        call plvect(u,v,scaling,xg,yg)
        call plcol0(1)

    end subroutine constriction

    ! Global transform function for a constriction using data passed in
    ! This is the same transformation used in constriction.
    ! Note:
    ! We need to use double precision here, independent of what precision is used
    ! in the rest of the program
    !
    subroutine transform( x, y, xt, yt )

        ! These callback arguments must have exactly these attributes.
        real(kind=double), intent(in) ::  x, y
        real(kind=double), intent(out) :: xt, yt

        xt = x
        yt = y / 4.0_pl_test_flt * ( 3.0_pl_test_flt - cos( PI * x / common_max ) )
    end subroutine transform

    ! Variant of transform that carries a generic data argument.
    subroutine transform_data( x, y, xt, yt, data )

        ! These callback arguments must have exactly these attributes.
        real(kind=double), intent(in) ::  x, y
        real(kind=double), intent(out) :: xt, yt
        type(c_ptr), intent(in) :: data

        type(callback_data_type), pointer :: d
        call c_f_pointer(data, d)

        xt = x
        yt = y / 4.0_pl_test_flt * ( 3.0_pl_test_flt - cos( PI * x / d%max ) )
    end subroutine transform_data

    ! Vector plot of flow through a constricted pipe
    ! with a coordinate transform
    subroutine constriction2()

        integer, parameter :: nx=20, ny=20, nc=11, nseg=20

        real(kind=pl_test_flt) dx, dy
        real(kind=pl_test_flt) xmin, xmax, ymin, ymax
        real(kind=pl_test_flt) Q, scaling
        real(kind=pl_test_flt), allocatable :: xg(:), yg(:), b(:), u(:,:), v(:,:), clev(:)

        type(callback_data_type), target :: data

        dx = 1.0_pl_test_flt
        dy = 1.0_pl_test_flt

        xmin = -real(nx,kind=pl_test_flt)/2.0_pl_test_flt*dx
        xmax = real(nx,kind=pl_test_flt)/2.0_pl_test_flt*dx
        ymin = -real(ny,kind=pl_test_flt)/2.0_pl_test_flt*dy
        ymax = real(ny,kind=pl_test_flt)/2.0_pl_test_flt*dy
        common_max = ymax
        data%max = common_max

        allocate( b(nx) )
        allocate( xg(nx), yg(ny) )
        allocate( u(nx,ny), v(nx,ny) )
        allocate( clev(nc) )

        if(ifno_transform_data) then
            call plstransform( transform )
        else
            call plstransform( transform_data, c_loc(data))
        endif

        Q = 2.0_pl_test_flt
        xg = (arange(nx) + (-nx/2.0_pl_test_flt+0.5_pl_test_flt))*dx
        yg = (arange(ny) + (-ny/2.0_pl_test_flt+0.5_pl_test_flt))*dy
        b = Q*4.0_pl_test_flt/(3.0_pl_test_flt-cos(PI*xg/xmax))
        u = spread(b,2,ny)
        v = 0.0_pl_test_flt*u
        clev = Q + arange(nc) * (Q/real(nc-1,kind=pl_test_flt))

        call plenv(xmin, xmax, ymin, ymax, 0, 0)
        call pllab('(x)', '(y)', &
               '#frPLplot Example 22 - constriction with plstransform')
        call plcol0(2)
        call plshades(u, xmin + dx / 2.0_pl_test_flt, &
               xmax - dx / 2.0_pl_test_flt, &
               ymin + dy / 2.0_pl_test_flt, ymax - dy / 2.0_pl_test_flt, &
               clev, 0.0_pl_test_flt, 1, 1.0_pl_test_flt, .false. )
        scaling = -1.0_pl_test_flt
        call plvect(u,v,scaling,xg,yg)
        call plpath(nseg, xmin, ymax, xmax, ymax)
        call plpath(nseg, xmin, ymin, xmax, ymin)
        call plcol0(1)

        call plstransform()

    end subroutine constriction2

    subroutine potential()

        integer i, j, nr, ntheta, nper, nlevel
        parameter (nr=20, ntheta=20, nper=100, nlevel=10)

        real(kind=pl_test_flt) u(nr, ntheta), v(nr, ntheta), z(nr, ntheta)
        real(kind=pl_test_flt) xg(nr,ntheta), yg(nr,ntheta)
        real(kind=pl_test_flt) clevel(nlevel), px(nper), py(nper)

        real(kind=pl_test_flt) xmin, xmax, ymin, ymax, zmin, zmax, rmax
        real(kind=pl_test_flt) xx, yy, r, theta, scaling, dz

        real(kind=pl_test_flt) eps, q1, d1, q1i, d1i, q2, d2, q2i, d2i
        real(kind=pl_test_flt) div1, div1i, div2, div2i

        rmax = real(nr,kind=pl_test_flt)

        eps = 2.0_pl_test_flt

        q1 = 1.0_pl_test_flt
        d1 = rmax/4.0_pl_test_flt

        q1i = - q1*rmax/d1
        d1i = rmax**2.0_pl_test_flt/d1

        q2 = -1.0_pl_test_flt
        d2 = rmax/4.0_pl_test_flt

        q2i = - q2*rmax/d2
        d2i = rmax**2.0_pl_test_flt/d2

        do i = 1, nr
            r = 0.5 + real(i-1,kind=pl_test_flt)
            do j = 1, ntheta
                theta = 2.*PI/real(ntheta-1,kind=pl_test_flt)*(real(j,kind=pl_test_flt)-0.5)
                xx = r*cos(theta)
                yy = r*sin(theta)
                xg(i,j) = xx
                yg(i,j) = yy
                div1 = sqrt((xg(i,j)-d1)**2 + (yg(i,j)-d1)**2 + eps**2)
                div1i = sqrt((xg(i,j)-d1i)**2 + (yg(i,j)-d1i)**2 + eps**2)

                div2 = sqrt((xg(i,j)-d2)**2 + (yg(i,j)+d2)**2 + eps**2)
                div2i = sqrt((xg(i,j)-d2i)**2 + (yg(i,j)+d2i)**2 + eps**2)

                z(i,j) = q1/div1 + q1i/div1i + q2/div2 + q2i/div2i
                u(i,j) = -q1*(xx-d1)/div1**3 - q1i*(xx-d1i)/div1i**3 - &
                       q2*(xx-d2)/div2**3 - q2i*(xx-d2i)/div2i**3
                v(i,j) = -q1*(yy-d1)/div1**3 - q1i*(yy-d1i)/div1i**3 - &
                       q2*(yy+d2)/div2**3 - q2i*(yy+d2i)/div2i**3
            enddo
        enddo

        call a2mnmx(xg, nr, ntheta, xmin, xmax, nr)
        call a2mnmx(yg, nr, ntheta, ymin, ymax, nr)
        call a2mnmx(z, nr, ntheta, zmin, zmax, nr)

        call plenv(xmin, xmax, ymin, ymax, 0, 0)
        call pllab('(x)', '(y)',  &
               '#frPLplot Example 22 - potential gradient vector plot')

        !     plot contours of the potential
        dz = abs(zmax - zmin)/real(nlevel,kind=pl_test_flt)
        do i = 1, nlevel
            clevel(i) = zmin + (i-0.5_pl_test_flt)*dz
        enddo
        call plcol0(3)
        call pllsty(2)
        call plcont(z,1,nr,1,ntheta,clevel,xg,yg)
        call pllsty(1)
        call plcol0(1)

        call plcol0(2)
        scaling = 25.0_pl_test_flt
        call plvect(u,v,scaling,xg,yg)
        call plcol0(1)

        do i=1,nper
            theta = 2.0_pl_test_flt*PI/real(nper-1,kind=pl_test_flt)*real(i,kind=pl_test_flt)
            px(i) = rmax*cos(theta)
            py(i) = rmax*sin(theta)
        enddo

        call plline(px,py)

    end subroutine potential

    !----------------------------------------------------------------------------
    !      Subroutine a2mnmx
    !      Minimum and the maximum elements of a 2-d array.

    subroutine a2mnmx(f, nx, ny, fmin, fmax, xdim)

        integer   i, j, nx, ny, xdim
        real(kind=pl_test_flt)    f(xdim, ny), fmin, fmax

        fmax = f(1, 1)
        fmin = fmax
        do j = 1, ny
            do  i = 1, nx
                fmax = max(fmax, f(i, j))
                fmin = min(fmin, f(i, j))
            enddo
        enddo
    end subroutine a2mnmx
end program x22f

!      set / get tester.
!
!      Copyright (C) 2008-2016  Alan W. Irwin
!      Copyright (C) 2008  Andrew Ross
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!--------------------------------------------------------------------------
! main
!
! Demonstrates absolute positioning of graphs on a page.
!--------------------------------------------------------------------------

program x31f
    use plplot, double_PL_NOTSET => PL_NOTSET

    implicit none
    real(kind=pl_test_flt), parameter :: NOTSET = double_PL_NOTSET

    real(kind=pl_test_flt) xmin0, xmax0, ymin0, ymax0, zxmin0, zxmax0, zymin0, zymax0
    real(kind=pl_test_flt) xmin, xmax, ymin, ymax, zxmin, zxmax, zymin, zymax
    real(kind=pl_test_flt) xmid, ymid, wx, wy
    real(kind=pl_test_flt) mar0, aspect0, jx0, jy0, ori0
    real(kind=pl_test_flt) mar, aspect, jx, jy, ori
    integer win, level2, digmax, digits, compression1, compression2
    real(kind=pl_test_flt) xp0, yp0, xp1, yp1, xp2, yp2
    integer xleng0, yleng0, xoff0, yoff0, xleng1, yleng1, xoff1, yoff1
    integer xleng2, yleng2, xoff2, yoff2
    integer fam0, num0, bmax0, fam1, num1, bmax1, fam2, num2, bmax2
    integer r0, g0, b0
    real(kind=pl_test_flt) a0
    integer r, g, b
    real(kind=pl_test_flt) a
    integer r1(2), g1(2), b1(2)
    data r1 /0, 255/
    data g1 /255, 0/
    data b1 /0, 0/
    real(kind=pl_test_flt) a1(2)
    data a1 /1.0_pl_test_flt, 1.0_pl_test_flt/
    character(len=256) fnam
    integer stderr
    integer status
    integer :: plparseopts_rc

    status = 0
    stderr = 0

    !     Parse and process command line arguments

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !     Test setting / getting familying parameters before plinit
    call plgfam(fam0, num0, bmax0)
    fam1 = 0
    num1 = 10
    bmax1 = 1000
    call plsfam(fam1, num1, bmax1)

    !     Retrieve the same values?
    call plgfam(fam2, num2, bmax2)
    write(*,'(A,I1,I3,I5)') 'family parameters: fam, num, bmax = ', &
           fam2, num2, bmax2
    if (fam2 .ne. fam1 .or. num2 .ne. num1 .or. bmax2 .ne. bmax1) then
        write(stderr,*) 'plgfam test failed\n'
        status = 1
    endif
    !     Restore values set initially by plparseopts.
    call plsfam(fam0, num0, bmax0)

    !     Test setting / getting page parameters before plinit
    !     Save values set by plparseopts to be restored later.
    call plgpage(xp0, yp0, xleng0, yleng0, xoff0, yoff0)
    xp1 = 200._pl_test_flt
    yp1 = 200._pl_test_flt
    xleng1 = 400
    yleng1 = 200
    xoff1 = 10
    yoff1 = 20
    call plspage(xp1, yp1, xleng1, yleng1, xoff1, yoff1)

    !     Retrieve the same values?
    call plgpage(xp2, yp2, xleng2, yleng2, xoff2, yoff2)
    write(*,'(A,2F11.6, 2I4, 2I3)')  &
           'page parameters: xp, yp, xleng, yleng, xoff, yoff =', &
           xp2, yp2, xleng2, yleng2, xoff2, yoff2
    if (xp2 .ne. xp1 .or. yp2 .ne. yp1 .or. xleng2 .ne. xleng1 .or. &
           yleng2 .ne. yleng1 .or. xoff2 .ne. xoff1 .or.  &
           yoff2 .ne. yoff1 ) then
        write(stderr,*) 'plgpage test failed'
        status = 1
    endif
    !     Restore values set initially by plparseopts.
    call plspage(xp0, yp0, xleng0, yleng0, xoff0, yoff0)

    !     Test setting / getting compression parameter across plinit
    compression1 = 95
    call plscompression(compression1)

    !     Initialize plplot

    call plinit()

    !     Test if device initialization screwed around with the preset
    !     compression parameter.
    call plgcompression(compression2)
    write(*,'(A)') 'Output various PLplot parameters'
    write(*,'(A,I2)') 'compression parameter = ', compression2
    if (compression2 .ne. compression1) then
        write(stderr,*) 'plgcompression test failed'
        status = 1
    endif

    !     Exercise plscolor, plscol0, plscmap1, and plscmap1a to make sure
    !     they work without any obvious error messages.
    call plscolor(1)
    call plscol0(1, 255, 0, 0)
    call plscmap1(r1,g1,b1)
    call plscmap1a(r1,g1,b1,a1)

    call plglevel(level2)
    write(*,'(A,I1)') 'level parameter = ', level2
    if (level2 .ne. 1) then
        write(stderr,*) 'plglevel test failed.'
        status = 1
    endif

    call pladv(0)
    xmin0 = 0.01_pl_test_flt
    xmax0 = 0.99_pl_test_flt
    ymin0 = 0.02_pl_test_flt
    ymax0 = 0.49_pl_test_flt
    call plvpor(xmin0, xmax0, ymin0, ymax0)
    call plgvpd(xmin, xmax, ymin, ymax)
    write(*,'(A,4F9.6)') 'plvpor: xmin, xmax, ymin, ymax =',  &
           xmin, xmax, ymin, ymax
    if (xmin .ne. xmin0 .or. xmax .ne. xmax0 .or. ymin .ne. ymin0 .or. ymax .ne. ymax0) then
        write(stderr,*) 'plgvpd test failed'
        status = 1
    endif
    xmid = 0.5*(xmin+xmax)
    ymid = 0.5*(ymin+ymax)

    xmin0 = 0.2_pl_test_flt
    xmax0 = 0.3_pl_test_flt
    ymin0 = 0.4_pl_test_flt
    ymax0 = 0.5_pl_test_flt
    call plwind(xmin0, xmax0, ymin0, ymax0)
    call plgvpw(xmin, xmax, ymin, ymax)
    write(*,'(A,4F9.6)') 'plwind: xmin, xmax, ymin, ymax =', &
           xmin, xmax, ymin, ymax
    if (xmin .ne. xmin0 .or. xmax .ne. xmax0 .or. ymin .ne. ymin0 .or. ymax .ne. ymax0) then
        write(stderr,*) 'plgvpw test failed',xmin,xmax,ymin,ymax
        status = 1
    endif

    !     Get world coordinates for midpoint of viewport
    call plcalc_world(xmid,ymid,wx,wy,win)
    write(*,'(A,2F9.6,I2)') 'world parameters: wx, wy, win =',  &
           wx, wy, win
    if (abs(wx-0.25_pl_test_flt).gt.1.0d-5 .or. abs(wy-0.45_pl_test_flt).gt.1.0d-5) then
        write(stderr,*) 'plcalc_world test failed'
        status = 1
    endif

    !     Retrieve and print the name of the output file (if any)
    call plgfnam(fnam)
    if (len(trim(fnam)) .eq. 0) then
        write(*,'(A)') 'No output file name is set'
    else
        write(*,'(A)') 'Output file name read'
    endif
    write(stderr,'(A,A)') 'Output file name is ',trim(fnam)

    !     Set and get the number of digits used to display axis labels
    !     Note digits is currently ignored in pls[xyz]ax and
    !     therefore it does not make sense to test the returned
    !     value
    call plsxax(3,0)
    call plgxax(digmax,digits)
    write(*,'(A,I2,I2)') 'x axis parameters: digmax, digits =', &
           digmax, digits
    if (digmax .ne. 3) then
        write(stderr,*) 'plgxax test failed'
        status = 1
    endif

    call plsyax(4,0)
    call plgyax(digmax,digits)
    write(*,'(A,I2,I2)') 'y axis parameters: digmax, digits =', &
           digmax, digits
    if (digmax .ne. 4) then
        write(stderr,*) 'plgyax test failed'
        status = 1
    endif

    call plszax(5,0)
    call plgzax(digmax,digits)
    write(*,'(A,I2,I2)') 'z axis parameters: digmax, digits =', &
           digmax, digits
    if (digmax .ne. 5) then
        write(stderr,*) 'plgzax test failed'
        status = 1
    endif

    mar0 = 0.05_pl_test_flt
    aspect0 = NOTSET
    jx0 = 0.1_pl_test_flt
    jy0 = 0.2_pl_test_flt
    call plsdidev(mar0, aspect0, jx0, jy0)
    call plgdidev(mar, aspect, jx, jy)
    write(*,'(A,4F9.6)') 'device-space window parameters: '// &
           'mar, aspect, jx, jy =', mar, aspect, jx, jy
    if (mar .ne. mar0 .or. jx .ne. jx0 .or. jy .ne. jy0) then
        write(stderr,*) 'plgdidev test failed'
        status = 1
    endif

    ori0 = 1.0_pl_test_flt
    call plsdiori(ori0)
    call plgdiori(ori)
    write(*,'(A,F9.6)') 'ori parameter =', ori
    if (ori .ne. ori0) then
        write(stderr,*) 'plgdiori test failed'
        status = 1
    endif

    xmin0 = 0.1_pl_test_flt
    ymin0 = 0.2_pl_test_flt
    xmax0 = 0.9_pl_test_flt
    ymax0 = 0.8_pl_test_flt
    call plsdiplt(xmin0, ymin0, xmax0, ymax0)
    call plgdiplt(xmin, ymin, xmax, ymax)
    write(*,'(A,4F9.6)') 'plot-space window parameters: '// &
           'xmin, ymin, xmax, ymax =', xmin, ymin, xmax, ymax
    if (xmin .ne. xmin0 .or. ymin .ne. ymin0 .or. xmax .ne. xmax0 .or. ymax .ne. ymax0) then
        write(stderr,*) 'plgdiplt test failed'
        status = 1
    endif

    zxmin0 = 0.1_pl_test_flt
    zymin0 = 0.1_pl_test_flt
    zxmax0 = 0.9_pl_test_flt
    zymax0 = 0.9_pl_test_flt
    call plsdiplz(zxmin0, zymin0, zxmax0, zymax0)
    call plgdiplt(zxmin, zymin, zxmax, zymax)
    write(*,'(A,4F9.6)') 'zoomed plot-space window parameters: '// &
           'xmin, ymin, xmax, ymax =', zxmin, zymin, zxmax, zymax
    if ( abs(zxmin -(xmin + (xmax-xmin)*zxmin0)) .gt. 1.0d-5 .or. &
           abs(zymin -(ymin+(ymax-ymin)*zymin0)) .gt. 1.0d-5 .or. &
           abs(zxmax -(xmin+(xmax-xmin)*zxmax0)) .gt. 1.0d-5 .or. &
           abs(zymax -(ymin+(ymax-ymin)*zymax0)) .gt. 1.0d-5 ) then
        write(stderr,*) 'plsdiplz test failed'
        status = 1
    endif

    r0 = 10
    g0 = 20
    b0 = 30
    call plscolbg(r0, g0, b0)
    call plgcolbg(r, g, b)
    write(*,'(A,3I3)') 'background colour parameters: r, g, b =', r, g, b
    if (r .ne. r0 .or. g .ne. g0 .or. b .ne. b0) then
        write(stderr,*) 'plgcolbg test failed'
        status = 1
    endif

    r0 = 20
    g0 = 30
    b0 = 40
    a0 = 0.5_pl_test_flt
    call plscolbga(r0, g0, b0, a0)
    call plgcolbga(r, g, b, a)
    write(*,'(A,3I3,F9.6)') 'background/transparency colour '// &
           'parameters: r, g, b, a =', r, g, b, a
    if (r .ne. r0 .or. g .ne. g0 .or. b .ne. b0 .or. a .ne. a0) then
        write(stderr,*) 'plgcolbga test failed'
        status = 1
    endif

    call plend()
    if (status.ne.0) then
        stop 'Error occured'
    endif
    stop

end program x31f

!   3-d plot demo
!
!   Copyright (C) 2004-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x08f
    use plplot, double_PI => PL_PI
    use plfortrandemolib

    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    integer :: i, j, k, ifshade

    !   xdim is the leading dimension of z, xpts <= xdim is the leading
    !   dimension of z that is defined.
    integer, parameter :: xdim=99, ydim=100, xpts=35, ypts=45
    real(kind=pl_test_flt)   :: x(xdim), y(ydim), z(xdim,ypts), xx, yy, r
    real(kind=pl_test_flt)   :: zlimited(xdim,ypts)
    integer, parameter :: indexxmin = 1
    integer, parameter :: indexxmax = xpts
    integer            :: indexymin(xpts), indexymax(xpts)

    ! parameters of ellipse (in x, y index coordinates) that limits the data.
    ! x0, y0 correspond to the exact floating point centre of the index
    ! range.
    ! Note: using the Fortran convention of starting indices at 1
    real(kind=pl_test_flt), parameter :: x0 = 0.5_pl_test_flt * ( xpts + 1 )
    real(kind=pl_test_flt), parameter :: a  = 0.9_pl_test_flt * ( x0 - 1.0_pl_test_flt )
    real(kind=pl_test_flt), parameter :: y0 = 0.5_pl_test_flt * ( ypts + 1 )
    real(kind=pl_test_flt), parameter :: b  = 0.7_pl_test_flt * ( y0 - 1.0_pl_test_flt )
    real(kind=pl_test_flt)            :: square_root

    character (len=80) :: title(2) = &
           (/'#frPLplot Example 8 - Alt=60, Az=30 ', &
           '#frPLplot Example 8 - Alt=40, Az=-30'/)
    real(kind=pl_test_flt)   :: alt(2) = (/60.0_pl_test_flt, 40.0_pl_test_flt/)
    real(kind=pl_test_flt)   :: az(2)  = (/30.0_pl_test_flt,-30.0_pl_test_flt/)
    integer            :: rosen
    integer, parameter :: nlevel = 10
    integer :: plparseopts_rc
    real(kind=pl_test_flt)   :: zmin, zmax, step, clevel(nlevel)

    real(kind=pl_test_flt)   :: dx, dy

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    rosen = 0

    !   x(1:xpts) = (arange(xpts) - (xpts-1)/2.0_pl_test_flt) / ((xpts-1)/2.0_pl_test_flt)
    !   y(1:ypts) = (arange(ypts) - (ypts-1)/2.0_pl_test_flt) / ((ypts-1)/2.0_pl_test_flt)
    !

    dx = 2.0_pl_test_flt / (xpts - 1)
    dy = 2.0_pl_test_flt / (ypts - 1)

    do i = 1,xpts
        x(i) = -1.0_pl_test_flt + (i-1) * dx
    enddo

    do j = 1,ypts
        y(j) = -1.0_pl_test_flt + (j-1) * dy
    enddo

    if ( rosen == 1 ) then
        x = 1.5_pl_test_flt * x
        y = y + 0.5_pl_test_flt
    endif

    do i=1,xpts
        xx = x(i)
        do j=1,ypts
            yy = y(j)
            if (rosen == 1) then
                z(i,j) = (1._pl_test_flt - xx)**2 + 100._pl_test_flt*(yy - xx**2)**2

                ! The log argument may be zero for just the right grid.
                if (z(i,j) > 0._pl_test_flt) then
                    z(i,j) = log(z(i,j))
                else
                    z(i,j) = -5._pl_test_flt
                endif
            else
                ! Sombrero function
                r = sqrt(xx**2 + yy**2)
                z(i,j) = exp(-r**2) * cos(2.0_pl_test_flt*PI*r)
            endif
        enddo
    enddo

    zlimited = huge(1.0_pl_test_flt)
    do i = indexxmin, indexxmax
        square_root = sqrt( 1.0_pl_test_flt - min( 1.0_pl_test_flt, (( i - x0 ) / a) ** 2 ) )
        ! Add 0.5 to find nearest integer and therefore preserve symmetry
        ! with regard to lower and upper bound of y range.
        indexymin(i) = max( 1, int( 0.5_pl_test_flt + y0 - b * square_root ) )
        ! indexymax calculated with the convention that it is 1
        ! greater than highest valid index.
        indexymax(i) = min( ypts, 1 + int( 0.5_pl_test_flt + y0 + b * square_root ) )

        do j = indexymin(i),indexymax(i)
            zlimited(i,j) = z(i,j)
        enddo
    enddo

    zmin = minval( z(1:xpts,:) )
    zmax = maxval( z(1:xpts,:) )

    step = (zmax-zmin)/(nlevel+1)
    clevel = zmin + step * arange(1,nlevel+1)

    call plinit()
    call pllightsource(1._pl_test_flt, 1._pl_test_flt, 1._pl_test_flt)
    do k=1,2
        do ifshade = 0, 4
            call pladv(0)
            call plvpor(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 0.9_pl_test_flt )
            call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -0.9_pl_test_flt, 1.1_pl_test_flt )
            call plcol0(3)
            call plmtex('t', 1.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, title(k))
            call plcol0(1)
            if (rosen ==1) then
                call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, -1.5_pl_test_flt, &
                       1.5_pl_test_flt, -0.5_pl_test_flt, 1.5_pl_test_flt, zmin, zmax, alt(k),az(k))
            else
                call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, &
                       1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, zmin, zmax, alt(k),az(k))
            endif
            call plbox3('bnstu','x axis', 0.0_pl_test_flt, 0, &
                   'bnstu', 'y axis', 0.0_pl_test_flt, 0, &
                   'bcdmnstuv','z axis', 0.0_pl_test_flt, 0)
            call plcol0(2)

            select case (ifshade)
            case( 0 )
                ! diffuse light surface plot
                call cmap1_init(1)
                call plsurf3d(x(:xpts), y(:ypts), z(:xpts,:ypts), &
                       0, clevel(nlevel:1))

            case( 1 )
                ! magnitude colored plot
                call cmap1_init(0)
                call plsurf3d(x(:xpts), y(:ypts), z(:xpts,:ypts), &
                       MAG_COLOR, clevel(nlevel:1))

            case( 2 )
                ! magnitude colored plot with faceted squares
                call cmap1_init(0)
                call plsurf3d(x(:xpts), y(:ypts), z(:xpts,:ypts), &
                       ior(MAG_COLOR, FACETED), clevel(nlevel:1))

            case( 3 )
                ! magnitude colored plot with contours
                call cmap1_init(0)
                call plsurf3d(x(:xpts), y(:ypts), z(:xpts,:ypts), &
                       ior(MAG_COLOR, ior(SURF_CONT, BASE_CONT)), clevel)

            case( 4 )
                ! magnitude colored plot with contours and index limits
                call cmap1_init(0)
                ! N.B. indexxmin, indexymin, and indexymax are
                ! calculated above using one-based indexing, but must
                ! substract one from all of them below to convert to
                ! zero-based indexing.  Zero-based indexing is assumed
                ! for those 3 arguments by the Fortran binding to make
                ! that binding consistent with the rest of our
                ! bindings and our core C code in this regard.
                call plsurf3dl(x(:xpts), y(:ypts), zlimited(:xpts,:ypts), &
                       ior(MAG_COLOR, ior(SURF_CONT, BASE_CONT)), clevel, &
                       indexxmin-1, indexymin-1, indexymax-1 )
            case default
                stop 'x08f: bad logic'
            end select
        enddo
    enddo
    call plend
contains

    !----------------------------------------------------------------------------
    subroutine cmap1_init(gray)

        !   For gray.eq.1, basic grayscale variation from half-dark
        !   to light.  Otherwise, hue variations around the front of the
        !   colour wheel from blue to green to red with constant lightness
        !   and saturation.

        integer          :: gray
        real(kind=pl_test_flt) :: i(0:1), h(0:1), l(0:1), s(0:1)

        !   left boundary
        i(0) = 0._pl_test_flt
        !   right boundary
        i(1) = 1._pl_test_flt
        if (gray == 1) then
            !       hue -- low: red (arbitrary if s=0)
            h(0) = 0.0_pl_test_flt
            !       hue -- high: red (arbitrary if s=0)
            h(1) = 0.0_pl_test_flt
            !       lightness -- low: half-dark
            l(0) = 0.5_pl_test_flt
            !       lightness -- high: light
            l(1) = 1.0_pl_test_flt
            !       minimum saturation
            s(0) = 0.0_pl_test_flt
            !       minimum saturation
            s(1) = 0.0_pl_test_flt
        else
            !       This combination of hues ranges from blue to cyan to green to yellow
            !       to red (front of colour wheel) with constant lightness = 0.6
            !       and saturation = 0.8.

            !       hue -- low: blue
            h(0) = 240._pl_test_flt
            !       hue -- high: red
            h(1) = 0.0_pl_test_flt
            !       lightness -- low:
            l(0) = 0.6_pl_test_flt
            !       lightness -- high:
            l(1) = 0.6_pl_test_flt
            !       saturation
            s(0) = 0.8_pl_test_flt
            !       minimum saturation
            s(1) = 0.8_pl_test_flt
        endif
        call plscmap1n(256)
        call plscmap1l(.false., i, h, l, s)
    end subroutine cmap1_init
end program x08f

!      plshades demo, using color fill
!
!      Copyright (C) 2004-2016  Alan W. Irwin
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x16f
    use plplot, double_PI => PL_PI
    use iso_c_binding, only: c_ptr, c_loc, c_f_pointer
    implicit none
    real(kind=pl_test_flt), parameter :: PI = double_PI
    real(kind=pl_test_flt) xx, yy, argx, argy, distort, r, t
    integer NLEVEL, NX, NY, PERIMETERPTS, xdim, ydim
    parameter(NLEVEL = 20)
    !      xdim and ydim are the static dimensions of the 2D arrays while
    !      NX and NY are the defined area.
    parameter(xdim=99, NX = 35)
    parameter(ydim=100, NY = 46)
    parameter(PERIMETERPTS = 100)
    real(kind=pl_test_flt) clevel(NLEVEL), shedge(NLEVEL+1), &
           z(xdim,ydim), w(xdim,ydim), xg1(xdim), yg1(ydim), &
           xg2(xdim,ydim), yg2(xdim,ydim), zmin, zmax, &
           px(PERIMETERPTS), py(PERIMETERPTS)
    integer cont_color
    real(kind=pl_test_flt) fill_width, cont_width
    real(kind=pl_test_flt) colorbar_width, colorbar_height
    integer NUM_AXES, NUM_LABELS
    parameter(NUM_AXES=1, NUM_LABELS=1)
    character(len=20) :: axis_opts(NUM_AXES)
    integer num_values(NUM_AXES)
    real(kind=pl_test_flt) values(NUM_AXES,NLEVEL+1)
    real(kind=pl_test_flt) axis_ticks(NUM_AXES)
    integer axis_subticks(NUM_AXES)
    character(len=100) :: labels(NUM_LABELS)
    integer label_opts(NUM_LABELS)

    integer i, j
    integer :: plparseopts_rc
    real(kind=pl_test_flt) tr(6)

    ! Global parameters to be used in mypltr callback
    real(kind=pl_test_flt), parameter :: xmin = -1.0_pl_test_flt
    real(kind=pl_test_flt), parameter :: xmax =  1.0_pl_test_flt
    real(kind=pl_test_flt), parameter :: ymin = -1.0_pl_test_flt
    real(kind=pl_test_flt), parameter :: ymax =  1.0_pl_test_flt

    ! Use no callback?
    logical, parameter :: no_callback = .false.

    ! Use tr callback? (only meaningful
    ! if no_callback is .false.).
    logical, parameter :: tr_callback = .false.

    ! Use Fortran callback with no data? (only meaningful
    ! if no_callback and tr_callback are .false.).
    logical, parameter :: mypltr_callback = .false.

    type mypltr_data_type
        ! Only contains data required by the mypltr_data callback
        integer :: xpts_data, ypts_data
        real(kind=pl_test_flt) :: xmin_data, xmax_data, ymin_data, ymax_data
    end type mypltr_data_type

    ! Global data type to be used in mypltr_data callback
    type(mypltr_data_type), target :: data

    data%xpts_data = NX
    data%ypts_data = NY
    data%xmin_data = xmin
    data%xmax_data = xmax
    data%ymin_data = ymin
    data%ymax_data = ymax

    tr = (/ (xmax-xmin)/real(NX-1,kind=pl_test_flt), 0.0_pl_test_flt, xmin, &
           0.0_pl_test_flt, (ymax-ymin)/real(NY-1,kind=pl_test_flt), ymin /)

    !      Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !      Load color palettes
    call plspal0('cmap0_black_on_white.pal')
    call plspal1('cmap1_gray.pal', .true.)

    !      Reduce colors in cmap 0 so that cmap 1 is useful on a 16-color display
    call plscmap0n(3)

    !      Initialize plplot

    call plinit()

    !      Calculate the data matrices.
    do i=1,NX
        xx = real(i-1-(NX/2),kind=pl_test_flt)/real(NX/2,kind=pl_test_flt)
        do j=1,NY
            yy = real(j-1-(NY/2),kind=pl_test_flt)/real(NY/2,kind=pl_test_flt) - 1.0_pl_test_flt
            z(i,j) = - sin(7._pl_test_flt*xx) * cos(7._pl_test_flt*yy) + xx*xx - yy*yy
            w(i,j) = - cos(7._pl_test_flt*xx) * sin(7._pl_test_flt*yy) + 2._pl_test_flt*xx*yy
        enddo
    enddo

    call a2mnmx(z, NX, NY, zmin, zmax, xdim)
    do i = 1, NLEVEL
        clevel(i) = zmin + (zmax - zmin) * (i - 0.5_pl_test_flt) / real(NLEVEL,kind=pl_test_flt)
    enddo
    do i = 1, NLEVEL+1
        shedge(i) = zmin + (zmax - zmin) * real(i-1,kind=pl_test_flt) / real(NLEVEL,kind=pl_test_flt)
    enddo

    !      Build the 1-d coord arrays.
    distort = 0.4_pl_test_flt
    do i=1,NX
        xx = -1._pl_test_flt + real(i-1,kind=pl_test_flt)*2._pl_test_flt/real(NX-1,kind=pl_test_flt)
        xg1(i) = xx + distort*cos(0.5_pl_test_flt*PI*xx)
    enddo

    do j=1,NY
        yy = -1._pl_test_flt + real(j-1,kind=pl_test_flt)*2._pl_test_flt/real(NY-1,kind=pl_test_flt)
        yg1(j) = yy - distort*cos(0.5_pl_test_flt*PI*yy)
    enddo

    !      Build the 2-d coord arrays.
    do i=1,NX
        xx = -1._pl_test_flt + real(i-1,kind=pl_test_flt)*2._pl_test_flt/real(NX-1,kind=pl_test_flt)
        argx = 0.5_pl_test_flt*PI*xx
        do j=1,NY
            yy = -1._pl_test_flt + real(j-1,kind=pl_test_flt)*2._pl_test_flt/real(NY-1,kind=pl_test_flt)
            argy = 0.5_pl_test_flt*PI*yy
            xg2(i,j) = xx + distort*cos(argx)*cos(argy)
            yg2(i,j) = yy - distort*cos(argx)*cos(argy)
        enddo
    enddo

    !      Plot using transform of index range to xmin, xmax, ymin, ymax
    call pladv(0)
    call plvpor(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
    call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt)

    call plpsty(0)

    fill_width = 2
    cont_color = 0
    cont_width = 0
    axis_opts(1) = 'bcvtm'
    axis_ticks(1) = 0.0_pl_test_flt
    axis_subticks(1) = 0
    label_opts(1) = PL_COLORBAR_LABEL_BOTTOM
    labels(1) = 'Magnitude'

    if(no_callback) then
        call plshades(z(:NX,:NY), -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, &
               1._pl_test_flt, &
               shedge, fill_width, &
               cont_color, cont_width, .true. )
    elseif(tr_callback) then
        call plshades(z(:NX,:NY), -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, &
               1._pl_test_flt, &
               shedge, fill_width, &
               cont_color, cont_width, .true., tr )
    elseif(mypltr_callback) then
        call plshades(z(:NX,:NY), -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, &
               1._pl_test_flt, &
               shedge, fill_width, &
               cont_color, cont_width, .true., mypltr )
    else
        call plshades(z(:NX,:NY), -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, &
               1._pl_test_flt, &
               shedge, fill_width, &
               cont_color, cont_width, .true., mypltr_data, c_loc(data) )
    endif

    ! Smaller text
    call  plschr( 0.0_pl_test_flt, 0.75_pl_test_flt )
    ! Small ticks on the vertical axis
    call plsmaj( 0.0_pl_test_flt, 0.5_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 0.5_pl_test_flt )

    num_values(1) = NLEVEL + 1;
    values(1,:)   = shedge;
    call plcolorbar( colorbar_width, colorbar_height, &
           ior(PL_COLORBAR_SHADE, PL_COLORBAR_SHADE_LABEL), 0, &
           0.005_pl_test_flt, 0.0_pl_test_flt, 0.0375_pl_test_flt, 0.875_pl_test_flt, 0, 1, 1, &
           0.0_pl_test_flt, 0.0_pl_test_flt, &
           cont_color, cont_width, &
           label_opts, labels, &
           axis_opts, &
           axis_ticks, axis_subticks, &
           num_values, values )

    ! Reset text and tick sizes
    call plschr( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmaj( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 1.0_pl_test_flt )

    call plcol0(1)
    call plbox('bcnst', 0.0_pl_test_flt, 0, 'bcnstv', 0.0_pl_test_flt, 0)
    call plcol0(2)
    call pllab('distance', 'altitude', 'Bogon density')

    !      Plot using 1d coordinate transform

    call plspal0('cmap0_black_on_white.pal')
    call plspal1('cmap1_blue_yellow.pal', .true.)
    call plscmap0n(3)

    call pladv(0)
    call plvpor(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
    call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt)

    call plpsty(0)

    fill_width = 2
    cont_color = 0
    cont_width = 0
    call plshades(z(:NX,:NY), -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, &
           1._pl_test_flt, &
           shedge, fill_width, &
           cont_color, cont_width, .true., xg1(:NX), yg1(:NY))

    ! Smaller text
    call  plschr( 0.0_pl_test_flt, 0.75_pl_test_flt )
    ! Small ticks on the vertical axis
    call plsmaj( 0.0_pl_test_flt, 0.5_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 0.5_pl_test_flt )

    num_values(1) = NLEVEL + 1;
    values(1,:)   = shedge;
    call plcolorbar( colorbar_width, colorbar_height, &
           ior(PL_COLORBAR_SHADE, PL_COLORBAR_SHADE_LABEL), 0, &
           0.005_pl_test_flt, 0.0_pl_test_flt, 0.0375_pl_test_flt, 0.875_pl_test_flt, 0, 1, 1, &
           0.0_pl_test_flt, 0.0_pl_test_flt, &
           cont_color, cont_width, &
           label_opts, labels, &
           axis_opts, &
           axis_ticks, axis_subticks, &
           num_values, values )

    ! Reset text and tick sizes
    call plschr( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmaj( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 1.0_pl_test_flt )

    call plcol0(1)
    call plbox('bcnst', 0.0_pl_test_flt, 0, 'bcnstv', 0.0_pl_test_flt, 0)
    call plcol0(2)
    call pllab('distance', 'altitude', 'Bogon density')

    !      Plot using 2d coordinate transform

    call plspal0('cmap0_black_on_white.pal')
    call plspal1('cmap1_blue_red.pal', .true.)
    call plscmap0n(3)

    call pladv(0)
    call plvpor(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
    call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt)

    call plpsty(0)

    fill_width = 2
    cont_color = 0
    cont_width = 0
    call plshades(z(:NX,:NY), -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, &
           1._pl_test_flt, &
           shedge, fill_width, &
           cont_color, cont_width, .false., xg2(:NX,:NY), yg2(:NX,:NY) )

    ! Smaller text
    call  plschr( 0.0_pl_test_flt, 0.75_pl_test_flt )
    ! Small ticks on the vertical axis
    call plsmaj( 0.0_pl_test_flt, 0.5_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 0.5_pl_test_flt )

    num_values(1) = NLEVEL + 1;
    values(1,:)   = shedge;
    call plcolorbar( colorbar_width, colorbar_height, &
           ior(PL_COLORBAR_SHADE, PL_COLORBAR_SHADE_LABEL), 0, &
           0.005_pl_test_flt, 0.0_pl_test_flt, 0.0375_pl_test_flt, 0.875_pl_test_flt, 0, 1, 1, &
           0.0_pl_test_flt, 0.0_pl_test_flt, &
           cont_color, cont_width, &
           label_opts, labels, &
           axis_opts, &
           axis_ticks, axis_subticks, &
           num_values, values )

    ! Reset text and tick sizes
    call plschr( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmaj( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 1.0_pl_test_flt )

    call plcol0(1)
    call plbox('bcnst', 0.0_pl_test_flt, 0, 'bcnstv', 0.0_pl_test_flt, 0)
    call plcol0(2)
    call plcont(w, 1, nx, 1, ny, clevel, xg2, yg2)
    call pllab('distance', 'altitude', &
           'Bogon density, with streamlines')

    !      Plot using 2d coordinate transform and plshades contours.
    call plspal0('')
    call plspal1('', .true. )
    call plscmap0n(3)

    call pladv(0)
    call plvpor(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
    call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt)

    call plpsty(0)

    fill_width = 2
    cont_color = 2
    cont_width = 3
    call plshades(z(:NX,:NY), -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, &
           1._pl_test_flt, &
           shedge, fill_width, &
           cont_color, cont_width, .false., xg2(:NX,:NY), yg2(:NX,:NY) )

    ! Smaller text
    call  plschr( 0.0_pl_test_flt, 0.75_pl_test_flt )
    ! Small ticks on the vertical axis
    call plsmaj( 0.0_pl_test_flt, 0.5_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 0.5_pl_test_flt )

    num_values(1) = NLEVEL + 1;
    values(1,:)   = shedge;
    call plcolorbar( colorbar_width, colorbar_height, &
           ior(PL_COLORBAR_SHADE, PL_COLORBAR_SHADE_LABEL), 0, &
           0.005_pl_test_flt, 0.0_pl_test_flt, 0.0375_pl_test_flt, 0.875_pl_test_flt, 0, 1, 1, &
           0.0_pl_test_flt, 0.0_pl_test_flt, &
           2, 3._pl_test_flt, &
           label_opts, labels, &
           axis_opts, &
           axis_ticks, axis_subticks, &
           num_values, values )

    ! Reset text and tick sizes
    call plschr( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmaj( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 1.0_pl_test_flt )

    call plcol0(1)
    call plbox('bcnst', 0.0_pl_test_flt, 0, 'bcnstv', 0.0_pl_test_flt, 0)
    call plcol0(2)
    call pllab('distance', 'altitude', 'Bogon density')

    !      Example with polar coordinates.
    call plspal0('cmap0_black_on_white.pal')
    call plspal1('cmap1_gray.pal', .true. )
    call plscmap0n(3)

    call pladv(0)
    call plvpor(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
    call plwind(-1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, 1._pl_test_flt)

    call plpsty(0)

    !      Build new coordinate matrices.
    do i = 1, NX
        r = real(i-1,kind=pl_test_flt)/real(NX-1,kind=pl_test_flt)
        do j = 1, NY
            t = (2._pl_test_flt*PI/real(NY-1,kind=pl_test_flt))*real(j-1,kind=pl_test_flt)
            xg2(i,j) = r*cos(t)
            yg2(i,j) = r*sin(t)
            z(i,j) = exp(-r*r)*cos(5._pl_test_flt*PI*r)*cos(5._pl_test_flt*t)
        enddo
    enddo

    !      Need a new shedge to go along with the new data set.
    call a2mnmx(z, NX, NY, zmin, zmax, xdim)
    do i = 1, NLEVEL+1
        shedge(i) = zmin + (zmax - zmin) * real(i-1,kind=pl_test_flt) / real(NLEVEL,kind=pl_test_flt)
    enddo

    !      Now we can shade the interior region.
    fill_width = 2
    cont_color = 0
    cont_width = 0
    call plshades(z(:NX,:NY), -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, &
           1._pl_test_flt, &
           shedge, fill_width, &
           cont_color, cont_width, .false., xg2(:NX,:NY), yg2(:NX,:NY) )

    ! Smaller text
    call  plschr( 0.0_pl_test_flt, 0.75_pl_test_flt )
    ! Small ticks on the vertical axis
    call plsmaj( 0.0_pl_test_flt, 0.5_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 0.5_pl_test_flt )

    num_values(1) = NLEVEL + 1;
    values(1,:)   = shedge;
    call plcolorbar( colorbar_width, colorbar_height, &
           ior(PL_COLORBAR_SHADE, PL_COLORBAR_SHADE_LABEL), 0, &
           0.005_pl_test_flt, 0.0_pl_test_flt, 0.0375_pl_test_flt, 0.875_pl_test_flt, 0, 1, 1, &
           0.0_pl_test_flt, 0.0_pl_test_flt, &
           cont_color, cont_width, &
           label_opts, labels, &
           axis_opts, &
           axis_ticks, axis_subticks, &
           num_values, values )

    ! Reset text and tick sizes
    call plschr( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmaj( 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsmin( 0.0_pl_test_flt, 1.0_pl_test_flt )

    !      Now we can draw the perimeter.  (If do before, shade stuff may overlap.)
    do i = 1, PERIMETERPTS
        t = (2._pl_test_flt*PI/real(PERIMETERPTS-1,kind=pl_test_flt))*real(i-1,kind=pl_test_flt)
        px(i) = cos(t)
        py(i) = sin(t)
    enddo

    call plcol0(1)
    call plline(px, py)

    !      And label the plot.
    call plcol0(2)
    call pllab( '', '',  'Tokamak Bogon Instability' )

    call plend

contains

    ! Callback function that relies on global NX, NY, xmin, xmax, ymin, ymax
    subroutine mypltr( x, y, xt, yt )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt

        xt = xmin + ((xmax-xmin)/real(NX-1,kind=pl_test_flt))*x
        yt = ymin + ((ymax-ymin)/real(NY-1,kind=pl_test_flt))*y

    end subroutine mypltr

    ! Callback function that uses data argument to pass required data.
    subroutine mypltr_data( x, y, xt, yt, data )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt
        type(c_ptr), intent(in) :: data

        type(mypltr_data_type), pointer :: d
        call c_f_pointer(data, d)

        xt = d%xmin_data + ((d%xmax_data-d%xmin_data)/real(d%xpts_data-1,kind=pl_test_flt))*x
        yt = d%ymin_data + ((d%ymax_data-d%ymin_data)/real(d%ypts_data-1,kind=pl_test_flt))*y

    end subroutine mypltr_data


    !----------------------------------------------------------------------------
    !      Subroutine a2mnmx
    !      Minimum and the maximum elements of a 2-d array.

    subroutine a2mnmx(f, nx, ny, fmin, fmax, xdim)
        use plplot
        implicit none

        integer   i, j, nx, ny, xdim
        real(kind=pl_test_flt)    f(xdim, ny), fmin, fmax

        fmax = f(1, 1)
        fmin = fmax
        do j = 1, ny
            do  i = 1, nx
                fmax = max(fmax, f(i, j))
                fmin = min(fmin, f(i, j))
            enddo
        enddo
    end subroutine a2mnmx
end program x16f

!   Illustration of logarithmic axes, and redefinition of window.
!
!   Copyright (C) 2004-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x04f
    use plplot, double_PI => PL_PI
    use plfortrandemolib
    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    real(kind=pl_test_flt)  :: freql(0:100),ampl(0:100),phase(0:100)
    integer :: plparseopts_rc


    !    Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plinit
    call plfont(2)
    !    Make log plots using two different styles.
    call plot1(0)
    call plot1(1)
    call plend
contains

    subroutine plot1(type)
        integer           :: type
        integer           :: nlegend

        real(kind=pl_test_flt)  :: legend_width, legend_height
        integer           :: opt_array(2), text_colors(2), line_colors(2), &
               line_styles(2), symbol_colors(2), symbol_numbers(2)
        real(kind=pl_test_flt)  :: line_widths(2), symbol_scales(2), box_scales(2)
        integer           :: box_colors(2), box_patterns(2)
        real(kind=pl_test_flt)  :: box_line_widths(2)
        character(len=20) :: text(2)
        character(len=20)  :: symbols(2)

        call pladv(0)
        !    Set up data for log plot.
        call setdata

        call plvpor(0.15_pl_test_flt, 0.85_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
        call plwind(-2.0_pl_test_flt, 3.0_pl_test_flt, -80.0_pl_test_flt, 0.0_pl_test_flt)
        call plcol0(1)
        !    Try different axis and labelling styles.
        if (type.eq.0) then
            call plbox('bclnst', 0.0_pl_test_flt, 0, 'bnstv', 0.0_pl_test_flt, 0)
        elseif (type.eq.1) then
            call plbox('bcfghlnst', 0.0_pl_test_flt, 0, 'bcghnstv', 0.0_pl_test_flt, 0)
        else
            stop 'plot1: invalid type'
        endif
        !    Plot ampl vs freq.
        call plcol0(2)
        call plline(freql,ampl)
        call plcol0(2)
        call plptex(1.6_pl_test_flt, -30.0_pl_test_flt, 1.0_pl_test_flt, -20.0_pl_test_flt, 0.5_pl_test_flt, &
               '-20 dB/decade')
        !    Put labels on.
        call plcol0(1)
        call plmtex('b', 3.2_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, 'Frequency')
        call plmtex('t', 2.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
               'Single Pole Low-Pass Filter')
        call plcol0(2)
        call plmtex('l', 5.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, 'Amplitude (dB)')
        nlegend = 1
        !    For the gridless case, put phase vs freq on same plot.
        if(type == 0) then
            call plcol0(1)
            call plwind(-2.0_pl_test_flt, 3.0_pl_test_flt, -100.0_pl_test_flt, 0.0_pl_test_flt)
            call plbox(' ', 0.0_pl_test_flt, 0, 'cmstv', 30.0_pl_test_flt, 3)
            call plcol0(3)
            call plline(freql, phase)
            call plstring(freql, phase, "#(728)")
            call plcol0(3)
            call plmtex('r', 5.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                   'Phase shift (degrees)')
            nlegend = 2
        endif

        !   Draw a legend
        !   First legend entry.
        opt_array(1)   = PL_LEGEND_LINE
        text_colors(1) = 2
        text(1)        = 'Amplitude'
        line_colors(1) = 2
        line_styles(1) = 1
        line_widths(1) = 1
        !   note from the above opt_array the first symbol (and box) indices
        !   do not have to be specified, at least in C. For Fortran we need
        !   to set the symbols to be something, since the string is always
        !   copied as part of the bindings.
        symbols(1) = ''

        !   Second legend entry.
        opt_array(2)      = PL_LEGEND_LINE + PL_LEGEND_SYMBOL
        text_colors(2)    = 3
        text(2)           = 'Phase shift'
        line_colors(2)    = 3
        line_styles(2)    = 1
        line_widths(2)    = 1
        symbol_colors(2)  = 3
        symbol_scales(2)  = 1.0
        symbol_numbers(2) = 4
        symbols(2)        = "#(728)"

        !   from the above opt_arrays we can completely ignore everything
        !   to do with boxes. (Hence the size 0 for the associated arrays)

        call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )
        call pllegend( legend_width, legend_height, &
               PL_LEGEND_BACKGROUND + PL_LEGEND_BOUNDING_BOX, 0, &
               0.0_pl_test_flt, 0.0_pl_test_flt, 0.1_pl_test_flt, 15, &
               1, 1, 0, 0, &
               opt_array(1:nlegend), &
               1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt, &
               1.0_pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
               box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
               line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
               symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    end subroutine plot1

    subroutine setdata
        real(kind=pl_test_flt), dimension(lbound(freql,1):ubound(freql,1)) :: freq
        real(kind=pl_test_flt) :: f0

        f0 = 1._pl_test_flt

        freql = -2.0_pl_test_flt + arange(lbound(freql,1),ubound(freql,1)+1) / 20.0_pl_test_flt
        freq  = 10.0_pl_test_flt ** freql
        ampl  = 20.0_pl_test_flt * log10(1.0_pl_test_flt/sqrt(1.0_pl_test_flt+(freq/f0)**2))
        phase = -(180.0_pl_test_flt/PI)*atan(freq/f0)
    end subroutine setdata
end program x04f

!   Pie chart demo.
!
!   Copyright (C) 2004-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x13f
    use plplot, double_PI => PL_PI
    implicit none
    real(kind=pl_test_flt), parameter :: PI = double_PI
    real(kind=pl_test_flt)   :: just, dx, dy, x(500), y(500)
    integer            ::  i, j, dthet, theta0, theta1, theta
    integer :: plparseopts_rc
    character(len=20), dimension(5) :: text = &
           (/ 'Maurice ', 'Geoffrey', 'Alan    ', 'Rafael  ', 'Vince   '/)
    real(kind=pl_test_flt)   :: per(5) = &
           (/ 10._pl_test_flt , 32._pl_test_flt , 12._pl_test_flt , 30._pl_test_flt , 16._pl_test_flt /)

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !   Ask user to specify the output device.
    call plinit()

    call pladv(0)
    !   Ensure window has aspect ratio of one so circle is
    !   plotted as a circle.
    call plvasp(1.0_pl_test_flt)
    call plwind(0._pl_test_flt, 10._pl_test_flt, 0._pl_test_flt, 10._pl_test_flt)
    !   call plenv( 0._pl_test_flt, 10._pl_test_flt, 0._pl_test_flt, 10._pl_test_flt, 1, -2 )
    call plcol0(2)

    !   n.b. all theta quantities scaled by 2*pi/500 to be integers to avoid
    !   floating point logic problems.
    theta0 = 0
    dthet = 1

    do i = 0, 4
        j = 0
        x(j+1) = 5._pl_test_flt
        y(j+1) = 5._pl_test_flt
        j = j + 1
        !       n.b. the theta quantities multiplied by 2*pi/500 afterward so
        !       in fact per is interpreted as a percentage.
        theta1 = int(theta0 + 5*per(i+1))
        if (i .eq. 4) theta1 = 500
        do theta = theta0, theta1, dthet
            x(j+1) = 5 + 3*cos((2._pl_test_flt*pi/500._pl_test_flt)*theta)
            y(j+1) = 5 + 3*sin((2._pl_test_flt*pi/500._pl_test_flt)*theta)
            j = j + 1
        enddo

        call plcol0(i+1)
        call plpsty( mod(i+3, 8) + 1 )
        call plfill(x(:j), y(:j))
        call plcol0(1)
        call plline(x(:j), y(:j))

        just = (2._pl_test_flt*pi/500._pl_test_flt)*(theta0 + theta1) / 2._pl_test_flt
        dx = 0.25_pl_test_flt * cos(just)
        dy = 0.25_pl_test_flt * sin(just)
        if ((theta0  + theta1) .lt. 250 .or. &
               (theta0 + theta1) .gt. 750) then
            just = 0._pl_test_flt
        else
            just = 1._pl_test_flt
        endif
        call plptex( x(j/2+1)+dx, y(j/2+1)+dy, 1._pl_test_flt, 0._pl_test_flt, just, text(i+1) )
        theta0 = theta - dthet
    enddo

    call plfont(2)
    call plschr( 0._pl_test_flt, 1.3_pl_test_flt)
    call plptex( 5._pl_test_flt, 9._pl_test_flt, 1._pl_test_flt, 0._pl_test_flt, 0.5_pl_test_flt, 'Percentage of Sales' )

    call plend
end program x13f

!   Simple line plot and multiple windows demo.
!
!   Copyright (C) 2004-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x01f
    use plplot, double_PI => PL_PI
    use :: iso_fortran_env, only: stdout => output_unit
    use plfortrandemolib

    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    real(pl_test_flt) :: xscale, yscale, xoff, yoff
    character(len=80) :: version
    integer :: digmax
    logical, parameter :: locate_mode = .false.
    logical, parameter :: pl_parse_dynamic = .false.
    logical, parameter :: pl_parse_static_length = .false.
    logical, parameter :: pl_parse_static = .false.
!   Declarations for general parsing of the command line
    integer arg_count, nargv
    character(len=200), dimension(0:20) :: argv_static
    character(len=200), dimension(:), allocatable :: argv_static_length
    character(len=:), dimension(:), allocatable :: argv_dynamic

    type(PLGraphicsIn) :: gin
    integer :: PLK_Escape
    integer :: plget_arguments_rc, plparseopts_rc
    data PLK_Escape /Z'1B'/

!   Process command-line arguments
    if(pl_parse_dynamic) then
       write(0,*) "pl_parse_dynamic = ", pl_parse_dynamic
       plget_arguments_rc = plget_arguments(argv_dynamic)
       if(plget_arguments_rc /= 0) stop "plget_arguments error"
       nargv = size(argv_dynamic) - 1
       write(*, '(a)') "argv before call to plparseopts(..., PL_PARSE_SKIP)"
       do arg_count = 0, nargv
          write(*,'(a,i4,a,a)') "i =", arg_count, ", argument = ", trim(argv_dynamic(arg_count))
       enddo
       plparseopts_rc = plparseopts(argv_dynamic, PL_PARSE_SKIP)
       if(plparseopts_rc /= 0) stop "plparseopts error"
       nargv = size(argv_dynamic) - 1

       write(*, '(a)') "argv after call to plparseopts(..., PL_PARSE_SKIP)"
       do arg_count = 0, nargv
          write(*,'(a,i4,a,a)') "i =", arg_count, ", argument = ", trim(argv_dynamic(arg_count))
       enddo
       deallocate(argv_dynamic)
    elseif(pl_parse_static_length) then
       write(0,*) "pl_parse_static_length = ", pl_parse_static_length
       plget_arguments_rc = plget_arguments(argv_static_length, 1)
       if(plget_arguments_rc /= 0) stop "plget_arguments error"
       nargv = size(argv_static_length) - 1
       write(*, '(a)') "argv before call to plparseopts(..., PL_PARSE_SKIP)"
       do arg_count = 0, nargv
          write(*,'(a,i4,a,a)') "i =", arg_count, ", argument = ", trim(argv_static_length(arg_count))
       enddo
       plparseopts_rc = plparseopts(argv_static_length, PL_PARSE_SKIP, 1)
       if(plparseopts_rc /= 0) stop "plparseopts error"
       nargv = size(argv_static_length) - 1

       write(*, '(a)') "argv after call to plparseopts(..., PL_PARSE_SKIP)"
       do arg_count = 0, nargv
          write(*,'(a,i4,a,a)') "i =", arg_count, ", argument = ", trim(argv_static_length(arg_count))
       enddo
       deallocate(argv_static_length)
    elseif(pl_parse_static) then
       write(0,*) "pl_parse_static = ", pl_parse_static
       plget_arguments_rc = plget_arguments(nargv, argv_static)
       if(plget_arguments_rc /= 0) stop "plget_arguments error"
       write(*, '(a)') "argv before call to plparseopts(..., PL_PARSE_SKIP)"
       do arg_count = 0, nargv
          write(*,'(a,i4,a,a)') "i =", arg_count, ", argument = ", trim(argv_static(arg_count))
       enddo
       plparseopts_rc = plparseopts(nargv, argv_static(0:nargv), PL_PARSE_SKIP)
       if(plparseopts_rc /= 0) stop "plparseopts error"

       write(*, '(a)') "argv after call to plparseopts(..., PL_PARSE_SKIP)"
       do arg_count = 0, nargv
          write(*,'(a,i4,a,a)') "i =", arg_count, ", argument = ", trim(argv_static(arg_count))
       enddo
    else
       plparseopts_rc = plparseopts(PL_PARSE_SKIP)
       if(plparseopts_rc .ne. 0) stop "plparseopts error"
    endif

    !  Print plplot version
    call plgver(version)
    write (*,'(a,a)') 'PLplot library version: ', trim(version)

    !  Initialize plplot
    !  Divide page into 2x2 plots
    call plstar(2,2)

    !  Set up the data
    !  Original case

    xscale = 6._pl_test_flt
    yscale = 1._pl_test_flt
    xoff = 0._pl_test_flt
    yoff = 0._pl_test_flt

    !  Do a plot

    call plot1()

    !  Set up the data

    xscale = 1._pl_test_flt
    yscale = 0.0014_pl_test_flt
    yoff = 0.0185_pl_test_flt

    !  Do a plot

    digmax = 5
    call plsyax(digmax,  0)
    call plot1()

    call plot2()
    call plot3()

    if( locate_mode ) then
        do while(.true.)

            ! plGetCursor returns zero value for some devices (e.g., xwin) when
            ! the user hits the escape key or hits a mouse button or key when outside
            ! a subwindow.
            if( plGetCursor( gin ) == 0 ) exit

            ! For some devices (e.g., xcairo) plGetCursor always returns 0, but if the user hits the escape
            ! key or hits a mouse button or key when outside a subwindow, the returned keysym is PLK_escape
            if( gin%keysym == PLK_escape ) exit

            write(stdout, "(a,i3,a,f0.6,a,f0.6,a,f0.6,a,f0.6)") &
                   "subwin = ", gin%subwindow, ", wx = ", gin%wX, ", wy = ", gin%wY, &
                   ", dx = ", gin%dX, ", dy = ", gin%dY
            write(stdout, "(a,z0,a,z0,a,a,z0,a,z0)") &
                   "keysym = 0x", gin%keysym, ", button = 0x", gin%button, ", string = '"//trim(gin%string)//"'", &
                   ", type = 0x", gin%type, ", state = 0x", gin%state
        enddo
    end if

    !  Don't forget to call PLEND to finish off!

    call plend()

contains

    !======================================================================
    subroutine plot1()

        real(pl_test_flt), dimension(1:60) :: x, y
        real(pl_test_flt) :: xmin, xmax, ymin, ymax

        x = xoff + xscale * arange(1,size(x)+1) / real(size(x),pl_test_flt)
        y = yoff + yscale * x ** 2

        xmin = minval(x)
        xmax = maxval(x)
        ymin = minval(y)
        ymax = maxval(y)

        !   Set up the viewport and window using PLENV. The range in X is
        !   0.0 to 6.0, and the range in Y is 0.0 to 30.0. The axes are
        !   scaled separately (just = 0), and we just draw a labelled
        !   box (axis = 0).

        call plcol0(1)
        call plenv( xmin, xmax, ymin, ymax, 0, 0 )
        call plcol0(2)
        call pllab( '(x)', '(y)', '#frPLplot Example 1 - y=x#u2' )

        !   Plot the data points
        !   Only plot every tenth!

        call plcol0(4)
        call plpoin( x(4::10), y(4::10), 9 )

        !   Draw the line through the data

        call plcol0(3)
        call plline( x, y )

    end subroutine plot1

    !======================================================================
    subroutine plot2()

        real(pl_test_flt), dimension(1:100) :: x, y

        !
        !   Set up the viewport and window using PLENV. The range in X is
        !   -2.0 to 10.0, and the range in Y is -0.4 to 2.0. The axes are
        !   scaled separately (just = 0), and we draw a box with axes
        !   (axis = 1).

        call plcol0(1)
        call plenv(-2.0_pl_test_flt, 10.0_pl_test_flt, -0.4_pl_test_flt, 1.2_pl_test_flt, 0, 1 )
        call plcol0(2)
        call pllab( '(x)', 'sin(x)/x', '#frPLplot Example 1 - Sinc Function' )

        !   Fill up the arrays


        x = ( arange(size(x)) - 19 ) / 6.0_pl_test_flt
        y = merge( sin(x) / x, 1.0_pl_test_flt, x /= 0.0_pl_test_flt )

        !   Draw the line

        call plcol0(3)
        call plwidth(2._pl_test_flt)
        call plline( x, y )
        call plwidth(1._pl_test_flt)

    end subroutine plot2

    !======================================================================
    subroutine plot3()

        !
        !   For the final graph we wish to override the default tick intervals,
        !   and so do not use_ PLENV

        real(pl_test_flt), dimension(1:101) :: x, y

        call pladv(0)

        !   Use_ standard viewport, and define X range from 0 to 360 degrees,
        !   Y range from -1.2 to 1.2.

        call plvsta()
        call plwind( 0.0_pl_test_flt, 360.0_pl_test_flt, -1.2_pl_test_flt, 1.2_pl_test_flt )

        !   Draw a box with ticks spaced 60 degrees apart in X, and 0.2 in Y.

        call plcol0(1)
        call plbox( 'bcnst', 60.0_pl_test_flt, 2, 'bcnstv', 0.2_pl_test_flt, 2 )

        !   Superimpose a dashed line grid, with 1.5 mm marks and spaces. With
        !   only a single mark and space element, we do not need arrays

        call plstyl( (/1500/), (/1500/) )
        call plcol0(2)
        call plbox( 'g', 30.0_pl_test_flt, 0, 'g', 0.2_pl_test_flt, 0 )
        call plstyl( (/integer ::/), (/integer ::/) )

        call plcol0(3)
        call pllab( 'Angle (degrees)', 'sine', '#frPLplot Example 1 - Sine function' )

        x = 3.6_pl_test_flt * arange(size(x))
        y = sin( x * PI/180.0_pl_test_flt )

        call plcol0(4)
        call plline( x, y )

    end subroutine plot3

end program x01f

!     Demonstrate most pllegend capability including unicode symbols.
!
!     Copyright (C) 2010-2016 Alan W. Irwin
!
!     This file is part of PLplot.
!
!     PLplot is free software; you can redistribute it and/or modify
!     it under the terms of the GNU Library General Public License as published
!     by the Free Software Foundation; either version 2 of the License, or
!     (at your option) any later version.
!
!     PLplot is distributed in the hope that it will be useful,
!     but WITHOUT ANY WARRANTY; without even the implied warranty of
!     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!     GNU Library General Public License for more details.
!
!     You should have received a copy of the GNU Library General Public License
!     along with PLplot; if not, write to the Free Software
!     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!     This example designed just for devices (e.g., the cairo-related and
!     qt-related devices) where the best choice of glyph is automatically
!     selected by the related libraries (pango/cairo or Qt4) for each
!     unicode character depending on what system fonts are installed.  Of
!     course, you must have the appropriate TrueType fonts installed to
!     have access to all the required glyphs.


!--------------------------------------------------------------------------
!  main
!
!  Demonstrate most pllegend capability including unicode symbols.
! --------------------------------------------------------------------------

program x33f
    use plplot

    implicit none

    integer, parameter :: MAX_NLEGEND = 7

    integer            :: i, k
    integer            :: opt, position
    integer            :: nlegend, nturn
    integer            :: opt_array(MAX_NLEGEND)
    integer            :: text_colors(MAX_NLEGEND)
    integer            :: box_colors(MAX_NLEGEND)
    integer            :: box_patterns(MAX_NLEGEND)
    real(kind=pl_test_flt)   :: box_scales(MAX_NLEGEND)
    real(kind=pl_test_flt)   :: box_line_widths(MAX_NLEGEND)
    integer            :: line_colors(MAX_NLEGEND)
    integer            :: line_styles(MAX_NLEGEND)
    real(kind=pl_test_flt)   :: line_widths(MAX_NLEGEND)
    integer            :: symbol_numbers(MAX_NLEGEND), symbol_colors(MAX_NLEGEND)
    real(kind=pl_test_flt)   :: symbol_scales(MAX_NLEGEND)
    character(len=200) :: text(MAX_NLEGEND)
    character(len=20)  :: symbols(MAX_NLEGEND)
    real(kind=pl_test_flt)   :: legend_width, legend_height, x, y, xstart, ystart
    real(kind=pl_test_flt)   :: max_height, text_scale
    integer            :: opt_base, nrow, ncolumn

    integer            :: position_options(16)
    character(len=3)   :: special_symbols(5)

    real(kind=pl_test_flt)   :: values_small(2)
    real(kind=pl_test_flt)   :: values_uneven(9)
    real(kind=pl_test_flt)   :: values_even(9)

    integer, parameter :: COLORBAR_KINDS = 4
    integer            :: colorbar_option_kinds(COLORBAR_KINDS)
    character(len=100) :: colorbar_option_kind_labels(COLORBAR_KINDS)

    integer, parameter :: COLORBAR_POSITIONS = 4
    integer            :: colorbar_position_options(COLORBAR_POSITIONS)
    character(len=100) :: colorbar_position_option_labels(COLORBAR_POSITIONS)

    integer, parameter :: COLORBAR_LABELS = 4
    integer            :: colorbar_label_options(COLORBAR_LABELS)
    character(len=100) :: colorbar_label_option_labels(COLORBAR_LABELS)

    integer, parameter :: COLORBAR_CAPS = 4
    integer            :: colorbar_cap_options(COLORBAR_CAPS)
    integer :: plparseopts_rc
    character(len=100) :: colorbar_cap_option_labels(COLORBAR_CAPS)

    !     Pick 5 arbitrary UTF-8 symbols useful for plotting points (✠✚✱✪✽✺✰✴✦).
    data special_symbols / &
           '✰',             &
           '✴',             &
           '✱',             &
           '✽',             &
           '✦'              /

    data values_small   / -1.0_pl_test_flt, 1.0_pl_test_flt /
    data values_uneven &
           / -1.0_pl_test_flt, 2.0_pl_test_flt, 2.6_pl_test_flt, 3.4_pl_test_flt, &
           6.0_pl_test_flt, 7.0_pl_test_flt, 8.0_pl_test_flt, 9.0_pl_test_flt, &
           10.0_pl_test_flt /
    data values_even &
           / -2.0_pl_test_flt, -1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt, &
           2.0_pl_test_flt, 3.0_pl_test_flt, 4.0_pl_test_flt, 5.0_pl_test_flt, &
           6.0_pl_test_flt /

    real(kind=pl_test_flt), parameter :: small_factor = 1.e-20_pl_test_flt

    values_small = small_factor*values_small
    values_uneven = small_factor*values_uneven
    values_even = small_factor*values_even

    position_options(1) = PL_POSITION_LEFT + PL_POSITION_TOP + PL_POSITION_OUTSIDE
    position_options(2) = PL_POSITION_TOP + PL_POSITION_OUTSIDE
    position_options(3) = PL_POSITION_RIGHT + PL_POSITION_TOP + PL_POSITION_OUTSIDE
    position_options(4) = PL_POSITION_RIGHT + PL_POSITION_OUTSIDE
    position_options(5) = PL_POSITION_RIGHT + PL_POSITION_BOTTOM + PL_POSITION_OUTSIDE
    position_options(6) = PL_POSITION_BOTTOM + PL_POSITION_OUTSIDE
    position_options(7) = PL_POSITION_LEFT + PL_POSITION_BOTTOM + PL_POSITION_OUTSIDE
    position_options(8) = PL_POSITION_LEFT + PL_POSITION_OUTSIDE
    position_options(9) = PL_POSITION_LEFT + PL_POSITION_TOP + PL_POSITION_INSIDE
    position_options(10) = PL_POSITION_TOP + PL_POSITION_INSIDE
    position_options(11) = PL_POSITION_RIGHT + PL_POSITION_TOP + PL_POSITION_INSIDE
    position_options(12) = PL_POSITION_RIGHT + PL_POSITION_INSIDE
    position_options(13) = PL_POSITION_RIGHT + PL_POSITION_BOTTOM + PL_POSITION_INSIDE
    position_options(14) = PL_POSITION_BOTTOM + PL_POSITION_INSIDE
    position_options(15) = PL_POSITION_LEFT + PL_POSITION_BOTTOM + PL_POSITION_INSIDE
    position_options(16) = PL_POSITION_LEFT + PL_POSITION_INSIDE

    ! plcolorbar options

    ! Colorbar type options
    colorbar_option_kinds(1) = PL_COLORBAR_SHADE
    colorbar_option_kinds(2) = PL_COLORBAR_SHADE + PL_COLORBAR_SHADE_LABEL
    colorbar_option_kinds(3) = PL_COLORBAR_IMAGE
    colorbar_option_kinds(4) = PL_COLORBAR_GRADIENT

    colorbar_option_kind_labels(1) = "Shade colorbars"
    colorbar_option_kind_labels(2) = "Shade colorbars with custom labels"
    colorbar_option_kind_labels(3) = "Image colorbars"
    colorbar_option_kind_labels(4) = "Gradient colorbars"

    ! Which side of the page are we positioned relative to?
    colorbar_position_options(1) = PL_POSITION_LEFT
    colorbar_position_options(2) = PL_POSITION_RIGHT
    colorbar_position_options(3) = PL_POSITION_TOP
    colorbar_position_options(4) = PL_POSITION_BOTTOM

    colorbar_position_option_labels(1) = "Left"
    colorbar_position_option_labels(2) = "Right"
    colorbar_position_option_labels(3) = "Top"
    colorbar_position_option_labels(4) = "Bottom"

    ! Colorbar label positioning options
    colorbar_label_options(1) = PL_COLORBAR_LABEL_LEFT
    colorbar_label_options(2) = PL_COLORBAR_LABEL_RIGHT
    colorbar_label_options(3) = PL_COLORBAR_LABEL_TOP
    colorbar_label_options(4) = PL_COLORBAR_LABEL_BOTTOM

    colorbar_label_option_labels(1) = "Label left"
    colorbar_label_option_labels(2) = "Label right"
    colorbar_label_option_labels(3) = "Label top"
    colorbar_label_option_labels(4) = "Label bottom"

    ! Colorbar cap options
    colorbar_cap_options(1) = PL_COLORBAR_CAP_NONE
    colorbar_cap_options(2) = PL_COLORBAR_CAP_LOW
    colorbar_cap_options(3) = PL_COLORBAR_CAP_HIGH
    colorbar_cap_options(4) = PL_COLORBAR_CAP_LOW + PL_COLORBAR_CAP_HIGH

    colorbar_cap_option_labels(1) = "No caps"
    colorbar_cap_option_labels(2) = "Low cap"
    colorbar_cap_option_labels(3) = "High cap"
    colorbar_cap_option_labels(4) = "Low and high caps"

    !     Parse and process command line arguments

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !     Initialize plplot
    call plinit

    !     First page illustrating the 16 standard positions.
    call pladv( 0 )
    call plvpor( 0.25_pl_test_flt, 0.75_pl_test_flt, 0.25_pl_test_flt, 0.75_pl_test_flt )
    call plwind( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plbox( 'bc', 0.0_pl_test_flt, 0, 'bc', 0.0_pl_test_flt, 0 )
    call plsfont( PL_FCI_SANS, -1, -1 )
    call plmtex( 't', 8.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
           'The 16 standard legend positions with' )
    call plmtex( 't', 6.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
           'the same (0.05) offset in x and y' )

    nlegend = 1
    !     Only specify legend data that are required according to the
    !     value of opt_array for that entry.
    opt_base          = PL_LEGEND_BACKGROUND + PL_LEGEND_BOUNDING_BOX
    opt_array(1)      = PL_LEGEND_LINE + PL_LEGEND_SYMBOL
    line_styles(1)    = 1
    line_widths(1)    = 1
    symbol_scales(1)  = 1._pl_test_flt
    symbol_numbers(1) = 4
    symbols(1)        = "#(728)"

    !     Use monotype fonts so that all legends are the same size.
    call plsfont( PL_FCI_MONO, -1, -1 )
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    do k = 1,16
        position = position_options(k)
        opt = opt_base
        text_colors(1)   = 1 + mod( k-1, 8 )
        line_colors(1)   = 1 + mod( k-1, 8 )
        symbol_colors(1) = 1 + mod( k-1, 8 )
        write( text(1), '(i2.2)' ) k-1

        call pllegend( legend_width, legend_height, opt, position, &
               0.05_pl_test_flt, 0.05_pl_test_flt,                                &
               0.1_pl_test_flt, 15, 1, 1, 0, 0,                             &
               opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt, &
               1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend),     &
               box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
               line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
               symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend)  )
    enddo

    !     Second page illustrating effect of nrow, ncolumn for the same legend
    !     data.

    call pladv( 0 )
    call plvpor( 0.25_pl_test_flt, 0.75_pl_test_flt, 0.25_pl_test_flt, 0.75_pl_test_flt )
    call plwind( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plbox( 'bc', 0.0_pl_test_flt, 0, 'bc', 0.0_pl_test_flt, 0 )
    call plsfont( PL_FCI_SANS, -1, -1 )
    call plmtex( 't', 8.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
           'The effect of nrow, ncolumn, PL_LEGEND_ROW_MAJOR,' )
    call plmtex( 't', 6.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
           'and position for the same legend data' )

    nlegend = 7

    !     Only specify legend data that are required according to the
    !     value of opt_array for that entry.

    opt_base = PL_LEGEND_BACKGROUND + PL_LEGEND_BOUNDING_BOX
    do k = 1,nlegend
        opt_array(k)      = PL_LEGEND_LINE + PL_LEGEND_SYMBOL
        line_styles(k)    = 1
        line_widths(k)    = 1
        symbol_scales(k)  = 1._pl_test_flt
        symbol_numbers(k) = 2
        symbols(k)        = "#(728)"
        write( text(k), '(i2.2)' ) k-1
        text_colors(k)   = 1 + mod( k-1, 8 )
        line_colors(k)   = 1 + mod( k-1, 8 )
        symbol_colors(k) = 1 + mod( k-1, 8 )
    enddo

    !     Use monotype fonts so that all legends are the same size.

    call plsfont( PL_FCI_MONO, -1, -1 )
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    position = PL_POSITION_TOP + PL_POSITION_OUTSIDE
    opt     = opt_base
    x       = 0._pl_test_flt
    y       = 0.1_pl_test_flt
    nrow    = 1
    ncolumn = nlegend
    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.05_pl_test_flt, 15, 1, 1, nrow, ncolumn,                         &
           opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt,       &
           1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )

    position = PL_POSITION_BOTTOM + PL_POSITION_OUTSIDE
    opt     = opt_base
    x       = 0._pl_test_flt
    y       = 0.1_pl_test_flt
    nrow    = 1
    ncolumn = nlegend
    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.05_pl_test_flt, 15, 1, 1, nrow, ncolumn,                         &
           opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt,       &
           1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )

    position = PL_POSITION_LEFT + PL_POSITION_OUTSIDE
    opt     = opt_base
    x       = 0.1_pl_test_flt
    y       = 0._pl_test_flt
    nrow    = nlegend
    ncolumn = 1
    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.05_pl_test_flt, 15, 1, 1, nrow, ncolumn,                         &
           opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt,       &
           1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )

    position = PL_POSITION_RIGHT + PL_POSITION_OUTSIDE
    opt     = opt_base
    x       = 0.1_pl_test_flt
    y       = 0._pl_test_flt
    nrow    = nlegend
    ncolumn = 1
    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.05_pl_test_flt, 15, 1, 1, nrow, ncolumn,                         &
           opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt,       &
           1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )

    position = PL_POSITION_LEFT + PL_POSITION_TOP + PL_POSITION_INSIDE
    opt     = opt_base
    x       = 0._pl_test_flt
    y       = 0._pl_test_flt
    nrow    = 6
    ncolumn = 2
    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.05_pl_test_flt, 15, 1, 1, nrow, ncolumn,                         &
           opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt,       &
           1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )

    position = PL_POSITION_RIGHT + PL_POSITION_TOP + PL_POSITION_INSIDE
    opt     = opt_base + PL_LEGEND_ROW_MAJOR
    x       = 0._pl_test_flt
    y       = 0._pl_test_flt
    nrow    = 6
    ncolumn = 2
    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.05_pl_test_flt, 15, 1, 1, nrow, ncolumn,                         &
           opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt,       &
           1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )

    position = PL_POSITION_BOTTOM + PL_POSITION_INSIDE
    opt     = opt_base + PL_LEGEND_ROW_MAJOR
    x       = 0._pl_test_flt
    y       = 0._pl_test_flt
    nrow    = 3
    ncolumn = 3
    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.05_pl_test_flt, 15, 1, 1, nrow, ncolumn,                         &
           opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt,       &
           1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )

    !     Third page demonstrating legend alignment

    call pladv( 0 )
    call plvpor( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 0.9_pl_test_flt )
    call plwind( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
    call plsfont( PL_FCI_SANS, -1, -1 )
    call plmtex( 't', 2.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
           'Demonstrate legend alignment' )

    x        = 0.1_pl_test_flt
    y        = 0.1_pl_test_flt
    nturn    = 5
    nlegend  = 0
    position = PL_POSITION_TOP + PL_POSITION_LEFT + PL_POSITION_SUBPAGE
    opt_base = PL_LEGEND_BACKGROUND + PL_LEGEND_BOUNDING_BOX
    opt      = opt_base
    do i = 1,9

        !         Set up legend arrays with the correct size, type.

        if ( i .le. nturn ) then
            nlegend = nlegend + 1
        else
            nlegend = nlegend - 1
        endif
        nlegend = max( 1, nlegend )

        !         nly specify legend data that are required according to the
        !         value of opt_array for that entry.

        do k = 1,nlegend
            opt_array(k)      = PL_LEGEND_LINE + PL_LEGEND_SYMBOL
            line_styles(k)    = 1
            line_widths(k)    = 1
            symbol_scales(k)  = 1._pl_test_flt
            symbol_numbers(k) = 2
            symbols(k)        = "#(728)"
            write( text(k), '(i2.2)' ) k-1
            text_colors(k)   = 1 + mod( k-1, 8 )
            line_colors(k)   = 1 + mod( k-1, 8 )
            symbol_colors(k) = 1 + mod( k-1, 8 )
        enddo

        !         Use monotype fonts so that all legends are the same size.

        call plsfont( PL_FCI_MONO, -1, -1 )
        call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

        nrow    = MIN( 3, nlegend )
        ncolumn = 0

        call pllegend( legend_width, legend_height, opt, position, &
               x, y,                                                  &
               0.025_pl_test_flt, 15, 1, 1, nrow, ncolumn,                  &
               opt_array(1:nlegend), 1.0_pl_test_flt, 1.0_pl_test_flt, 1.5_pl_test_flt, &
               1._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
               box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
               line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
               symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )

        if ( i .eq. nturn ) then
            position = PL_POSITION_TOP + PL_POSITION_RIGHT + PL_POSITION_SUBPAGE
            opt = opt_base
            x   = 1._pl_test_flt - x
            y   = y + legend_height
        else
            x = x + legend_width
            y = y + legend_height
        endif
    enddo

    !     Fourth page illustrating various kinds of legends

    max_height = 0._pl_test_flt
    xstart     = 0.0_pl_test_flt
    ystart     = 0.1_pl_test_flt
    x          = xstart
    y          = ystart
    text_scale = 0.90_pl_test_flt
    call pladv( 0 )
    call plvpor( 0.0_pl_test_flt, 1._pl_test_flt, 0.0_pl_test_flt, 0.90_pl_test_flt )
    call plwind( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
    !       call plbox('bc', 0.0, 0, 'bc', 0.0_pl_test_flt, 0)
    call plsfont( PL_FCI_SANS, -1, -1 )
    call plmtex( 't', 2.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
           'Demonstrate Various Kinds of Legends' )

    nlegend = 5

    !     Only specify legend data that are required according to the
    !     value of opt_array for that entry.

    position = PL_POSITION_LEFT + PL_POSITION_TOP
    opt_base = PL_LEGEND_BACKGROUND + PL_LEGEND_BOUNDING_BOX + PL_LEGEND_TEXT_LEFT

    !     Set up None, Box, Line, Symbol, and Line & Symbol legend entries.

    opt_array(1) = PL_LEGEND_NONE
    text(1) = 'None'
    text_colors(1) = 1

    opt_array(2) = PL_LEGEND_COLOR_BOX
    text(2) = 'Box'
    text_colors(2)     = 2
    box_colors(2)      = 2
    box_patterns(2)    = 0
    box_scales(2)      = 0.8_pl_test_flt
    box_line_widths(2) = 1

    opt_array(3) = PL_LEGEND_LINE
    text(3) = 'Line'
    text_colors(3) = 3
    line_colors(3) = 3
    line_styles(3) = 1
    line_widths(3) = 1

    opt_array(4) = PL_LEGEND_SYMBOL
    text(4) = 'Symbol'
    text_colors(4)    = 4
    symbol_colors(4)  = 4
    symbol_scales(4)  = text_scale
    symbol_numbers(4) = 4
    symbols(4)        = special_symbols(3)

    opt_array(5) = PL_LEGEND_SYMBOL + PL_LEGEND_LINE
    text(5) = 'L & S'
    text_colors(5)    = 5
    line_colors(5)    = 5
    line_styles(5)    = 1
    line_widths(5)    = 1
    symbol_colors(5)  = 5
    symbol_scales(5)  = text_scale
    symbol_numbers(5) = 4
    symbols(5)        = special_symbols(3)

    opt = opt_base
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Set up symbol legend entries with various symbols.

    do i = 1,nlegend
        opt_array(i) = PL_LEGEND_SYMBOL
        text(i) = 'Symbol ' // special_symbols(i)
        text_colors(i)    = i
        symbol_colors(i)  = i
        symbol_scales(i)  = text_scale
        symbol_numbers(i) = 4
        symbols(i)        = special_symbols(i)
    enddo

    opt = opt_base
    x   = x + legend_width
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Set up symbol legend entries with various numbers of symbols.

    do i = 1,nlegend
        opt_array(i) = PL_LEGEND_SYMBOL
        write( text(i), '(a,i0)' ) 'Symbol Number ', i+1
        text_colors(i)    = i
        symbol_colors(i)  = i
        symbol_scales(i)  = text_scale
        symbol_numbers(i) = i + 1
        symbols(i)        = special_symbols(3)
    enddo

    opt = opt_base
    x   = x + legend_width
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Set up box legend entries with various colours.

    do i = 1,nlegend
        opt_array(i) = PL_LEGEND_COLOR_BOX
        write( text(i), '(a,i0)' ) 'Box Color ', i
        text_colors(i)     = i
        box_colors(i)      = i
        box_patterns(i)    = 0
        box_scales(i)      = 0.8_pl_test_flt
        box_line_widths(i) = 1
    enddo

    opt = opt_base

    !     Use new origin

    x          = xstart
    y          = y + max_height
    max_height = 0._pl_test_flt
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt)

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Set up box legend entries with various patterns.

    do i = 1,nlegend
        opt_array(i) = PL_LEGEND_COLOR_BOX
        write( text(i), '(a,i0)' ) 'Box Pattern ', i-1
        text_colors(i)     = 2
        box_colors(i)      = 2
        box_patterns(i)    = i - 1
        box_scales(i)      = 0.8_pl_test_flt
        box_line_widths(i) = 1
    enddo

    opt = opt_base
    x   = x + legend_width
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Set up box legend entries with various box pattern line widths.

    do i = 1,nlegend
        opt_array(i) = PL_LEGEND_COLOR_BOX
        write( text(i), '(a,i0)' ) 'Box Line Width ', i
        text_colors(i)     = 2
        box_colors(i)      = 2
        box_patterns(i)    = 3
        box_scales(i)      = 0.8_pl_test_flt
        box_line_widths(i) = i
    enddo

    opt = opt_base
    x   = x + legend_width
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Set up line legend entries with various colours.

    do i =1,nlegend
        opt_array(i) = PL_LEGEND_LINE
        write( text(i), '(a,i0)' ) 'Line Color ', i
        text_colors(i) = i
        line_colors(i) = i
        line_styles(i) = 1
        line_widths(i) = 1
    enddo

    opt = opt_base

    !     Use new origin

    x          = xstart
    y          = y + max_height
    max_height = 0._pl_test_flt
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Set up line legend entries with various styles.

    do i = 1,nlegend
        opt_array(i) = PL_LEGEND_LINE
        write( text(i), '(a,i0)' ) 'Line Style ', i
        text_colors(i) = 2
        line_colors(i) = 2
        line_styles(i) = i
        line_widths(i) = 1
    enddo

    opt = opt_base
    x   = x + legend_width
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Set up line legend entries with various widths.

    do i =1,nlegend
        opt_array(i) = PL_LEGEND_LINE
        write( text(i), '(a,i0)' ) 'Line Width ', i
        text_colors(i) = 2
        line_colors(i) = 2
        line_styles(i) = 1
        line_widths(i) = i
    enddo

    opt = opt_base
    x   = x + legend_width
    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )

    call pllegend( legend_width, legend_height, opt, position, x, y, &
           0.1_pl_test_flt, 15, 1, 1, 0, 0,                                   &
           opt_array(1:nlegend), 1.0_pl_test_flt, text_scale, 2.0_pl_test_flt,      &
           0._pl_test_flt, text_colors(1:nlegend), text(1:nlegend), &
           box_colors(1:nlegend), box_patterns(1:nlegend), box_scales(1:nlegend), box_line_widths(1:nlegend), &
           line_colors(1:nlegend), line_styles(1:nlegend), line_widths(1:nlegend), &
           symbol_colors(1:nlegend), symbol_scales(1:nlegend), symbol_numbers(1:nlegend), symbols(1:nlegend) )
    max_height = max( max_height, legend_height )

    !     Color bar examples

    ! Use unsaturated green background colour to contrast with black caps.
    call plscolbg( 70, 185, 70 )
    ! Cut out the greatest and smallest bits of the color spectrum to
    ! leave colors for the end caps.
    call plscmap1_range( 0.01_pl_test_flt, 0.99_pl_test_flt )

    ! We can only test image and gradient colorbars with two element arrays
    do i = 2,COLORBAR_KINDS-1
        call plcolorbar_example( "cmap1_blue_yellow.pal", i, 0, 0._pl_test_flt, 2, values_small )
    enddo
    ! Test shade colorbars with larger arrays
    do i = 0,1
        call plcolorbar_example( "cmap1_blue_yellow.pal", i, 4, 2._pl_test_flt, 9, values_even )
    enddo
    do i = 0,1
        call plcolorbar_example( "cmap1_blue_yellow.pal", i, 0, 0._pl_test_flt, 9, values_uneven )
    enddo

    call plend()

contains

    subroutine plcolorbar_example_page( kind_i, label_i, cap_i, cont_color, cont_width, n_values, values )

        use plplot

        implicit none

        integer  :: kind_i, label_i, cap_i, cont_color, n_values
        real(kind=pl_test_flt)   :: cont_width
        real(kind=pl_test_flt), dimension(:)   :: values

        ! Parameters for the colorbars on this page
        integer            :: position_i, position, opt
        real(kind=pl_test_flt)   :: x, y, x_length, y_length;
        real(kind=pl_test_flt)   :: ticks(1)
        integer            :: sub_ticks(1)
        real(kind=pl_test_flt)   :: low_cap_color, high_cap_color
        logical            :: vertical, ifn
        character(len=20)  :: axis_opts(1)
        integer            :: label_opts(1)
        character(len=200) :: labels(1)
        character(len=200) :: title
        real(kind=pl_test_flt)   :: colorbar_width, colorbar_height
        integer            :: n_values_array(1);
        real(kind=pl_test_flt), allocatable, dimension(:,:) :: values_array

        ticks(1) = 0.0_pl_test_flt
        sub_ticks(1) = 0
        label_opts(1) = 0

        n_values_array(1) = n_values
        allocate(values_array(1,n_values))
        values_array(1,:) = values(:)

        low_cap_color  = 0.0_pl_test_flt;
        high_cap_color = 1.0_pl_test_flt;

        ! Start a new page
        call pladv( 0 )

        ! Draw one colorbar relative to each side of the page
        do position_i = 0,COLORBAR_POSITIONS-1
            position = colorbar_position_options(position_i+1);
            opt      = ior( &
                   colorbar_option_kinds(kind_i+1), &
                   ior(colorbar_label_options(label_i+1), &
                   colorbar_cap_options(cap_i+1) ) )

            vertical = (iand(position, PL_POSITION_LEFT) > 0 .or. iand(position, PL_POSITION_RIGHT) > 0 )
            ifn      = (iand(position, PL_POSITION_LEFT) > 0 .or. iand(position, PL_POSITION_BOTTOM) > 0 )

            ! Set the offset position on the page
            if (vertical .eqv. .true.) then
                x        = 0.0_pl_test_flt
                y        = 0.0_pl_test_flt
                x_length = 0.05_pl_test_flt
                y_length = 0.5_pl_test_flt
            else
                x        = 0.0_pl_test_flt
                y        = 0.0_pl_test_flt
                x_length = 0.5_pl_test_flt
                y_length = 0.05_pl_test_flt
            endif

            ! Set appropriate labelling options.
            if (ifn .eqv. .true.) then
                if ( cont_color .eq. 0 .or. cont_width .eq. 0._pl_test_flt ) then
                    axis_opts(1) = "uwtivn"
                else
                    axis_opts(1) = "uwxvn"
                endif
            else
                if ( cont_color .eq. 0 .or. cont_width .eq. 0._pl_test_flt ) then
                    axis_opts(1) = "uwtivm"
                else
                    axis_opts(1) = "uwxvm"
                endif
            endif

            write(labels(1), '(3A)') trim(colorbar_position_option_labels(position_i+1)), &
                   ', ', trim(colorbar_label_option_labels(label_i+1))

            ! Smaller text
            call plschr( 0.0_pl_test_flt, 0.75_pl_test_flt )
            ! Small ticks on the vertical axis
            call plsmaj( 0.0_pl_test_flt, 0.5_pl_test_flt )
            call plsmin( 0.0_pl_test_flt, 0.5_pl_test_flt )

            call plvpor( 0.20_pl_test_flt, 0.80_pl_test_flt, 0.20_pl_test_flt, 0.80_pl_test_flt )
            call plwind( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
            ! Set interesting background colour.
            call plscol0a( 15, 0, 0, 0, 0.20_pl_test_flt )
            call plcolorbar( colorbar_width, colorbar_height, &
                   ior(opt, ior(PL_COLORBAR_BOUNDING_BOX, PL_COLORBAR_BACKGROUND)), position, &
                   x, y, x_length, y_length, &
                   15, 1, 1, &
                   low_cap_color, high_cap_color, &
                   cont_color, cont_width, &
                   label_opts, labels, &
                   axis_opts, ticks, sub_ticks, &
                   n_values_array, values_array )

            ! Reset text and tick sizes
            call plschr( 0.0_pl_test_flt, 1.0_pl_test_flt )
            call plsmaj( 0.0_pl_test_flt, 1.0_pl_test_flt )
            call plsmin( 0.0_pl_test_flt, 1.0_pl_test_flt )
        enddo


        ! Draw a page title
        write(title, '(3A)') trim(colorbar_option_kind_labels(kind_i+1)), ' - ', &
               trim(colorbar_cap_option_labels(cap_i+1))
        call plvpor( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
        call plwind( 0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt )
        call plptex( 0.5_pl_test_flt, 0.5_pl_test_flt, 0.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, title )

        deallocate(values_array)

    end subroutine plcolorbar_example_page

    subroutine plcolorbar_example( palette, kind_i, cont_color, cont_width, n_values, values )
        character(*) :: palette
        integer  :: kind_i, label_i, cap_i, cont_color, n_values
        real(kind=pl_test_flt)   :: cont_width
        real(kind=pl_test_flt), dimension(:)   :: values

        ! Load the color palette
        call plspal1( palette, .true. )

        do label_i = 0,COLORBAR_LABELS-1
            do cap_i = 0,COLORBAR_CAPS-1
                call plcolorbar_example_page( kind_i, label_i, cap_i, &
                       cont_color, cont_width, &
                       n_values, values )
            enddo
        enddo
    end subroutine plcolorbar_example

end program x33f

!      Shade plot demo.
!      Does a variety of shade plots.
!
!      Copyright (C) 2004-2016  Alan W. Irwin
!
!      This file is part of PLplot.
!
!      PLplot is free software; you can redistribute it and/or modify
!      it under the terms of the GNU Library General Public License as
!      published by the Free Software Foundation; either version 2 of the
!      License, or (at your option) any later version.
!
!      PLplot is distributed in the hope that it will be useful,
!      but WITHOUT ANY WARRANTY; without even the implied warranty of
!      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!      GNU Library General Public License for more details.
!
!      You should have received a copy of the GNU Library General Public
!      License along with PLplot; if not, write to the Free Software
!      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x15f
    use plplot
    use plfortrandemolib
    use iso_c_binding, only: c_ptr, c_loc, c_f_pointer
    implicit none

    integer  xdim, ydim, XPTS, YPTS
    !      xdim and ydim are the static dimensions of the 2D arrays while
    !      NX and NY are the defined area.
    parameter( xdim = 99, XPTS = 35, ydim = 100, YPTS = 46 )

    integer i,  j
    integer :: plparseopts_rc
    real(kind=pl_test_flt)  xx, yy
    real(kind=pl_test_flt)  z(xdim, ydim), zmin, zmax, tr(6)

    ! Global parameters to be used in mypltr callback
    real(kind=pl_test_flt), parameter :: xmin = -1.0_pl_test_flt
    real(kind=pl_test_flt), parameter :: xmax =  1.0_pl_test_flt
    real(kind=pl_test_flt), parameter :: ymin = -1.0_pl_test_flt
    real(kind=pl_test_flt), parameter :: ymax =  1.0_pl_test_flt

    ! Use tr callback?
    logical, parameter :: tr_callback = .false.

    ! Use C pltr1 callback? (only meaningful
    ! if tr_callback is .false.).
    logical, parameter :: pltr1_callback = .false.

    ! Use Fortran callback with no data? (only meaningful
    ! if tr_callback and pltr1_callback are .false.).
    logical, parameter :: mypltr_callback = .false.

    type mypltr_data_type
        ! Only contains data required by the mypltr_data callback
        integer :: xpts_data, ypts_data
        real(kind=pl_test_flt) :: xmin_data, xmax_data, ymin_data, ymax_data
    end type mypltr_data_type

    ! Global data type to be used in mypltr_data callback
    type(mypltr_data_type), target :: data

    data%xpts_data = XPTS
    data%ypts_data = YPTS
    data%xmin_data = xmin
    data%xmax_data = xmax
    data%ymin_data = ymin
    data%ymax_data = ymax

    tr = (/ (xmax-xmin)/real(XPTS-1,kind=pl_test_flt), 0.0_pl_test_flt, xmin, &
           0.0_pl_test_flt, (ymax-ymin)/real(YPTS-1,kind=pl_test_flt), ymin /)
    !      Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !      Set up color map 1

          call cmap1_init2()

    !      Initialize plplot

    call plinit()

    !      Set up data array

    do i = 1,XPTS
        xx = real(i-1 - (XPTS / 2),kind=pl_test_flt) / real(XPTS / 2,kind=pl_test_flt)
        do j = 1,YPTS
            yy = real(j-1 - (YPTS / 2),kind=pl_test_flt) / real(YPTS / 2,kind=pl_test_flt) - 1.0_pl_test_flt
            z(i,j) = xx*xx - yy*yy + (xx - yy)/(xx*xx+yy*yy + 0.1_pl_test_flt)
        enddo
    enddo

    call a2mnmx(z, XPTS, YPTS, zmin, zmax, xdim)

    call plot1(z, XPTS, YPTS, zmin, zmax, xdim)
    call plot2(z, XPTS, YPTS, zmin, zmax, xdim)
    call plot3()

    call plend()

contains

    ! Callback function that relies on global XPTS, YPTS, xmin, xmax, ymin, ymax
    subroutine mypltr( x, y, xt, yt )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt

        xt = xmin + ((xmax-xmin)/real(XPTS-1,kind=pl_test_flt))*x
        yt = ymin + ((ymax-ymin)/real(YPTS-1,kind=pl_test_flt))*y

    end subroutine mypltr

    ! Callback function that uses data argument to pass required data.
    subroutine mypltr_data( x, y, xt, yt, data )

        ! These callback arguments must have exactly these attributes.
        real(kind=pl_test_flt), intent(in) ::  x, y
        real(kind=pl_test_flt), intent(out) :: xt, yt
        type(c_ptr), intent(in) :: data

        type(mypltr_data_type), pointer :: d
        call c_f_pointer(data, d)

        xt = d%xmin_data + ((d%xmax_data-d%xmin_data)/real(d%xpts_data-1,kind=pl_test_flt))*x
        yt = d%ymin_data + ((d%ymax_data-d%ymin_data)/real(d%ypts_data-1,kind=pl_test_flt))*y

    end subroutine mypltr_data

    ! -------------------------------------------------------------------------
    !      cmap1_init1
    !
    !      Initializes color map 1 in HLS space.
    ! -------------------------------------------------------------------------

!    subroutine cmap1_init1()
!        use plplot
!        implicit none
!        real(kind=pl_test_flt)   i(4), h(4), l(4), s(4)
!
!        i(1) = 0.0_pl_test_flt    ! left boundary
!        i(2) = 0.45_pl_test_flt   ! just before center
!        i(3) = 0.55_pl_test_flt   ! just after center
!        i(4) = 1.0_pl_test_flt    ! right boundary
!
!        h(1) = 260.0_pl_test_flt  ! hue -- low: blue-violet
!        h(2) = 260.0_pl_test_flt  ! only change as we go over vertex
!        h(3) = 20.0_pl_test_flt   ! hue -- high: red
!        h(4) = 20.0_pl_test_flt   ! keep fixed
!
!
!        l(1) = 0.5_pl_test_flt    ! lightness -- low
!        l(2) = 0.0_pl_test_flt    ! lightness -- center
!        l(3) = 0.0_pl_test_flt    ! lightness -- center
!        l(4) = 0.5_pl_test_flt    ! lightness -- high
!
!        !     call plscolbg(255,255,255)
!        !     l(1) = 0.5_pl_test_flt    ! lightness -- low
!        !     l(2) = 1.0_pl_test_flt    ! lightness -- center
!        !     l(3) = 1.0_pl_test_flt    ! lightness -- center
!        !     l(4) = 0.5_pl_test_flt    ! lightness -- high
!
!        s(1) = 1.0_pl_test_flt    ! maximum saturation
!        s(2) = 1.0_pl_test_flt    ! maximum saturation
!        s(3) = 1.0_pl_test_flt    ! maximum saturation
!        s(4) = 1.0_pl_test_flt    ! maximum saturation
!
!        call plscmap1l(.false., i, h, l, s)
!    end subroutine cmap1_init1

    ! -------------------------------------------------------------------------
    !      cmap1_init2
    !
    !      Initializes color map 1 in HLS space.
    ! -------------------------------------------------------------------------

    subroutine cmap1_init2()
        use plplot
        implicit none
        real(kind=pl_test_flt) i(4), h(4), l(4), s(4)

        i(1) = 0.0_pl_test_flt    ! left boundary
        i(2) = 0.45_pl_test_flt   ! just before center
        i(3) = 0.55_pl_test_flt   ! just after center
        i(4) = 1.0_pl_test_flt    ! right boundary

        h(1) = 260.0_pl_test_flt  ! hue -- low: blue-violet
        h(2) = 260.0_pl_test_flt  ! only change as we go over vertex
        h(3) = 20.0_pl_test_flt   ! hue -- high: red
        h(4) = 20.0_pl_test_flt   ! keep fixed


        l(1) = 0.6_pl_test_flt    ! lightness -- low
        l(2) = 0.0_pl_test_flt    ! lightness -- center
        l(3) = 0.0_pl_test_flt    ! lightness -- center
        l(4) = 0.6_pl_test_flt    ! lightness -- high

        !     call plscolbg(255,255,255)
        !     l(1) = 0.5_pl_test_flt    ! lightness -- low
        !     l(2) = 1.0_pl_test_flt    ! lightness -- center
        !     l(3) = 1.0_pl_test_flt    ! lightness -- center
        !     l(4) = 0.5_pl_test_flt    ! lightness -- high

        s(1) = 1.0_pl_test_flt    ! maximum saturation
        s(2) = 0.5_pl_test_flt    ! maximum saturation
        s(3) = 0.5_pl_test_flt    ! maximum saturation
        s(4) = 1.0_pl_test_flt    ! maximum saturation

        call plscmap1l(.false., i, h, l, s)
    end subroutine cmap1_init2

    ! -------------------------------------------------------------------------
    !      plot1
    !
    !      Illustrates a single shaded region.
    ! -------------------------------------------------------------------------

    subroutine plot1(z, XPTS, YPTS, zmin, zmax, xdim)
        use plplot
        implicit none

        integer xdim, XPTS, YPTS
        real(kind=pl_test_flt)  z(xdim,YPTS), zmin, zmax

        real(kind=pl_test_flt)  shade_min, shade_max, sh_color
        integer sh_cmap
        integer min_color, max_color
        real(kind=pl_test_flt) sh_width, min_width, max_width
        real(kind=pl_test_flt), dimension(:), allocatable :: xg, yg

        sh_cmap   = 0
        min_color = 0
        min_width = 0
        max_color = 0
        max_width = 0

        call pladv(0)
        call plvpor( 0.1_pl_test_flt, 0.9_pl_test_flt,  0.1_pl_test_flt, 0.9_pl_test_flt)
        call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt)

        !      Plot using identity transform

        shade_min = zmin + (zmax-zmin)*0.4_pl_test_flt
        shade_max = zmin + (zmax-zmin)*0.6_pl_test_flt
        sh_color  = 7
        sh_width  = 2
        min_color = 9
        max_color = 2
        min_width = 2
        max_width = 2

        call plpsty(8)

        if(tr_callback) then
            call plshade(z(:XPTS,:YPTS), &
                   -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, 1._pl_test_flt, &
                   shade_min, shade_max, &
                   sh_cmap, sh_color, sh_width, &
                   min_color, min_width, max_color, max_width, .true., tr )
        elseif(pltr1_callback) then
            allocate( xg(XPTS), yg(YPTS) )
            xg = (2.0_pl_test_flt/real(XPTS-1,kind=pl_test_flt))*arange(XPTS) - 1.0_pl_test_flt
            yg = (2.0_pl_test_flt/real(YPTS-1,kind=pl_test_flt))*arange(YPTS) - 1.0_pl_test_flt
            call plshade(z(:XPTS,:YPTS), &
                   -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, 1._pl_test_flt, &
                   shade_min, shade_max, &
                   sh_cmap, sh_color, sh_width, &
                   min_color, min_width, max_color, max_width, .true., xg, yg )
        elseif(mypltr_callback) then
            call plshade(z(:XPTS,:YPTS), &
                   -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, 1._pl_test_flt, &
                   shade_min, shade_max, &
                   sh_cmap, sh_color, sh_width, &
                   min_color, min_width, max_color, max_width, .true., mypltr )
        else
            call plshade(z(:XPTS,:YPTS), &
                   -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, 1._pl_test_flt, &
                   shade_min, shade_max, &
                   sh_cmap, sh_color, sh_width, &
                   min_color, min_width, max_color, max_width, .true., mypltr_data, c_loc(data))
        endif

        call plcol0(1)
        call plbox('bcnst', 0.0_pl_test_flt, 0, 'bcnstv', 0.0_pl_test_flt, 0)
        call plcol0(2)
        call pllab('distance', 'altitude', 'Bogon flux')

    end subroutine plot1

    ! -------------------------------------------------------------------------
    !      plot2
    !
    !      Illustrates multiple adjacent shaded regions, using different fill
    !      patterns for each region.
    ! -------------------------------------------------------------------------

    subroutine plot2(z, XPTS, YPTS, zmin, zmax, xdim)
        use plplot
        implicit none

        integer xdim, XPTS, YPTS
        real(kind=pl_test_flt)  z(xdim,YPTS), zmin, zmax

        real(kind=pl_test_flt)  shade_min, shade_max, sh_color
        integer sh_cmap
        integer min_color, max_color
        real(kind=pl_test_flt) sh_width, min_width, max_width
        integer i, j

        integer nlin(10), inc(2,10), del(2,10)
        data nlin /1, 1, 1, 1, 1, 2, 2, 2, 2, 2/
        data ( (inc(i,j), i=1,2), j=1,10) / &
               450, 0, -450, 0, 0, 0, 900, 0, &
               300, 0, 450,-450, 0, 900, 0, 450, &
               450, -450, 0, 900/
        data ( (del(i,j), i=1,2), j=1,10) / &
               2000, 2000, 2000, 2000, 2000, 2000, &
               2000, 2000, 2000, 2000, 2000, 2000, &
               2000, 2000, 2000, 2000, 4000, 4000, &
               4000, 2000/

        sh_cmap   = 0
        min_color = 0
        min_width = 0
        max_color = 0
        max_width = 0
        sh_width  = 2

        call pladv(0)
        call plvpor( 0.1_pl_test_flt, 0.9_pl_test_flt,  0.1_pl_test_flt, 0.9_pl_test_flt)
        call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt)

        do  i = 1,10
            shade_min = zmin + (zmax - zmin) * (i-1) / 10.0_pl_test_flt
            shade_max = zmin + (zmax - zmin) * i / 10.0_pl_test_flt
            sh_color = i+5
            call plpat( inc(1:nlin(i),i),del(1:nlin(i),i))
            call plshade(z(:XPTS,:YPTS), &
                   -1._pl_test_flt, 1._pl_test_flt, -1._pl_test_flt, 1._pl_test_flt, &
                   shade_min, shade_max, &
                   sh_cmap, sh_color, sh_width, &
                   min_color, min_width, max_color, max_width, .true. )
        enddo

        call plcol0(1)
        call plbox('bcnst', 0.0_pl_test_flt, 0, 'bcnstv', 0.0_pl_test_flt, 0)
        call plcol0(2)
        call pllab('distance', 'altitude', 'Bogon flux')

    end subroutine plot2
    !--------------------------------------------------------------------------
    !     plot3
    !
    !     Illustrates shaded regions in 3d, using a different fill pattern for
    !     each region.
    !--------------------------------------------------------------------------

    subroutine plot3
        use plplot
        implicit none

        real(kind=pl_test_flt) xx1(5), xx2(5), yy1(5), yy2(5), zz1(5), zz2(5)
        data xx1 / -1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, -1.0_pl_test_flt/
        data xx2 / -1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, -1.0_pl_test_flt/
        data yy1 /1.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt/
        data yy2 / -1.0_pl_test_flt, -1.0_pl_test_flt, 0.0_pl_test_flt, 0.0_pl_test_flt, -1.0_pl_test_flt/
        data zz1 / 0.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt/
        data zz2 / 0.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt/

        call pladv(0)
        call plvpor(0.1_pl_test_flt, 0.9_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
        call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt)
        call plw3d(1._pl_test_flt, 1._pl_test_flt, 1._pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, &
               -1.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt,1.5_pl_test_flt, 30._pl_test_flt, -40._pl_test_flt)

        !     Plot using identity transform

        call plcol0(1)
        call plbox3("bntu", "X", 0.0_pl_test_flt, 0, "bntu", "Y", 0.0_pl_test_flt, 0, &
               "bcdfntu", "Z", 0.5_pl_test_flt, 0)
        call plcol0(2)
        call pllab("","","3-d polygon filling")

        call plcol0(3)
        call plpsty(1)
        call plline3(xx1, yy1, zz1)
        call plfill3(xx1(1:4), yy1(1:4), zz1(1:4))
        call plpsty(2)
        call plline3(xx2, yy2, zz2)
        call plfill3(xx2(1:4), yy2(1:4), zz2(1:4))

    end subroutine plot3

    !----------------------------------------------------------------------------
    !      Subroutine a2mnmx
    !      Minimum and the maximum elements of a 2-d array.

    subroutine a2mnmx(f, nx, ny, fmin, fmax, xdim)
        use plplot
        implicit none

        integer   i, j, nx, ny, xdim
        real(kind=pl_test_flt)    f(xdim, ny), fmin, fmax

        fmax = f(1, 1)
        fmin = fmax
        do j = 1, ny
            do  i = 1, nx
                fmax = max(fmax, f(i, j))
                fmin = min(fmin, f(i, j))
            enddo
        enddo
    end subroutine a2mnmx
end program x15f

!  Multi-lingual version of the first page of example 4.
!
!  Copyright (C) 2006-2016 Alan W. Irwin
!  Copyright (C) 2006,2008 Andrew Ross
!
!  Thanks to the following for providing translated strings for this example:
!  Valery Pipin (Russian)
!
!  This file is part of PLplot.
!
!  PLplot is free software; you can redistribute it and/or modify
!  it under the terms of the GNU Library General Public License as published
!  by the Free Software Foundation; either version 2 of the License, or
!  (at your option) any later version.
!
!  PLplot is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Library General Public License for more details.
!
!  You should have received a copy of the GNU Library General Public License
!  along with PLplot; if not, write to the Free Software
!  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!

!
! This example designed just for devices (e.g., psttfc and the
! cairo-related devices) that utilise the pango and fontconfig libraries. The
! best choice of glyph is selected by fontconfig and automatically rendered
! by pango in way that is sensitive to complex text layout (CTL) language
! issues for each unicode character in this example. Of course, you must
! have the appropriate TrueType fonts installed to have access to all the
! required glyphs.
!
! Translation instructions: The strings to be translated are given by
! x_label, y_label, alty_label, title_label, and line_label below.  The
! encoding used must be UTF-8.
!
! The following strings to be translated involve some scientific/mathematical
! jargon which is now discussed further to help translators.
!
! (1) dB is a decibel unit, see http://en.wikipedia.org/wiki/Decibel .
! (2) degrees is an angular measure, see
!     http://en.wikipedia.org/wiki/Degree_(angle) .
! (3) low-pass filter is one that transmits (passes) low frequencies.
! (4) pole is in the mathematical sense, see
!     http://en.wikipedia.org/wiki/Pole_(complex_analysis) .  "Single Pole"
!     means a particular mathematical transformation of the filter function has
!     a single pole, see
!     http://ccrma.stanford.edu/~jos/filters/Pole_Zero_Analysis_I.html .
!     Furthermore, a single-pole filter must have an inverse square decline
!     (or -20 db/decade). Since the filter plotted here does have that
!     characteristic, it must by definition be a single-pole filter, see also
!     http://www-k.ext.ti.com/SRVS/Data/ti/KnowledgeBases/analog/document/faqs/1p.htm
! (5) decade represents a factor of 10, see
!     http://en.wikipedia.org/wiki/Decade_(log_scale) .
!
!
!

! --------------------------------------------------------------------------
!  main
!
!  Illustration of logarithmic axes, and redefinition of window.
! --------------------------------------------------------------------------

program x26f

    use plplot
    implicit none

    integer, parameter :: nolangs = 2
    integer, parameter :: nlegend = 2

    character(len=80) x_label(nolangs)
    character(len=80) y_label(nolangs)
    character(len=80) legend_text(2,nolangs)
    character(len=80) alty_label(nolangs)
    character(len=80) title_label(nolangs)
    character(len=80) line_label(nolangs)

    integer      i, j
    integer :: plparseopts_rc

    data (x_label(i) ,i=1,nolangs) / &
           'Frequency', &
           'Частота'/

    data (y_label(i) ,i=1,nolangs) / &
           'Amplitude (dB)', &
           'Амплитуда (dB)'/

    data (alty_label(i) ,i=1,nolangs) / &
           'Phase shift (degrees)', &
           'Фазовый сдвиг (градусы)'/

    ! Short rearranged versions of y_label and alty_label.
    data ((legend_text(j,i), j=1, nlegend), i=1,nolangs) / &
           'Amplitude',          'Phase shift'              , &
           'Амплитуда', 'Фазовый сдвиг' /

    data (title_label(i) ,i=1,nolangs) / &
           'Single Pole Low-Pass Filter', &
           'Однополюсный Низко-Частотный Фильтр'/

    data (line_label(i) ,i=1,nolangs) / &
           '-20 dB/decade', &
           '-20 dB/десяток'/

    !  Parse and process command line arguments

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !  Initialize plplot

    call plinit()
    call plfont(2)

    !  Make log plots using two different styles.

    do i = 1,nolangs
        call plot1(nlegend, 0, x_label(i), y_label(i), alty_label(i), &
               legend_text(:,i), title_label(i), line_label(i))
    end do
    call plend()

end program x26f

! --------------------------------------------------------------------------
!  plot1
!
!  Log-linear plot.
! --------------------------------------------------------------------------

subroutine plot1( nlegend, type, x_label, y_label, alty_label, &
       legend_text, title_label, line_label )

    use plplot, double_PI => PL_PI
    implicit none

    real(kind=pl_test_flt), parameter :: PI = double_PI
    integer type, nlegend
    character(*) x_label, y_label, alty_label, title_label, line_label

    integer i
    real(kind=pl_test_flt)  freql(101), ampl(101), phase(101)
    real(kind=pl_test_flt)  f0, freq

    character(*) legend_text(nlegend)

    integer          opt_array(nlegend)
    integer          text_colors(nlegend)
    integer          line_colors(nlegend)
    integer          line_styles(nlegend)
    real(kind=pl_test_flt) line_widths(nlegend)
    integer          symbol_numbers(nlegend)
    integer          symbol_colors(nlegend)
    real(kind=pl_test_flt) symbol_scales(nlegend)
    character(len=20) symbols(nlegend)
    integer          box_colors(nlegend), box_patterns(nlegend)
    real(kind=pl_test_flt) box_scales(nlegend), box_line_widths(nlegend)
    real(kind=pl_test_flt) legend_width, legend_height

    call pladv(0)

    !  Set up data for log plot

    f0 = 1.0
    do i = 1,101
        freql(i) = -2.0_pl_test_flt + (i-1) / 20.0_pl_test_flt
        freq     = 10.0_pl_test_flt ** freql(i)
        ampl(i)  = 20.0_pl_test_flt * log10(1.0_pl_test_flt / sqrt(1.0_pl_test_flt + (freq/f0)**2))
        phase(i) = -(180.0_pl_test_flt / PI) * atan(freq / f0)
    end do
    call plvpor(0.15_pl_test_flt, 0.85_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
    call plwind(-2.0_pl_test_flt, 3.0_pl_test_flt, -80.0_pl_test_flt, 0.0_pl_test_flt)

    !  Try different axis and labelling styles.

    call plcol0(1)
    if ( type .eq. 0 ) then
        call plbox("bclnst", 0.0_pl_test_flt, 0, "bnstv", 0.0_pl_test_flt, 0)
    endif
    if ( type .eq. 1 ) then
        call plbox("bcfghlnst", 0.0_pl_test_flt, 0, "bcghnstv", 0.0_pl_test_flt, 0)
    endif

    !  Plot ampl vs freq

    call plcol0(2)
    call plline(freql, ampl)
    call plcol0(2)
    call plptex(1.6_pl_test_flt, -30.0_pl_test_flt, 1.0_pl_test_flt, -20.0_pl_test_flt, 0.5_pl_test_flt, line_label)

    !  Put labels on

    call plcol0(1)
    call plmtex("b", 3.2_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, x_label)
    call plmtex("t", 2.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, title_label)
    call plcol0(2)
    call plmtex("l", 5.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, y_label)

    !  For the gridless case, put phase vs freq on same plot

    if (type .eq. 0) then
        call plcol0(1)
        call plwind(-2.0_pl_test_flt, 3.0_pl_test_flt, -100.0_pl_test_flt, 0.0_pl_test_flt)
        call plbox("", 0.0_pl_test_flt, 0, "cmstv", 30.0_pl_test_flt, 3)
        call plcol0(3)
        call plline(freql, phase)
        call plstring(freql, phase, "#(728)")
        call plcol0(3)
        call plmtex("r", 5.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, alty_label)
    endif

    !  Draw a legend
    !     First legend entry.

    opt_array(1)   = PL_LEGEND_LINE
    text_colors(1) = 2
    line_colors(1) = 2
    line_styles(1) = 1
    line_widths(1) = 1
    !     defining this makes the Fortran to C transformation of
    !     symbols(1) work on defined values which makes valgrind
    !     happier (even if that transformed string is not used inside the
    !     C version of pllegend)
    symbols(1) = ""

    !     note from the above opt_array the first symbol (and box) indices
    !     do not have to be specified

    !     Second legend entry.

    opt_array(2)      = PL_LEGEND_LINE + PL_LEGEND_SYMBOL
    text_colors(2)    = 3
    line_colors(2)    = 3
    line_styles(2)    = 1
    line_widths(2)    = 1
    symbol_colors(2)  = 3
    symbol_scales(2)  = 1.
    symbol_numbers(2) = 4
    symbols(2)        = "#(728)"

    !     from the above opt_arrays we can completely ignore everything
    !     to do with boxes.
    !     (note: number of legend entries determined from size of
    !     opt_array)

    call plscol0a( 15, 32, 32, 32, 0.70_pl_test_flt )
    call pllegend( legend_width, legend_height, &
           PL_LEGEND_BACKGROUND + PL_LEGEND_BOUNDING_BOX, 0, &
           0.0_pl_test_flt, 0.0_pl_test_flt, 0.10_pl_test_flt, 15, &
           1, 1, 0, 0, &
           opt_array, &
           1.0_pl_test_flt, 1.0_pl_test_flt, 2.0_pl_test_flt, &
           1.0_pl_test_flt, text_colors, legend_text, &
           box_colors, box_patterns, box_scales, box_line_widths, &
           line_colors, line_styles, line_widths, &
           symbol_colors, symbol_scales, symbol_numbers, symbols )

end subroutine plot1

!   Demonstration program for PLplot: Bar chart example.
!
!   Copyright (C) 2004-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x12f
    use plplot
    implicit none

    character(len=20) :: string
    integer :: i
    integer :: plparseopts_rc
    real(kind=pl_test_flt) :: y0(10)
    real(kind=pl_test_flt) :: pos(5)   = (/0.0_pl_test_flt, 0.25_pl_test_flt, 0.5_pl_test_flt, 0.75_pl_test_flt, 1.0_pl_test_flt/)
    real(kind=pl_test_flt) :: red(5)   = (/0.0_pl_test_flt, 0.25_pl_test_flt, 0.5_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt/)
    real(kind=pl_test_flt) :: green(5) = (/1.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, 1.0_pl_test_flt/)
    real(kind=pl_test_flt) :: blue(5)  = (/1.0_pl_test_flt, 1.0_pl_test_flt, 0.5_pl_test_flt, 0.25_pl_test_flt, 0.0_pl_test_flt/)

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plinit()

    call pladv(0)
    call plvsta
    call plwind( 1980._pl_test_flt, 1990._pl_test_flt, 0._pl_test_flt, 35._pl_test_flt )
    call plbox( 'bc', 1._pl_test_flt, 0, 'bcnv', 10._pl_test_flt, 0 )
    call plcol0(2)
    call pllab( 'Year', 'Widget Sales (millions)', '#frPLplot Example 12' )

    y0 = (/ 5, 15, 12, 24, 28, 30, 20, 8, 12, 3 /)

    call plscmap1l(.true.,pos,red,green,blue)

    do i = 0, 9
        !       call plcol0(i + 1)
        call plcol1(real(i,kind=pl_test_flt)/9.0_pl_test_flt)
        call plpsty(0)
        call plfbox( 1980._pl_test_flt+i, y0(i+1) )
        write (string, '(i0)') int(y0(i+1))
        call plptex( 1980._pl_test_flt+i+0.5_pl_test_flt, y0(i+1)+1._pl_test_flt, &
               1._pl_test_flt, 0._pl_test_flt, 0.5_pl_test_flt, string )
        write (string, '(i0)')1980+i
        call plmtex( 'b', 1._pl_test_flt, (i+1)*0.1_pl_test_flt-0.05_pl_test_flt, 0.5_pl_test_flt, string )
    enddo

    !    Don't forget to call PLEND to finish off!
    call plend
contains

    subroutine plfbox(x0, y0)
        real(kind=pl_test_flt) x0, y0, x(4), y(4)

        x(1) = x0
        y(1) = 0._pl_test_flt
        x(2) = x0
        y(2) = y0
        x(3) = x0+1._pl_test_flt
        y(3) = y0
        x(4) = x0+1._pl_test_flt
        y(4) = 0._pl_test_flt
        call plfill(x, y)
        call plcol0(1)
        call pllsty(1)
        call plline(x, y)
    end subroutine plfbox
end program x12f

!   Displays the plotter symbols for PLSYM
!
!   Copyright (C) 2004-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
program x07f
    use plplot
    implicit none

    character (len=4) :: text

    integer :: i, j, k, l
    integer, dimension(20) :: base = &
           (/    0,  100,    0,  100,  200,  &
           500,  600,  700,  800,  900, &
           2000, 2100, 2200, 2300, 2400, &
           2500, 2600, 2700, 2800, 2900  /)

    integer :: plparseopts_rc
    real(kind=pl_test_flt), dimension(1:1) ::  x, y

    !   Process command-line arguments

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !   Full sized page for display

    call plinit()
    call plfontld(0)
    do l=1,20
        if (l==3) call plfontld(1)

        call pladv(0)

        call plcol0(2)

        ! Set up viewport and window

        call plvpor(0.15_pl_test_flt, 0.95_pl_test_flt, 0.1_pl_test_flt, 0.9_pl_test_flt)
        call plwind(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)

        ! Draw the grid using plbox

        call plbox('bcg', 0.1_pl_test_flt, 0,'bcg', 0.1_pl_test_flt, 0)
        call plcol0(15)

        ! Write the digits below the frame

        do i=0,9
            write (text,'(i1)') i
            call plmtex('b', 1.5_pl_test_flt, (0.1_pl_test_flt*i+0.05_pl_test_flt), &
                   0.5_pl_test_flt, text)
        enddo

        k=0
        do i=0,9

            ! Write the digits to the left of the frame

            write (text,'(i0)') base(l)+10*i

            call plmtex('lv', 1.0_pl_test_flt, (0.95_pl_test_flt-0.1_pl_test_flt*i), &
                   1.0_pl_test_flt, text)
            do j=0,9
                x=0.1_pl_test_flt*j+0.05_pl_test_flt
                y=0.95_pl_test_flt-0.1_pl_test_flt*i

                ! Display the symbols

                call plsym(x,y,base(l)+k)
                k=k+1
            enddo
        enddo

        if (l<=2) then
            call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                   'PLplot Example 7 - PLSYM symbols (compact)')
        else
            call plmtex('t', 1.5_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, &
                   'PLplot Example 7 - PLSYM symbols (extended)')
        endif
    enddo

    call plend
end program x07f

!   Unicode Pace Flag
!
!   Copyright (C) 2005 Rafael Laboissiere
!   Copyright (C) 2008 Andrew Ross
!   Copyright (C) 2008-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as published
!   by the Free Software Foundation; either version 2 of the License, or
!   (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public License
!   along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!
!   In Debian, run like this:
!
!   ( TTFDIR=/usr/share/fonts/truetype ; \
!     PLPLOT_FREETYPE_SANS_FONT=$TTFDIR/arphic/bkai00mp.ttf \
!     PLPLOT_FREETYPE_SERIF_FONT=$TTFDIR/freefont/FreeSerif.ttf \
!     PLPLOT_FREETYPE_MONO_FONT=$TTFDIR/ttf-devanagari-fonts/lohit_hi.ttf \
!     PLPLOT_FREETYPE_SCRIPT_FONT=$TTFDIR/unfonts/UnBatang.ttf \
!     PLPLOT_FREETYPE_SYMBOL_FONT=$TTFDIR/ttf-bengali-fonts/JamrulNormal.ttf \
!     ./x24f -dev png -o x24f.png )
!
!   Packages needed:
!
!   ttf-arphic-bkai00mp
!   ttf-freefont
!   ttf-devanagari-fonts
!   ttf-unfonts
!   ttf-bengali-fonts
!
!   For the latest Ubuntu systems lohit_hi.ttf has been moved to the
!   ttf-indic-fonts-core package instead of ttf-devanagari-fonts so you
!   will have to use this package instead and update the font path.


program x24f
    use plplot
    implicit none

    integer i, j
    integer red(7)
    integer green(7)
    integer blue(7)
    integer :: plparseopts_rc

    real(kind=pl_test_flt)  px(4)
    real(kind=pl_test_flt)  py(4)
    real(kind=pl_test_flt)  sx(12)
    real(kind=pl_test_flt)  sy(12)

    character(len=30) peace(12)

    data (red(i) ,i=1,7)   / 240, 204, 204, 204,   0,  39, 125 /
    data (green(i) ,i=1,7) / 240,   0, 125, 204, 204,  80,   0 /
    data (blue(i) ,i=1,7)  / 240,   0,   0,   0,   0, 204, 125 /

    data (px(i) ,i=1,4) / 0.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt /
    data (py(i) ,i=1,4) / 0.0_pl_test_flt, 0.25_pl_test_flt, 0.25_pl_test_flt, 0.0_pl_test_flt /

    data (sx(i) ,i=1,12) / &
           0.16374_pl_test_flt, &
           0.15844_pl_test_flt, &
           0.15255_pl_test_flt, &
           0.17332_pl_test_flt, &
           0.50436_pl_test_flt, &
           0.51721_pl_test_flt, &
           0.49520_pl_test_flt, &
           0.48713_pl_test_flt, &
           0.83976_pl_test_flt, &
           0.81688_pl_test_flt, &
           0.82231_pl_test_flt, &
           0.82647_pl_test_flt/


    data (sy(i) ,i=1,12) / &
           0.125_pl_test_flt, &
           0.375_pl_test_flt, &
           0.625_pl_test_flt, &
           0.875_pl_test_flt, &
           0.125_pl_test_flt, &
           0.375_pl_test_flt, &
           0.625_pl_test_flt, &
           0.875_pl_test_flt, &
           0.125_pl_test_flt, &
           0.375_pl_test_flt, &
           0.625_pl_test_flt, &
           0.875_pl_test_flt/


    !  Taken from http://www.columbia.edu/~fdc/pace/

    !  Mandarin
    peace(1) = '#<0x00>和平'

    !  Hindi
    peace(2) = '#<0x20>शांति'

    !  English
    peace(3) = '#<0x10>Peace'

    !  Hebrew
    peace(4) = '#<0x10>שלום'

    !  Russian
    peace(5) = '#<0x10>Мир'

    !  German
    peace(6) = '#<0x10>Friede'

    !  Korean
    peace(7) = '#<0x30>평화'

    !  French
    peace(8) = '#<0x10>Paix'

    !  Spanish
    peace(9) = '#<0x10>Paz'

    !  Arabic
    peace(10) = '#<0x10>ﺳﻼم'

    !  Turkish
    peace(11) = '#<0x10>Barış'

    !  Kurdish
    peace(12) = '#<0x10>Hasîtî'

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    call plinit()

    call pladv(0)
    call plvpor (0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)
    call plwind (0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 1.0_pl_test_flt)
    call plcol0 (0)
    call plbox ('', 1.0_pl_test_flt, 0, '', 1.0_pl_test_flt, 0)

    call plscmap0n (7)
    call plscmap0 (red, green, blue)

    call plschr (0.0_pl_test_flt, 4.0_pl_test_flt)
    call plfont (1)

    do i = 1,4

        call plcol0 (i)
        call plfill (px, py)

        do j = 1,4
            py (j) = py (j) + 1.0_pl_test_flt / 4.0_pl_test_flt
        enddo
    enddo

    call plcol0 (0)
    do i = 1,12
        call plptex (sx (i), sy (i), 1.0_pl_test_flt, 0.0_pl_test_flt, 0.5_pl_test_flt, peace (i))
    enddo

    call plend()

end program x24f

!   Filling and clipping polygons.
!
!   Copyright (C) 2005 Arjen Markus
!   Copyright (C) 2008 Andrew Ross
!   Copyright (C) 2008-2016 Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as published
!   by the Free Software Foundation; either version 2 of the License, or
!   (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public License
!   along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
!
!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!
! --------------------------------------------------------------------------
! main
!
! Test program for filling polygons and proper clipping
! --------------------------------------------------------------------------

program x25f

    use plplot
    implicit none

    integer          :: i, j, k
    integer          :: npts
    integer :: plparseopts_rc
    real(kind=pl_test_flt) :: xextreme(2,10)
    real(kind=pl_test_flt) :: yextreme(2,10)
    real(kind=pl_test_flt) :: x0(10)
    real(kind=pl_test_flt) :: y0(10)

    data ( xextreme(1,i), xextreme(2,i), yextreme(1,i), yextreme(2,i), i=1,9) / &
           -120.0_pl_test_flt,      120.0_pl_test_flt,     -120.0_pl_test_flt,      120.0_pl_test_flt, &
           -120.0_pl_test_flt,      120.0_pl_test_flt,       20.0_pl_test_flt,      120.0_pl_test_flt, &
           -120.0_pl_test_flt,      120.0_pl_test_flt,      -20.0_pl_test_flt,      120.0_pl_test_flt, &
           -80.0_pl_test_flt,       80.0_pl_test_flt,      -20.0_pl_test_flt,      120.0_pl_test_flt, &
           -220.0_pl_test_flt,     -120.0_pl_test_flt,     -120.0_pl_test_flt,      120.0_pl_test_flt, &
           -20.0_pl_test_flt,       20.0_pl_test_flt,     -120.0_pl_test_flt,      120.0_pl_test_flt, &
           -20.0_pl_test_flt,       20.0_pl_test_flt,      -20.0_pl_test_flt,       20.0_pl_test_flt, &
           -80.0_pl_test_flt,       80.0_pl_test_flt,      -80.0_pl_test_flt,       80.0_pl_test_flt, &
           20.0_pl_test_flt,      120.0_pl_test_flt,     -120.0_pl_test_flt,      120.0_pl_test_flt/

    npts = 0

    !  Parse and process command line arguments

    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !  Initialize plplot

    call plssub(3,3)
    call plinit()

    do k = 1,2
        do j = 1,4

            select case ( j )
            case ( 1 ) !  Polygon 1: a diamond
                x0(1) =    0.0_pl_test_flt
                y0(1) = -100.0_pl_test_flt
                x0(2) = -100.0_pl_test_flt
                y0(2) =    0.0_pl_test_flt
                x0(3) =    0.0_pl_test_flt
                y0(3) =  100.0_pl_test_flt
                x0(4) =  100.0_pl_test_flt
                y0(4) =    0.0_pl_test_flt
                npts = 4

            case( 2 )
                !  Polygon 1: a diamond - reverse direction
                x0(4) =    0.0_pl_test_flt
                y0(4) = -100.0_pl_test_flt
                x0(3) = -100.0_pl_test_flt
                y0(3) =    0.0_pl_test_flt
                x0(2) =    0.0_pl_test_flt
                y0(2) =  100.0_pl_test_flt
                x0(1) =  100.0_pl_test_flt
                y0(1) =    0.0_pl_test_flt
                npts = 4

            case( 3 )
                !  Polygon 2: a square with punctures
                x0(1)  = -100.0_pl_test_flt
                y0(1)  = -100.0_pl_test_flt
                x0(2)  = -100.0_pl_test_flt
                y0(2)  =  -80.0_pl_test_flt
                x0(3)  =   80.0_pl_test_flt
                y0(3)  =    0.0_pl_test_flt
                x0(4)  = -100.0_pl_test_flt
                y0(4)  =   80.0_pl_test_flt
                x0(5)  = -100.0_pl_test_flt
                y0(5)  =  100.0_pl_test_flt
                x0(6)  =  -80.0_pl_test_flt
                y0(6)  =  100.0_pl_test_flt
                x0(7)  =    0.0_pl_test_flt
                y0(7)  =   80.0_pl_test_flt
                x0(8)  =   80.0_pl_test_flt
                y0(8)  =  100.0_pl_test_flt
                x0(9)  =  100.0_pl_test_flt
                y0(9)  =  100.0_pl_test_flt
                x0(10) =  100.0_pl_test_flt
                y0(10) = -100.0_pl_test_flt
                npts = 10

            case( 4 )
                !  Polygon 2: a square with punctures - reversed direction
                x0(10) = -100.0_pl_test_flt
                y0(10) = -100.0_pl_test_flt
                x0(9)  = -100.0_pl_test_flt
                y0(9)  =  -80.0_pl_test_flt
                x0(8)  =   80.0_pl_test_flt
                y0(8)  =    0.0_pl_test_flt
                x0(7)  = -100.0_pl_test_flt
                y0(7)  =   80.0_pl_test_flt
                x0(6)  = -100.0_pl_test_flt
                y0(6)  =  100.0_pl_test_flt
                x0(5)  =  -80.0_pl_test_flt
                y0(5)  =  100.0_pl_test_flt
                x0(4)  =    0.0_pl_test_flt
                y0(4)  =   80.0_pl_test_flt
                x0(3)  =   80.0_pl_test_flt
                y0(3)  =  100.0_pl_test_flt
                x0(2)  =  100.0_pl_test_flt
                y0(2)  =  100.0_pl_test_flt
                x0(1)  =  100.0_pl_test_flt
                y0(1)  = -100.0_pl_test_flt
                npts = 10
            end select

            do i = 1,9
                call pladv(0)
                call plvsta()
                call plwind(xextreme(1,i), xextreme(2,i), yextreme(1,i), yextreme(2,i))

                call plcol0(2)
                call plbox('bc', 1.0_pl_test_flt, 0, 'bcnv', 10.0_pl_test_flt, 0)
                call plcol0(1)
                call plpsty(0)
                if(k.eq.1) then
                    call plfill(x0(1:npts),y0(1:npts))
                else
                    call plgradient(x0(1:npts),y0(1:npts),45._pl_test_flt)
                endif
                call plcol0(2)
                call pllsty(1)
                call plline(x0(1:npts),y0(1:npts))
            end do
        end do
    end do

    !  Don't forget to call plend() to finish off!
    call plend

end program x25f

!   Copyright (C) 2004-2016  Alan W. Irwin
!
!   This file is part of PLplot.
!
!   PLplot is free software; you can redistribute it and/or modify
!   it under the terms of the GNU Library General Public License as
!   published by the Free Software Foundation; either version 2 of the
!   License, or (at your option) any later version.
!
!   PLplot is distributed in the hope that it will be useful,
!   but WITHOUT ANY WARRANTY; without even the implied warranty of
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!   GNU Library General Public License for more details.
!
!   You should have received a copy of the GNU Library General Public
!   License along with PLplot; if not, write to the Free Software
!   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

!     N.B. the pl_test_flt parameter used in this code is only
!     provided by the plplot module to allow convenient developer
!     testing of either kind(1.0) or kind(1.0d0) floating-point
!     precision regardless of the floating-point precision of the
!     PLplot C libraries.  We do not guarantee the value of this test
!     parameter so it should not be used by users, and instead user
!     code should replace the pl_test_flt parameter by whatever
!     kind(1.0) or kind(1.0d0) precision is most convenient for them.
!     For further details on floating-point precision issues please
!     consult README_precision in this directory.
!
!--------------------------------------------------------------------------
!   main
!
!   Does a series of 3-d plots for a given data set, with different
!   viewing options in each plot.
!--------------------------------------------------------------------------

program x18f
    use plplot, double_PI => PL_PI, double_TWOPI => PL_TWOPI
    implicit none
    real(kind=pl_test_flt), parameter :: PI = double_PI
    real(kind=pl_test_flt), parameter :: TWOPI = double_TWOPI

    integer, parameter :: NPTS = 1000

    integer            :: i, k
    real(kind=pl_test_flt), dimension(NPTS) :: x, y, z, r
    character(len=80)  :: title

    integer            :: opt(4) = (/    1,          0,          1,          0       /)
    real(kind=pl_test_flt)   :: alt(4) = (/ 20.0_pl_test_flt, 35.0_pl_test_flt, 50.0_pl_test_flt, 65.0_pl_test_flt /)
    real(kind=pl_test_flt)   :: az(4)  = (/ 30.0_pl_test_flt, 40.0_pl_test_flt, 50.0_pl_test_flt, 60.0_pl_test_flt /)

    integer, dimension(NPTS) :: ia = (/(i,i=1,NPTS)/)
    integer :: plparseopts_rc

    !   Process command-line arguments
    plparseopts_rc = plparseopts(PL_PARSE_FULL)
    if(plparseopts_rc .ne. 0) stop "plparseopts error"

    !   Initialize plplot

    call plinit()

    do k = 1, 4
        call test_poly(k, alt(k), az(k))
    enddo

    !   From the mind of a sick and twisted physicist...

    z = -1._pl_test_flt + 2._pl_test_flt * real(ia-1,kind=pl_test_flt) / real(NPTS,kind=pl_test_flt)

    !   Pick one ...

    !   r = 1. - real(ia-1,kind=pl_test_flt) / real(NPTS,kind=pl_test_flt)
    r = z

    x = r * cos( 2._pl_test_flt * PI * 6._pl_test_flt * real(ia-1,kind=pl_test_flt) / real(NPTS,kind=pl_test_flt) )
    y = r * sin( 2._pl_test_flt * PI * 6._pl_test_flt * real(ia-1,kind=pl_test_flt) / real(NPTS,kind=pl_test_flt) )

    do k = 1, 4
        call pladv(0)
        call plvpor(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 0.9_pl_test_flt)
        call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -0.9_pl_test_flt, 1.1_pl_test_flt)
        call plcol0(1)
        call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, &
               -1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt,  &
               1.0_pl_test_flt, -1.0_pl_test_flt, 1.0_pl_test_flt, &
               alt(k), az(k))
        call plbox3('bnstu', 'x axis', 0.0_pl_test_flt, 0, &
               'bnstu', 'y axis', 0.0_pl_test_flt, 0, &
               'bcdmnstuv', 'z axis', 0.0_pl_test_flt, 0)

        call plcol0(2)

        if ( opt(k).gt. 0 ) then
            call plline3(x, y, z)
        else
            !U+22C5 DOT OPERATOR.
            call plstring3( x, y, z, "⋅" )
        endif

        call plcol0(3)
        write( title, '(a,i2,a,i2)') '#frPLplot Example 18 - Alt=', nint(alt(k)), ', Az=', nint(az(k))
        call plmtex('t', 1.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, title)
    enddo

    call plend()
contains

    subroutine test_poly(k, alt, az)
        integer          :: k
        real(kind=pl_test_flt) :: alt, az

        real(kind=pl_test_flt) :: x(5), y(5), z(5)
        integer          :: i, j
        logical          :: draw(4,4) = &
               reshape( &
               (/  .true., .true., .true., .true., &
               .true., .false., .true., .false., &
               .false., .true., .false., .true., &
               .true., .true., .false., .false. /), (/4,4/) )
        integer, dimension(0:20)          :: ia = (/(j,j=0,20)/)
        real(kind=pl_test_flt), dimension(0:20) :: theta, phi

        theta = TWOPI * ia /20._pl_test_flt
        phi   = PI * ia / 20.1_pl_test_flt

        call pladv(0)
        call plvpor(0.0_pl_test_flt, 1.0_pl_test_flt, 0.0_pl_test_flt, 0.9_pl_test_flt)
        call plwind(-1.0_pl_test_flt, 1.0_pl_test_flt, -0.9_pl_test_flt, 1.1_pl_test_flt)
        call plcol0(1)
        call plw3d(1.0_pl_test_flt, 1.0_pl_test_flt, 1.0_pl_test_flt, &
               -1.0_pl_test_flt, 1.0_pl_test_flt, -1.0_pl_test_flt, &
               1.0_pl_test_flt,  -1.0_pl_test_flt, 1.0_pl_test_flt, &
               alt, az)
        call plbox3('bnstu', 'x axis', 0.0_pl_test_flt, 0, &
               'bnstu', 'y axis', 0.0_pl_test_flt, 0, &
               'bcdmnstuv', 'z axis', 0.0_pl_test_flt, 0)

        call plcol0(2)


        !    x = r sin(phi) cos(theta)
        !    y = r sin(phi) sin(theta)
        !    z = r cos(phi)
        !    r = 1 :=)

        do i=0,19
            do j=0,19
                x(1) = sin( phi(j) ) * cos( theta(i) )
                y(1) = sin( phi(j) ) * sin( theta(i) )
                z(1) = cos( phi(j) )

                x(2) = sin( phi(j+1) ) * cos( theta(i) )
                y(2) = sin( phi(j+1) ) * sin( theta(i) )
                z(2) = cos( phi(j+1) )

                x(3) = sin( phi(j+1) ) * cos( theta(i+1) )
                y(3) = sin( phi(j+1) ) * sin( theta(i+1) )
                z(3) = cos( phi(j+1) )

                x(4) = sin( phi(j) ) * cos( theta(i+1) )
                y(4) = sin( phi(j) ) * sin( theta(i+1) )
                z(4) = cos( phi(j) )

                x(5) = sin( phi(j) ) * cos( theta(i) )
                y(5) = sin( phi(j) ) * sin( theta(i) )
                z(5) = cos( phi(j) )

                call plpoly3(x, y, z, draw(:,k), .true.)
            enddo
        enddo

        call plcol0(3)
        call plmtex('t', 1.0_pl_test_flt, 0.5_pl_test_flt, 0.5_pl_test_flt, 'unit radius sphere' )
    end subroutine test_poly
end program x18f
